package com.adc.da.system.service;

import com.adc.da.dto.resDTO.DownCheckFalseDTO;
import com.adc.da.system.entity.CheckDataCheckResult;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author jobob
 * @since 2019-10-17
 */
public interface ICheckDataCheckResultService extends IService<CheckDataCheckResult> {
    /**
     * 删除
     * @param id
     * @param type
     */
    void delByMainIdAndType(String id, String type);

    /**
     * 根据证书核查ID和证书类型查询核查结果
     * @param id 证书核查ID
     * @param type 证书类型
     * @return
     */
    List<CheckDataCheckResult> selectByIdAndType(String id, String type);


    /**
     *
     * @param id
     * @return
     */
    List<String> selectCheckOkDetail(String id);

    /**
     *
     * @param response
     * @param request
     * @param id
     * @param type
     */
    void exportCheckResult(HttpServletResponse response, HttpServletRequest request, String id, String type);

    /**
     *
     * @param page
     * @param limit
     * @param address
     * @param carGroup
     * @param editionCode
     * @param paramName
     * @return
     */
    IPage getListInfo(int page, int limit, String address, String carTypeCode, String result, String carGroup, String editionCode, String paramName);

    /**
     *
     * @param id
     * @return
     */
    Boolean updateCheckFalse(String id);

    List<DownCheckFalseDTO> downCheckFalse(String address, String project, String isHandel , String carGroup, String editionCode, String paramName);

    boolean updateResultById(String id, String result);
}
