package com.adc.da.system.service;


import com.adc.da.dto.resDTO.CheckEnterpriseDTO;
import com.adc.da.system.entity.CheckEnterpriseData;
import com.adc.da.system.entity.VehicleList;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;

public interface ICheckEnterpriseDataService extends IService<CheckEnterpriseData> {

    /**
     * 企业数据分页查询
     * @param page
     * @param checkEnterpriseData
     * @return
     */
    IPage<CheckEnterpriseData> queryCheckEnterpriseDataByPage(Page page, CheckEnterpriseData checkEnterpriseData);

    /**
     * 车型列表分页查询
     * @param page
     * @param vehicleList
     * @return
     */
    IPage<VehicleList> queryVehicleListByPage(Page page, VehicleList vehicleList);

    /**
     * 企业数据导入
     * @return
     */
    Map<String, Object> importCheckEnterpriseData(MultipartFile file, String founder);

    String getCCAPDataByCode(String certificateCode);

    IPage<CheckEnterpriseData>queryInfoByCheckstatus(@Param("page")Page page);

    IPage<CheckEnterpriseData> queryEnterpriseDataPage(Page page,CheckEnterpriseData checkEnterpriseData);

    List<CheckEnterpriseDTO> queryEnterpriseData(String vehicleType, String entryName, String checkStatus, String auditNumber, String versionNumber);

//    Integer updateEnterpriseData (CheckEnterpriseData checkEnterpriseData);

}
