package com.adc.da.system.service;


import com.adc.da.system.entity.CheckModelSeriesList;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;


import java.util.List;
import java.util.Map;

/**
 * service
 */
public interface ICheckModelSeriesListService extends IService<CheckModelSeriesList> {

    /**
     * 车型系列表分页查询
     * @param page
     * @param checkModelSeriesList
     * @return
     */
    IPage<CheckModelSeriesList> queryCheckModelSeriesListByPage(Page page, CheckModelSeriesList checkModelSeriesList);

    /**
     * 车型系列结果分页查询
     * @param page
     * @param checkModelSeriesList
     * @return
     */
    IPage<CheckModelSeriesList> querySuccessCheckModelSeriesList(Page page, CheckModelSeriesList checkModelSeriesList);

    IPage<CheckModelSeriesList> queryReviewCheckModelSeriesList(Page page, CheckModelSeriesList checkModelSeriesList);

    /**
     * 车型系列表查询(不分页)
     * @param checkModelSeriesList
     * @return
     */
    List<CheckModelSeriesList> queryCheckModelSeriesList(CheckModelSeriesList checkModelSeriesList);

    /**
     * 车型系列表查询(不分页)
     * @param checkModelSeriesList
     * @return
     */
    List<CheckModelSeriesList> queryCheckModelSeriesListFh(CheckModelSeriesList checkModelSeriesList);

    /**
     * 车型系列表分页查询（复核）
     * @param page
     * @param checkModelSeriesList
     * @return
     */
    IPage<CheckModelSeriesList> queryCheckModelSeriesListByPageFh(Page page, CheckModelSeriesList checkModelSeriesList);

    /**
     * 车型系列表结果分页查询
     * @param page
     * @param checkModelSeriesList
     * @return
     */
    IPage<CheckModelSeriesList> queryCheckedModelSeriesListByPage(Page page, CheckModelSeriesList checkModelSeriesList);

    /**
     * 新增车型系列表数据
     * @param checkModelSeriesList
     * @return
     */
    Boolean addCheckModelSeriesList(CheckModelSeriesList checkModelSeriesList);

    /**
     * 首页统计
     * @param checkModelSeriesList
     * @return
     */
    Map<String, Integer> stat(CheckModelSeriesList checkModelSeriesList);

    void checkOk(String ids);
}
