package com.adc.da.system.service;

import com.adc.da.system.entity.CheckObd;
import com.adc.da.system.entity.TsOrg;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * <p>
 * OBD参数审核表 服务类
 * </p>
 *
 * @author jobob
 * @since 2021-03-30
 */
public interface ICheckObdService extends IService<CheckObd> {

    /**
     *
     * @param page 页
     * @param limit 长度
     * @param obdName 模板名称
     * @param operator 创建人
     * @param base 事业部
     * @param sort 排序字段
     * @param isAsc 是否正序
     * @param userBase
     * @return 查询结果
     */
    IPage queryCheckObd(Integer page, Integer limit, String obdName, String operator, String base, String sort,
                        String isAsc, String type, String userBase,String startTime,String endTime);

    /**
     * 查询关联案件id
     * @param id 模板id
     * @return
     */
    String selectDetailObd(String id);

    /**
     * 查询所有事业部
     * @return
     */
    List<TsOrg> selectOrg();

    /**
     * 添加
     * @return
     */
    Integer insertObd(CheckObd checkObd);

    /**
     * 修改
     * @param checkObd obd实体类
     * @return 修改结果
     */
    Integer updateObd(CheckObd checkObd);

    /**
     * 删除
     * @param id 模板id
     * @return
     */
    Integer deleteObd(String id);

    List<CheckObd> selectMouldByBase(String baseId, String mouldType, String standType);

    int selectCountByBaseAndName(String baseId, String mouldType, String mouldName, String id);
}
