package com.adc.da.system.service;

import com.adc.da.dto.reqDTO.CertificationDTO;
import com.adc.da.dto.reqDTO.CheckRealVehicleVerificationDto;
import com.adc.da.dto.reqDTO.RVVObdDTO;
import com.adc.da.dto.reqDTO.RegulationsDTO;
import com.adc.da.dto.reqDTO.ScanCodeDTO;
import com.adc.da.dto.resDTO.CheckRealVehicleVerificationDTO;
import com.adc.da.system.entity.CheckModelSeriesList;
import com.adc.da.system.entity.CheckRealVehicleVerAndMoedelSeriesList;
import com.adc.da.system.entity.CheckRealVehicleVerification;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

public interface ICheckRealVehicleVerificationService extends IService<CheckRealVehicleVerification> {

    /**
     * 保存实车核查列表
     * @param checkRealVehicleVerificationDto
     * @return
     */
    Boolean saveInfo(CheckRealVehicleVerificationDto checkRealVehicleVerificationDto);

    /**
     * 保存核查结果
     * @param checkRealVehicleVerificationDto
     * @return
     */
    Boolean saveById(CheckRealVehicleVerificationDto checkRealVehicleVerificationDto);

//    boolean saveCheckDetail(CheckModelSeriesList checkModelSeriesList, String detailType);

    /**
     * 导入备案故障码模板
     * @param file
     * @param vehicleSeriesId
     * @return
     */
    String importCheckRealVVData(MultipartFile file, String vehicleSeriesId);

    /**
     * 根据车系ID查询CheckRealVehicleVerificationDTO
     * @param vehicleSeriesId
     * @return
     */
    List<CheckRealVehicleVerificationDTO> selectByVehicleSeriesId(String vehicleSeriesId);

    boolean editScanCode(String id, String value, String column, String vehicleSeriesId, String userId,String detailType);

    IPage<CheckRealVehicleVerAndMoedelSeriesList> queryRealVehicleVer(@Param("Page") Page page, @Param("type")String type, @Param("handleType")String handleType, @Param("checkType")String checkType, @Param("vehicleSeries")String vehicleSeries);

    List<CheckRealVehicleVerification> queryCheckRealVehicleVer(String vehicleSeriesId, String checkType);

    Integer updateCheckRealVehicleVer(CheckRealVehicleVerification checkRealVehicleVer);

    IPage<CheckRealVehicleVerification> getCheckRealVehicleVerPage(CheckRealVehicleVerification checkRealVehicleVer) throws Exception;

    List<RVVObdDTO> getCheckRealVehicleVer(List<String> ids, String checkType, String handleType, String parameterName);
    List<ScanCodeDTO> getCheckRealVehicleVer1(List<String> ids, String checkType, String handleType, String parameterName);
    List<RegulationsDTO> getCheckRealVehicleVer2(List<String> ids, String checkType, String handleType, String parameterName, String project);
    List<CertificationDTO> getCheckRealVehicleVer3(List<String> ids, String checkType, String handleType, String parameterName);

    Integer updateCheckModelSeries(CheckRealVehicleVerificationDto checkRealVehicleVerificationDto);

    List<CheckRealVehicleVerification> getLastCheckRealVehicleVer(CheckModelSeriesList checkModelSeriesList);

}
