package com.adc.da.system.service.impl;


import com.adc.da.dto.reqDTO.CheckMenuManagementReqDTO;
import com.adc.da.system.dao.CheckCheckMenuManagementMapper;
import com.adc.da.system.entity.CheckCheckMenuManagement;
import com.adc.da.system.entity.CheckObd;
import com.adc.da.system.service.ICheckCheckMenuManagementService;
import com.adc.da.system.service.ICheckDetailObdService;
import com.adc.da.system.service.ICheckObdService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.util.utils.UUID;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-10-09
 */
@Transactional
@Service
public class CheckCheckMenuManagementServiceImpl
        extends ServiceImpl<CheckCheckMenuManagementMapper, CheckCheckMenuManagement>
        implements ICheckCheckMenuManagementService {

    @Autowired
    private HttpServletRequest request;
    @Autowired
    private ICheckDetailObdService iCheckDetailObdService;
    @Autowired
    private ICheckObdService iCheckObdService;

    private static String parameterType = "PARAMETER_TYPE";

    @Override
    public ResponseMessage addNoticeParameter(String codes) {
        List<CheckMenuManagementReqDTO> checkMenuManagements = new ArrayList<>();
        if (StringUtils.isNotEmpty(codes)) {
            List<String> codeList = Arrays.asList(codes.split(","));
            checkMenuManagements = baseMapper.selectNoticeParameterByCodes(codeList);
        }
        List<CheckCheckMenuManagement> result = new ArrayList<>();
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq(parameterType, "1");
        baseMapper.delete(wrapper);
        List<String> ids = new ArrayList<>();
        if (checkMenuManagements != null && !checkMenuManagements.isEmpty()) {
            for (CheckMenuManagementReqDTO checkMenuManagementReqDTO : checkMenuManagements) {
                CheckCheckMenuManagement checkCheckMenuManagement = new CheckCheckMenuManagement();
                checkCheckMenuManagement.setId(UUID.randomUUID());
                checkCheckMenuManagement.setParameterCodeOne(checkMenuManagementReqDTO.getParameterCodeOne());
                checkCheckMenuManagement.setParameterName(checkMenuManagementReqDTO.getParameterName().replace(" ",""));
                checkCheckMenuManagement.setParameterType("1");
                checkCheckMenuManagement.setParameterState("0");
                ids.add(checkCheckMenuManagement.getId());
                result.add(checkCheckMenuManagement);
            }
            if (this.saveBatch(result)) {
                return Result.success("200","保存成功",ids);
            }
        }
        return Result.success("200","保存成功",true);
    }

    @Override
    public ResponseMessage getCCCParameterOrENV(String mouldId,String type, String parameterCode, String parameterName) {
        if (StringUtils.isEmpty(type)) {
            return Result.error("参数类型不能为空");
        }
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq(parameterType, type);

//        if (StringUtils.isNotEmpty(obdId)){
//            wrapper.inSql("ID","SELECT CHECK_DETAIL_OBD.DETAIL_ID FROM CHECK_DETAIL_OBD WHERE OBD_ID = '" + obdId + "'");
//            //更新操作
//            checkCheckMenuManagementMapper.updateMenuParameterStateByObdid(obdId,type,parameterCode);
//        }
        List<String> allDataIds = iCheckDetailObdService.getDetailIdByMould(mouldId);
        if (StringUtils.isNotEmpty(parameterCode)) {
            wrapper.like("PARAMETER_CODE_ONE", parameterCode);
//            wrapper.or();
//            wrapper.eq(parameterType, type);
//            wrapper.like("PARAMETER_CODE_TWO", parameterCode);
        }
        if (StringUtils.isNotEmpty(parameterName)) {
            wrapper.like("PARAMETER_NAME", parameterName);
        }
        List<CheckCheckMenuManagement> list = this.list(wrapper);
        for (CheckCheckMenuManagement checkMenuManagementResDTO : list) {
            if (allDataIds.contains(checkMenuManagementResDTO.getId())) {
                checkMenuManagementResDTO.setParameterState("0");
            } else {
                checkMenuManagementResDTO.setParameterState("1");
            }
        }
        return Result.success("200", "查询成功", list);
    }

    @Override
    public ResponseMessage addCCCParameterOrENV(List<String> ids, String type, String mouldId) {
        UpdateWrapper wrapper = new UpdateWrapper();
        wrapper.set("PARAMETER_STATE", "1");
        wrapper.eq(parameterType, type);
        this.update(wrapper);
        if (ids != null && !ids.isEmpty()) {

            iCheckDetailObdService.saveRealCheckParameter(ids,mouldId);
            String str = getInParameter(ids,"ID");
            UpdateWrapper updateWrapper = new UpdateWrapper();
//            updateWrapper.in("ID", ids);
            updateWrapper.set("PARAMETER_STATE", "0");
            updateWrapper.last("where ID IN (" + str + ")");
            UpdateWrapper<CheckObd> mouldWrapper = new UpdateWrapper<>();
            mouldWrapper.eq("ID",mouldId);
            mouldWrapper.set("CHANGE_TIME",new Date());
            iCheckObdService.update(mouldWrapper);
            if (this.update(updateWrapper)) {
                return Result.success("保存成功");
            }
        }

        return Result.success("保存成功");
    }

    @Override
    public ResponseMessage insertRelationship(String obdId, String detailIds) {
        if(StringUtils.isNotBlank(obdId) && StringUtils.isNotBlank(detailIds)){
            //先删除原有的数据
            deleteRelationshipByMenuId(obdId);
            //添加数据
            List detailIdList = Arrays.asList(detailIds.split(","));
            int result = baseMapper.insertRelationship(obdId,detailIdList);
            if (result>0){
                return Result.success("保存成功");
            }
        }
        return Result.success("保存失败");

    }

    @Override
    public List<CheckCheckMenuManagement> queryMenuInfoByObdid(String obdId) {
        if (StringUtils.isNotBlank(obdId)){
            List<CheckCheckMenuManagement> list = baseMapper.queryMenuInfoByObdid(obdId);
            return list;
        }
        return null;

    }

    @Override
    public ResponseMessage queryObdDetailInfoByObdid(String obdId) {
        if (StringUtils.isNotBlank(obdId)){
            List list = baseMapper.queryObdDetailInfoByObdid(obdId);
            return Result.success("查询成功",list);
        }
        return Result.success("查询失败");
    }

    @Override
    public ResponseMessage deleteRelationshipByMenuId(String id) {

        if(StringUtils.isNotBlank(id)){
            int result = baseMapper.deleteRelationshipByMenuId(id);
            if(result>0){
                return Result.success("删除成功");
            }
        }
            return Result.success("删除失败");
    }

    public static String getInParameter(List list, String parameter) {
        if (!list.isEmpty()) {
            List<String> setList = new ArrayList<String>(0);
            Set set = new HashSet();
            StringBuilder stringBuffer = new StringBuilder();
            for (int i = 1; i <= list.size(); i++) {
                set.add("'" + list.get(i - 1) + "'");
                if (i % 900 == 0) {//900为阈值
                    setList.add(StringUtils.join(set.iterator(), ","));
                    set.clear();
                }
            }
            if (!set.isEmpty()) {
                setList.add(StringUtils.join(set.iterator(), ","));
            }
            stringBuffer.append(setList.get(0));
            for (int j = 1; j < setList.size(); j++) {
                stringBuffer.append(") or " + parameter + " in (");
                stringBuffer.append(setList.get(j));
            }
            return stringBuffer.toString();
        } else {
            return "''";
        }
    }
}
