package com.adc.da.system.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.adc.da.system.dao.CheckDetailObdMapper;
import com.adc.da.system.dao.CheckObdMapper;
import com.adc.da.system.entity.CheckDetailObd;
import com.adc.da.system.entity.CheckObd;
import com.adc.da.system.service.ICheckDetailObdService;
import com.adc.da.system.service.ICheckObdService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * OBD与OBD_DETAILS关联表 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2021-04-08
 */
@Service
public class CheckDetailObdServiceImpl extends ServiceImpl<CheckDetailObdMapper, CheckDetailObd> implements ICheckDetailObdService {

    @Autowired
    private CheckObdMapper checkObdMapper;
    @Autowired
    private ICheckObdService iCheckObdService;

    @Override
    public Integer insertDetailObd(List<CheckDetailObd> list) {
        this.saveBatch(list);
        return 1;
    }

    @Override
    public void saveRealCheckParameter(List<String> codeList, String mouldId) {
        QueryWrapper<CheckDetailObd> delWrapper = new QueryWrapper<>();
        delWrapper.eq("OBD_ID",mouldId);
        this.remove(delWrapper);
        CheckDetailObd checkDetailObd;
        List<CheckDetailObd> insertList = new ArrayList<>();
        for (String code:codeList) {
            checkDetailObd = new CheckDetailObd();
            checkDetailObd.setObdId(mouldId)
                    .setDetailId(code);
            insertList.add(checkDetailObd);
        }
        this.saveBatch(insertList);
        UpdateWrapper<CheckObd> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("ID",mouldId);
        updateWrapper.set("CHANGE_TIME",new Date());
        iCheckObdService.update(updateWrapper);
    }

    @Override
    public List<String> getDetailIdByMould(String mouldId) {
        QueryWrapper allDataWrapper = new QueryWrapper();
        allDataWrapper.eq("OBD_ID", mouldId);
        allDataWrapper.select("DETAIL_ID");
        List<String> detailIds = baseMapper.selectObjs(allDataWrapper);
        return CollectionUtil.isEmpty(detailIds) ? new ArrayList<>() : detailIds;
    }

    @Override
    public void delByObdId(String id) {
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("OBD_ID",id);
        this.remove(wrapper);
    }

    @Override
    public boolean saveStandCheckParameter(String mouldId, String detailId, String status) {
        CheckObd checkObd = new CheckObd();
        checkObd.setId(mouldId);
        checkObd.setChangeTime(new Date());
        checkObdMapper.updateObd(checkObd);
        List<String> detailIdList = Arrays.asList(detailId.split(","));
        if("0".equals(status)){
            for (String s : detailIdList) {
                CheckDetailObd checkDetailObd=new CheckDetailObd();
                checkDetailObd.setObdId(mouldId);
                checkDetailObd.setDetailId(s);
                this.save(checkDetailObd);
            }
        }else {
            QueryWrapper wrapper = new QueryWrapper();
            wrapper.eq("OBD_ID",mouldId);
            wrapper.in("DETAIL_ID",detailIdList);
            this.remove(wrapper);
        }
        return true;
    }
}
