package com.adc.da.system.service.impl;


import com.adc.da.dto.reqDTO.CheckRealVehicleVerificationDto;
import com.adc.da.system.dao.CheckModelSeriesListResultMapper;
import com.adc.da.system.dao.CheckRealVehicleVerResultMapper;
import com.adc.da.system.dao.CheckRealVehicleVerificationDao;
import com.adc.da.system.entity.CheckModelSeriesListResult;
import com.adc.da.system.entity.CheckRealVehicleVerResult;
import com.adc.da.system.entity.CheckRealVehicleVerification;
import com.adc.da.system.entity.CheckVehicleCheckMenu;
import com.adc.da.system.service.ICheckModelSeriesListResultService;
import com.adc.da.system.service.ICheckModelSeriesListService;
import com.adc.da.system.service.ICheckRealVehicleVerificationService;
import com.adc.da.system.service.ICheckVehicleCheckMenuService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2020-03-05
 */
@Service
public class CheckModelSeriesListResultServiceImpl extends ServiceImpl<CheckModelSeriesListResultMapper, CheckModelSeriesListResult> implements ICheckModelSeriesListResultService {

    @Autowired
    private CheckModelSeriesListResultMapper checkModelSeriesListResultMapper;

    @Autowired
    private CheckRealVehicleVerResultMapper checkRealVehicleVerResultMapper;

    @Autowired
    private CheckRealVehicleVerificationDao checkRealVehicleVerificationDao;

    @Autowired
    private ICheckRealVehicleVerificationService checkRealVehicleVerificationService;

    @Autowired
    private ICheckVehicleCheckMenuService checkVehicleCheckMenuService;

    @Autowired
    private ICheckModelSeriesListService checkModelSeriesListService;

    @Override
    public IPage<CheckModelSeriesListResult> getByPage(Page page, CheckModelSeriesListResult checkModelSeriesListResult) {
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesListResult.getBase() != null){
            baseIdList = Arrays.asList(checkModelSeriesListResult.getBase().split(","));
        }
        return checkModelSeriesListResultMapper.getByPage(page, checkModelSeriesListResult,baseIdList);
    }

    @Override
    public List<CheckModelSeriesListResult> getList(List<String> baseIdList) {
        return checkModelSeriesListResultMapper.getList(baseIdList);
    }

    @Override
    public List<CheckModelSeriesListResult> getModelList(List<String> baseIdList) {
        return checkModelSeriesListResultMapper.getModelList(baseIdList);
    }

    @Override
    public Boolean appoint(String id, String vehicleSeriesId, String vehicleType, String carOperator, String editionCode, String base) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("VEHICLE_SERIES_ID", vehicleSeriesId);
        List<CheckVehicleCheckMenu> listMenu = checkVehicleCheckMenuService.getMenuByVId(vehicleSeriesId);
        List<CheckRealVehicleVerification> listInfo = checkRealVehicleVerificationService.list(queryWrapper);
        for (CheckVehicleCheckMenu data : listMenu) {
            c1(data,vehicleType,vehicleSeriesId,editionCode,base,listInfo);
        }
        QueryWrapper queryWrapper1 = new QueryWrapper();
        queryWrapper1.eq("VEHICLE_SERIES_ID", id);
        queryWrapper1.eq("TYPE", "2");
        List<CheckRealVehicleVerResult> list1 = checkRealVehicleVerResultMapper.selectList(queryWrapper1);
        if (list1.size() == 0){
            return false;
        }
        QueryWrapper queryWrapper2 = new QueryWrapper();
        queryWrapper2.eq("VEHICLE_SERIES_ID", vehicleSeriesId);
        List<CheckRealVehicleVerification> list2 = checkRealVehicleVerificationDao.selectList(queryWrapper2);
        List<CheckRealVehicleVerification> list = new ArrayList<>();
        c2(list1,list2,list);
        if (list.size() != 0){
            checkRealVehicleVerificationService.updateBatchById(list);
        }else {
            return false;
        }
        QueryWrapper queryWrapper4 = new QueryWrapper();
        queryWrapper4.eq("VEHICLE_SERIES_ID",vehicleSeriesId);
        List<CheckRealVehicleVerification> listByPName = checkRealVehicleVerificationDao.selectList(queryWrapper4);
        for (CheckVehicleCheckMenu data : listMenu) {
            List<CheckRealVehicleVerification> list3 = new ArrayList<>();
            for (CheckRealVehicleVerification data1:listByPName) {
                if (data1.getId().contains("_"+data.getParameterType())
                        && data.getParameterName().equals(data1.getParameterName().split(" ")[0])){
                    list3.add(data1);
                }
            }
            List<String> type = list3
                    .stream()
                    .map(CheckRealVehicleVerification::getType)
                    .collect(Collectors.toList());
            if (list3.size() != 0) {
                c3(list3,data,vehicleSeriesId,type);
            }
        }
        /**
         * 更新车型系列表状态值
         */
        QueryWrapper queryWrapper3 = new QueryWrapper();
        queryWrapper3.eq("VEHICLE_SERIES_ID", vehicleSeriesId);
        queryWrapper3.select("PARAMETER_CHECK_STATE");
        List<CheckVehicleCheckMenu> typeList = checkVehicleCheckMenuService.list(queryWrapper3);
        List<Integer> parameterCheckState = typeList
                .stream()
                .map(CheckVehicleCheckMenu::getParameterCheckState)
                .collect(Collectors.toList());
        UpdateWrapper updateWrapper1 = new UpdateWrapper();
        if ((parameterCheckState.contains(1)
                || parameterCheckState.contains(2)
                || parameterCheckState.contains(3)
                || parameterCheckState.contains(4)
                || parameterCheckState.contains(5))) {
            // 核查中
            updateWrapper1.set("TYPE", 1);
        } else {
            updateWrapper1.set("TYPE", 0);
        }

        /**
         * 更新车型系列状态值
         */
        updateWrapper1.eq("ID", vehicleSeriesId);
        updateWrapper1.set("CAR_OPERATOR", carOperator);
        updateWrapper1.set("CREATE_TIME", new Date());
        checkModelSeriesListService.update(updateWrapper1);
        return true;
    }

    private void c1(CheckVehicleCheckMenu data,String vehicleType, String vehicleSeriesId,String editionCode,String base,List<CheckRealVehicleVerification> listInfo){
        CheckRealVehicleVerificationDto checkRealVehicleVerificationDto = new CheckRealVehicleVerificationDto();
        checkRealVehicleVerificationDto.setParameterName(data.getParameterName());
        checkRealVehicleVerificationDto.setParameterData(data.getParameterData());
        checkRealVehicleVerificationDto.setParameterType(data.getParameterType());
        checkRealVehicleVerificationDto.setParameterCodeOne(data.getParameterCodeOne());
        checkRealVehicleVerificationDto.setParameterCodeTwo(data.getParameterCodeTwo());
        checkRealVehicleVerificationDto.setVehicleType(vehicleType);
        checkRealVehicleVerificationDto.setVehicleSeriesId(vehicleSeriesId);
        checkRealVehicleVerificationDto.setEditionCode(editionCode);
        checkRealVehicleVerificationDto.setBase(base);
        boolean flag = true;
        for (CheckRealVehicleVerification data1:listInfo) {
            if (checkRealVehicleVerificationDto.getParameterType().equals("3")
                    && data1.getParameter() != null
                    && data1.getParameter().equals(checkRealVehicleVerificationDto.getParameterCodeOne())){

                flag = false;
                break;

            }
            if (data1.getId().contains("_"+checkRealVehicleVerificationDto.getParameterType())
                    && (data1.getParameterName().equals(checkRealVehicleVerificationDto.getParameterName())
                    || data1.getParameterName().equals(checkRealVehicleVerificationDto.getParameterName() + " 1"))){
                flag = false;
                break;
            }
        }
        if (flag){
            checkRealVehicleVerificationService.saveInfo(checkRealVehicleVerificationDto);
        }
    }
    private void c2(List<CheckRealVehicleVerResult> list1,List<CheckRealVehicleVerification> list2,List<CheckRealVehicleVerification> list){
        for (CheckRealVehicleVerResult data : list1) {
            for (CheckRealVehicleVerification data1 : list2) {
                if (data.getParameterName().equals(data1.getParameterName()) && data.getParamConfig().equals(data1.getParamConfig())) {
                    c2Sub(data, data1, list);
                }
            }
        }
    }

    private void c2Sub(CheckRealVehicleVerResult data, CheckRealVehicleVerification data1, List<CheckRealVehicleVerification> list) {
        if (data.getParameter() != null && data1.getParameter() != null){
            if (data.getParameter().equals(data1.getParameter() != null)){
                data1.setCheckPicturePath(data.getCheckPicturePath());
                data1.setType(data.getType());
                data1.setRemarks(data.getRemarks());
                list.add(data1);
            }
        }else {
            data1.setCheckPicturePath(data.getCheckPicturePath());
            data1.setType(data.getType());
            data1.setRemarks(data.getRemarks());
            list.add(data1);
        }
    }

    private void c3(List<CheckRealVehicleVerification> list3,CheckVehicleCheckMenu data, String vehicleSeriesId,List<String> type){
        UpdateWrapper updateWrapper = new UpdateWrapper();
        String name = list3.get(0).getParameterName().split(" ")[0];
        String strh = "";
        if (name.split("/")[0].length() > 2){
            strh = name.split("/")[0].substring(name.split("/")[0].length()-2);
        }
        String strh1 = "";
        if (name.split("/")[0].length() > 4){
            strh1 = name.split("/")[0].substring(name.split("/")[0].length()-4);
        }
        if (data.getParameterType().equals("1") && (strh.equals("型号") || strh1.equals("生产企业"))){
            updateWrapper.eq("PARAMETER_NAME", name.split("/")[0].replace("型号", "").replace("生产企业", ""));
        }else {
            updateWrapper.eq("PARAMETER_NAME", name);
        }
        updateWrapper.eq("PARAMETER_TYPE",data.getParameterType());
        updateWrapper.eq("VEHICLE_SERIES_ID", vehicleSeriesId);
        /**
         * type为核查每一项的状态
         * 0：待确认
         * 1：核查期间为供货
         * 2：一致
         * 3：不一致
         * 4: 停止供货
         */
        /**
         * 核查参数列表核查结果
         * 0：待确认
         * 1：核查中
         * 2：不一致
         * 3：一致
         * 4：核查期间未供货
         * 5：停止供货
         */
        // 包含待确认项则显示为核查中（最少包含其它项一个）
        if (type.contains("0") && (type.contains("3") || type.contains("2") || type.contains("1") || type.contains("4"))) {
            updateWrapper.set("PARAMETER_CHECK_STATE", 1);
            // 包含不一致项则显示不一致（不包含待确认）
        } else if (!type.contains("0") && type.contains("3")) {
            updateWrapper.set("PARAMETER_CHECK_STATE", 2);
            // 包含一致项则显示一致（不包含待确认,不一致）
        } else if (!type.contains("0") && !type.contains("3") && type.contains("2")) {
            updateWrapper.set("PARAMETER_CHECK_STATE", 3);
            // 包含核查期间未供货项则显示核查期间未供货（不包含待确认,不一致,一致）
        } else if (!type.contains("0") && !type.contains("3") && !type.contains("2") && type.contains("1")) {
            updateWrapper.set("PARAMETER_CHECK_STATE", 4);
            // 包含停止供货项则显示停止供货（不包含待确认,不一致,一致,核查期间未供货）
        } else if (!type.contains("0") && !type.contains("3") && !type.contains("2") && !type.contains("1") && type.contains("4")) {
            updateWrapper.set("PARAMETER_CHECK_STATE", 5);
        } else {
            // 待确认
            updateWrapper.set("PARAMETER_CHECK_STATE", 0);
        }
        /**
         * 更新实车核查列表状态值
         */
        checkVehicleCheckMenuService.update(updateWrapper);
    }
}
