package com.adc.da.system.service.impl;


import com.adc.da.dto.reqDTO.CheckRealVehicleVerificationDto;
import com.adc.da.dto.resDTO.ModelServiceItemDTO;
import com.adc.da.system.dao.CheckModelSeriesListDao;
import com.adc.da.system.dao.CheckModelSeriesListResultMapper;
import com.adc.da.system.entity.CheckEnterpriseData;
import com.adc.da.system.entity.CheckModelSeriesList;
import com.adc.da.system.entity.CheckRealVehicleVerification;
import com.adc.da.system.entity.CheckVehicleAndSeries;
import com.adc.da.system.entity.CheckVehicleCheckMenu;
import com.adc.da.system.service.ICheckModelSeriesListResultService;
import com.adc.da.system.service.ICheckModelSeriesListService;
import com.adc.da.system.service.ICheckRealVehicleVerResultService;
import com.adc.da.system.service.ICheckRealVehicleVerificationService;
import com.adc.da.system.service.ICheckVehicleAndSeriesService;
import com.adc.da.system.service.ICheckVehicleCheckMenuService;
import com.adc.da.util.UUIDUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tencentcloudapi.tci.v20190318.models.DetailInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class CheckModelSeriesListServiceImpl extends ServiceImpl<CheckModelSeriesListDao, CheckModelSeriesList>
        implements ICheckModelSeriesListService {

    /**
     * checkModelSeriesListDao
     */
    @Autowired
    private CheckModelSeriesListDao checkModelSeriesListDao;


    /**
     * checkVehicleAndSeriesService
     */
    @Autowired
    private ICheckVehicleAndSeriesService checkVehicleAndSeriesService;



    @Autowired
    private ICheckVehicleCheckMenuService checkVehicleCheckMenuService;

    @Autowired
    private ICheckRealVehicleVerificationService checkRealVehicleVerificationService;

    @Autowired
    private ICheckModelSeriesListResultService checkModelSeriesListResultService;

    @Autowired
    private ICheckRealVehicleVerResultService checkRealVehicleVerResultService;

    @Override
    public IPage<CheckModelSeriesList> queryCheckModelSeriesListByPage(Page page, CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrderBy() != null) {
            switch (checkModelSeriesList.getOrderBy()) {
                case "vehicleSeries":
                    checkModelSeriesList.setOrderBy("NLSSORT(VEHICLE_SERIES,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "vehicleTypeAndGroup":
                    checkModelSeriesList.setOrderBy("VEHICLE_TYPE_AND_GROUP");
                    break;
                case "createTime":
                    checkModelSeriesList.setOrderBy("CREATE_TIME");
                    break;
                case "orgName":
                    checkModelSeriesList.setOrderBy("NLSSORT(ORG_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "carOperator":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_OPERATOR,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "type":
                    checkModelSeriesList.setOrderBy("TYPE");
                    break;
                case "carRemarks":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_REMARKS,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                default:
                   break;
            }
        } else {
            checkModelSeriesList.setOrderBy("ID");
        }
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList  = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        return checkModelSeriesListDao.queryCheckModelSeriesListByPage(page, checkModelSeriesList, baseIdList, null);
    }

    @Override
    public IPage<CheckModelSeriesList> queryReviewCheckModelSeriesList(Page page, CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrderBy() != null) {
            switch (checkModelSeriesList.getOrderBy()) {
                case "vehicleSeries":
                    checkModelSeriesList.setOrderBy("NLSSORT(VEHICLE_SERIES,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "vehicleTypeAndGroup":
                    checkModelSeriesList.setOrderBy("VEHICLE_TYPE_AND_GROUP");
                    break;
                case "createTime":
                    checkModelSeriesList.setOrderBy("CREATE_TIME");
                    break;
                case "orgName":
                    checkModelSeriesList.setOrderBy("NLSSORT(ORG_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "carOperator":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_OPERATOR,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "type":
                    checkModelSeriesList.setOrderBy("TYPE");
                    break;
                case "carRemarks":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_REMARKS,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                default:
                    checkModelSeriesList.setOrderBy("TYPE");
                    checkModelSeriesList.setOrder("asc");
            }
        } else {
            checkModelSeriesList.setOrderBy("ID");
        }
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList  = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        return checkModelSeriesListDao.queryReviewCheckModelSeriesList(page, checkModelSeriesList, baseIdList, null);
    }

    @Override
    public IPage<CheckModelSeriesList> querySuccessCheckModelSeriesList(Page page, CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrderBy() != null) {
            switch (checkModelSeriesList.getOrderBy()) {
                case "vehicleSeries":
                    checkModelSeriesList.setOrderBy("NLSSORT(VEHICLE_SERIES,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "vehicleTypeAndGroup":
                    checkModelSeriesList.setOrderBy("VEHICLE_TYPE_AND_GROUP");
                    break;
                case "createTime":
                    checkModelSeriesList.setOrderBy("CREATE_TIME");
                    break;
                case "orgName":
                    checkModelSeriesList.setOrderBy("NLSSORT(ORG_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "carOperator":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_OPERATOR,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "type":
                    checkModelSeriesList.setOrderBy("TYPE");
                    break;
                case "carRemarks":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_REMARKS,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                default:
                    checkModelSeriesList.setOrderBy("TYPE");
                    checkModelSeriesList.setOrder("asc");
            }
        }
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList  = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        return checkModelSeriesListDao.querySuccessCheckModelSeriesList(page, checkModelSeriesList, baseIdList, null);
    }

    @Override
    public List<CheckModelSeriesList> queryCheckModelSeriesList(CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList  = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        List<String> idList = new ArrayList<>();
        if (checkModelSeriesList.getId() != null){
            idList = Arrays.asList(checkModelSeriesList.getId().split(","));
        }
        List<CheckModelSeriesList> list = checkModelSeriesListDao.queryCheckModelSeriesListByPage(checkModelSeriesList, baseIdList, idList);
        ModelServiceItemDTO modelServiceItemDTO;
        String[] itemArr = new String[] {"认证一致性核查","关键件一致性核查","OBD静态验证","标准符合性核查","扫码符合性检查"};
        for (CheckModelSeriesList data:list) {
            CheckVehicleCheckMenu checkVehicleCheckMenu = new CheckVehicleCheckMenu();
            checkVehicleCheckMenu.setVehicleSeriesId(data.getId());
            CheckRealVehicleVerificationDto checkRealVehicleVerificationDto = new CheckRealVehicleVerificationDto();
            checkRealVehicleVerificationDto.setVehicleType(data.getVehicleTypeAndGroup());
            checkRealVehicleVerificationDto.setVehicleSeriesId(data.getId());
            checkRealVehicleVerificationDto.setEditionCode(data.getEditionCode());
            checkRealVehicleVerificationDto.setBase(data.getBase());
            checkVehicleCheckMenu.setParameterCheckState(0);
            checkVehicleCheckMenu.setRealMouldId(data.getRealMouldId());
            List<CheckVehicleCheckMenu> list1 = checkVehicleCheckMenuService.queryVehicleCheckMenu(checkVehicleCheckMenu, checkRealVehicleVerificationDto);
            for (CheckVehicleCheckMenu data1:list1) {
                QueryWrapper<CheckRealVehicleVerification> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("VEHICLE_SERIES_ID",data1.getVehicleSeriesId());
                if (data1.getParameterType().equals("3")){
                    queryWrapper.eq("PARAMETER",data1.getParameterCodeOne());
                }else {
                    queryWrapper.and(wrapper -> wrapper.eq("PARAMETER_NAME",data1.getParameterName())
                            .or()
                            .like("PARAMETER_NAME",data1.getParameterName()+' '));
                }
                queryWrapper.orderByDesc("TYPE","PARAMETER_NAME");
                queryWrapper.eq("TYPE","0");
                List<CheckRealVehicleVerification> list2 = checkRealVehicleVerificationService.list(queryWrapper);
                data1.setCheckRealVehicleVerificationList(list2);
            }

            data.setCheckVehicleCheckMenuList(list1);
//            List<CheckRealVehicleVerification> obd = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","1"));
//            if (null == obd || obd.isEmpty()) {
//                checkRealVehicleVerificationService.saveCheckDetail(data,"1");
//            }
//            obd = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","1"));
//            data.setObdDetail(obd);
//
//            List<CheckRealVehicleVerification> scanCode = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","2"));
//            if (null == scanCode || scanCode.isEmpty()) {
//                checkRealVehicleVerificationService.saveCheckDetail(data,"2");
//            }
//            scanCode = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","2"));
//            data.setScanCodeDetail(scanCode);
//
//            List<CheckRealVehicleVerification> standDetail = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","4"));
//            if (null == standDetail || standDetail.isEmpty()) {
//                checkRealVehicleVerificationService.saveCheckDetail(data,"4");
//            }
//            standDetail = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","4"));
//            data.setStandDetail(standDetail);

                List<ModelServiceItemDTO> itemData = new ArrayList<>();
                for (String itemStr : itemArr) {
                    modelServiceItemDTO = new ModelServiceItemDTO();
                    switch (itemStr){
                        case "认证一致性核查" :
                            modelServiceItemDTO.setCarOperator(itemStr);
                            modelServiceItemDTO.setOperationTime(data.getRealVehicleTime());
                            modelServiceItemDTO.setOperationUser(data.getRealMouldOperator());
                            modelServiceItemDTO.setType(data.getRealMouldStatus());
                            modelServiceItemDTO.setRemark(data.getCarRemarks());
                            break;
                        case "关键件一致性核查" :
                            modelServiceItemDTO = new ModelServiceItemDTO();
                            modelServiceItemDTO.setCarOperator(itemStr);
                            modelServiceItemDTO.setOperationTime(data.getKeyTime());
                            modelServiceItemDTO.setOperationUser(data.getKeyOperator());
                            modelServiceItemDTO.setType(data.getKeyStatus());
                            modelServiceItemDTO.setRemark(data.getKeyRemark());
                            break;
                        case "OBD静态验证" :
                            modelServiceItemDTO = new ModelServiceItemDTO();
                            modelServiceItemDTO.setCarOperator(itemStr);
                            modelServiceItemDTO.setOperationTime(data.getObdTime());
                            modelServiceItemDTO.setOperationUser(data.getObdOperator());
                            modelServiceItemDTO.setType(data.getObdStatus());
                            modelServiceItemDTO.setRemark(data.getObdRemark());
                            break;
                        case "扫码符合性检查" :
                            modelServiceItemDTO = new ModelServiceItemDTO();
                            modelServiceItemDTO.setCarOperator(itemStr);
                            modelServiceItemDTO.setOperationTime(data.getScanCodeTime());
                            modelServiceItemDTO.setOperationUser(data.getScanCodeOperator());
                            modelServiceItemDTO.setType(data.getScanCodeStatus());
                            modelServiceItemDTO.setRemark(data.getScanCodeRemark());
                            break;
                        case "标准符合性核查" :
                            modelServiceItemDTO = new ModelServiceItemDTO();
                            modelServiceItemDTO.setCarOperator(itemStr);
                            modelServiceItemDTO.setOperationTime(data.getStandTime());
                            modelServiceItemDTO.setOperationUser(data.getStandOperator());
                            modelServiceItemDTO.setType(data.getStandStatus());
                            modelServiceItemDTO.setRemark(data.getStandRemark());
                            break;
                        default:
                            break;
                    }
                    itemData.add(modelServiceItemDTO);
                }
            data.setArr(itemData);
        }
        return list;
    }

    @Override
    public List<CheckModelSeriesList> queryCheckModelSeriesListFh(CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList  = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        List<String> idList = new ArrayList<>();
        if (checkModelSeriesList.getId() != null){
            idList = Arrays.asList(checkModelSeriesList.getId().split(","));
        }
        List<CheckModelSeriesList> list = checkModelSeriesListDao.queryCheckModelSeriesListByPageFh(checkModelSeriesList, baseIdList, idList);
        ModelServiceItemDTO modelServiceItemDTO;
        String[] itemArr = new String[] {"认证一致性核查","关键件一致性核查","OBD静态验证","标准符合性核查","扫码符合性检查"};
        for (CheckModelSeriesList data:list) {
            CheckVehicleCheckMenu checkVehicleCheckMenu = new CheckVehicleCheckMenu();
            checkVehicleCheckMenu.setVehicleSeriesId(data.getId());
            CheckRealVehicleVerificationDto checkRealVehicleVerificationDto = new CheckRealVehicleVerificationDto();
            checkRealVehicleVerificationDto.setVehicleType(data.getVehicleTypeAndGroup());
            checkRealVehicleVerificationDto.setVehicleSeriesId(data.getId());
            checkRealVehicleVerificationDto.setEditionCode(data.getEditionCode());
            checkRealVehicleVerificationDto.setBase(data.getBase());
            checkVehicleCheckMenu.setParameterCheckState(0);
            List<CheckVehicleCheckMenu> list1 = checkVehicleCheckMenuService.queryVehicleCheckMenu(checkVehicleCheckMenu, checkRealVehicleVerificationDto);
            for (CheckVehicleCheckMenu data1:list1) {
                QueryWrapper<CheckRealVehicleVerification> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("VEHICLE_SERIES_ID",data1.getVehicleSeriesId());
                if (data1.getParameterType().equals("3")){
                    queryWrapper.eq("PARAMETER",data1.getParameterCodeOne());
                }else {
                    queryWrapper.and(wrapper -> wrapper.eq("PARAMETER_NAME",data1.getParameterName())
                            .or()
                            .like("PARAMETER_NAME",data1.getParameterName()+' '));
                }
                queryWrapper.orderByDesc("TYPE","PARAMETER_NAME");
                queryWrapper.eq("TYPE","0");
                List<CheckRealVehicleVerification> list2 = checkRealVehicleVerificationService.list(queryWrapper);
                data1.setCheckRealVehicleVerificationList(list2);
            }
            data.setCheckVehicleCheckMenuList(list1);
//            List<CheckRealVehicleVerification> obd = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","1"));
//            if (null == obd || obd.isEmpty()) {
//                checkRealVehicleVerificationService.saveCheckDetail(data,"1");
//            }
//            obd = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","1"));
//            data.setObdDetail(obd);
//
//            List<CheckRealVehicleVerification> scanCode = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","2"));
//            if (null == scanCode || scanCode.isEmpty()) {
//                checkRealVehicleVerificationService.saveCheckDetail(data,"2");
//            }
//            scanCode = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","2"));
//            data.setScanCodeDetail(scanCode);
//
//            List<CheckRealVehicleVerification> standDetail = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","4"));
//            if (null == standDetail || standDetail.isEmpty()) {
//                checkRealVehicleVerificationService.saveCheckDetail(data,"4");
//            }
//            standDetail = checkRealVehicleVerificationService
//                    .list(new QueryWrapper<CheckRealVehicleVerification>().eq("VEHICLE_SERIES_ID",data.getId()).eq("CHECK_TYPE","4"));
//            data.setStandDetail(standDetail);

            List<ModelServiceItemDTO> itemData = new ArrayList<>();
            for (String itemStr : itemArr) {
                modelServiceItemDTO = new ModelServiceItemDTO();
                switch (itemStr){
                    case "认证一致性核查" :
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(data.getRealVehicleTime());
                        modelServiceItemDTO.setOperationUser(data.getRealMouldOperator());
                        modelServiceItemDTO.setType(data.getRealMouldStatus());
                        modelServiceItemDTO.setRemark(data.getCarRemarks());
                        break;
                    case "关键件一致性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(data.getKeyTime());
                        modelServiceItemDTO.setOperationUser(data.getKeyOperator());
                        modelServiceItemDTO.setType(data.getKeyStatus());
                        modelServiceItemDTO.setRemark(data.getKeyRemark());
                        break;
                    case "OBD静态验证" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(data.getObdTime());
                        modelServiceItemDTO.setOperationUser(data.getObdOperator());
                        modelServiceItemDTO.setType(data.getObdStatus());
                        modelServiceItemDTO.setRemark(data.getObdRemark());
                        break;
                    case "扫码符合性检查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(data.getScanCodeTime());
                        modelServiceItemDTO.setOperationUser(data.getScanCodeOperator());
                        modelServiceItemDTO.setType(data.getScanCodeStatus());
                        modelServiceItemDTO.setRemark(data.getScanCodeRemark());
                        break;
                    case "标准符合性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(data.getStandTime());
                        modelServiceItemDTO.setOperationUser(data.getStandOperator());
                        modelServiceItemDTO.setType(data.getStandStatus());
                        modelServiceItemDTO.setRemark(data.getStandRemark());
                        break;
                    default:
                        break;
                }
                itemData.add(modelServiceItemDTO);
            }
            data.setArr(itemData);
        }
        return list;
    }

    @Override
    public IPage<CheckModelSeriesList> queryCheckModelSeriesListByPageFh(Page page, CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrderBy() != null) {
            switch (checkModelSeriesList.getOrderBy()) {
                case "vehicleSeries":
                    checkModelSeriesList.setOrderBy("NLSSORT(VEHICLE_SERIES,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "vehicleTypeAndGroup":
                    checkModelSeriesList.setOrderBy("VEHICLE_TYPE_AND_GROUP");
                    break;
                case "createTime":
                    checkModelSeriesList.setOrderBy("CREATE_TIME");
                    break;
                case "orgName":
                    checkModelSeriesList.setOrderBy("NLSSORT(ORG_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "operator":
                    checkModelSeriesList.setOrderBy("OPERATOR");
                    break;
                case "carOperator":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_OPERATOR,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "type":
                    checkModelSeriesList.setOrderBy("TYPE");
                    break;
                case "realVehicleTime":
                    checkModelSeriesList.setOrderBy("REAL_VEHICLE_TIME");
                    break;
                case "carRemarks":
                    checkModelSeriesList.setOrderBy("NLSSORT(CAR_REMARKS,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                default:
                    checkModelSeriesList.setOrderBy("TYPE");
                    checkModelSeriesList.setOrder("asc");
            }
        }
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        resetList();
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList  = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        List<CheckModelSeriesList> list = checkModelSeriesListDao.queryCheckModelSeriesListByPageFh(page, checkModelSeriesList, baseIdList, null);
        page.setRecords(list);
        return page;
    }

    private void resetList(){
        List<CheckModelSeriesList> list = checkModelSeriesListDao.queryCheckModelSeriesList();
        for (CheckModelSeriesList data:list) {
            if (data.getCreateTime() == null || data.getCreateTime().before(data.getRealVehicleTime())){
                UpdateWrapper updateWrapper = new UpdateWrapper();
                updateWrapper.set("TYPE",0);
                updateWrapper.set("REAL_VEHICLE_IS_CHECK",0);
                updateWrapper.set("CAR_REMARKS","");
                updateWrapper.set("CREATE_TIME","");
                updateWrapper.set("STOPRODUCTION","");
                updateWrapper.eq("ID",data.getId());
                this.update(updateWrapper);
                data.setType(0);
                data.setRealVehicleIsCheck(0);
                UpdateWrapper updateWrapper1 = new UpdateWrapper();
                updateWrapper1.set("PARAMETER_CHECK_STATE",0);
                updateWrapper1.eq("VEHICLE_SERIES_ID",data.getId());
                checkVehicleCheckMenuService.update(updateWrapper1);
                UpdateWrapper updateWrapper2 = new UpdateWrapper();
                updateWrapper2.set("TYPE","0");
                updateWrapper2.set("CHECK_PICTURE_PATH","");
                updateWrapper2.set("REMARKS","");
                updateWrapper2.eq("VEHICLE_SERIES_ID",data.getId());
                checkRealVehicleVerificationService.update(updateWrapper2);
            }
        }
    }

    @Override
    public IPage<CheckModelSeriesList> queryCheckedModelSeriesListByPage(Page page, CheckModelSeriesList checkModelSeriesList) {
        if (checkModelSeriesList.getOrderBy() != null) {
            switch (checkModelSeriesList.getOrderBy()) {
                case "vehicleSeries":
                    checkModelSeriesList.setOrderBy("VEHICLE_SERIES");
                    break;
                case "vehicleTypeAndGroup":
                    checkModelSeriesList.setOrderBy("VEHICLE_TYPE_AND_GROUP");
                    break;
                case "operator":
                    checkModelSeriesList.setOrderBy("OPERATOR");
                    break;
                case "keyPartsTime":
                    checkModelSeriesList.setOrderBy("KEY_PARTS_TIME");
                    break;
                case "realVehicleTime":
                    checkModelSeriesList.setOrderBy("REAL_VEHICLE_TIME");
                    break;
                case "carRemarks":
                    checkModelSeriesList.setOrderBy("CAR_REMARKS");
                    break;
                case "keyRemarks":
                    checkModelSeriesList.setOrderBy("KEY_REMARKS");
                    break;
                default:
                    checkModelSeriesList.setOrderBy(null);
            }
        }
        if (checkModelSeriesList.getOrder() != null && checkModelSeriesList.getOrder().equals("normal")) {
            checkModelSeriesList.setOrder(null);
        }
        List<String> userRole = checkModelSeriesListDao.userIsSupper(checkModelSeriesList.getOrgName());
        if (userRole != null && !userRole.isEmpty()) {
            checkModelSeriesList.setOrgName("");
        } else {
            checkModelSeriesList.setOrgName(checkModelSeriesListDao.
                    getOrgNameByUserId(checkModelSeriesList.getOrgName()));
        }
        return checkModelSeriesListDao.queryCheckedModelSeriesListByPage(page, checkModelSeriesList);
    }

    @Override
    public Boolean addCheckModelSeriesList(CheckModelSeriesList checkModelSeriesList) {
        String id = UUIDUtils.getUUID();
        checkModelSeriesList.setId(id);
        checkModelSeriesList.setCreationTime(new Date());
//        DetailInfo detailInfo = detailInfoMapper.getByVehilceType(Arrays.asList(checkModelSeriesList.getVehicleType().split(",")));
//        if (detailInfo != null) {
//            checkModelSeriesList.setCccNumber(detailInfo.getItemId());
//        }
//        EnvDataEntity envDataEntity = envDataDao.getByVehilceType(Arrays.asList(checkModelSeriesList.getVehicleType().split(",")));
//        if (envDataEntity != null) {
//            checkModelSeriesList.setEnvNumber(envDataEntity.getInfoDisclosureNo());
//        }
        if (this.save(checkModelSeriesList)) {
            List<CheckVehicleAndSeries> checkVehicleAndSeriesList = new ArrayList<>();
            for (String vehicleId : checkModelSeriesList.getVehicleId()) {
                CheckVehicleAndSeries checkVehicleAndSeries = new CheckVehicleAndSeries();
                checkVehicleAndSeries.setId(UUIDUtils.getUUID());
                checkVehicleAndSeries.setVehicleSeriesId(id);
                checkVehicleAndSeries.setVehicleId(vehicleId);
                checkVehicleAndSeriesList.add(checkVehicleAndSeries);
            }
//            if (checkVehicleAndSeriesService.saveBatch(checkVehicleAndSeriesList)) {
//                List<CheckEnterpriseData> checkEnterpriseData = new ArrayList<>();
//                List<CheckConsistencyCheck> list = new ArrayList<>();
//                for (String vehicleId : checkModelSeriesList.getVehicleId()) {
//                    CheckEnterpriseData data = new CheckEnterpriseData();
//                    CheckConsistencyCheck checkConsistencyCheck = new CheckConsistencyCheck();
//                    data.setId(vehicleId);
//                    data.setType(1);
//                    checkEnterpriseData.add(data);
//                    checkConsistencyCheck.setId(vehicleId);
//                    checkConsistencyCheck.setType(1);
//                    list.add(checkConsistencyCheck);
//                }
//                checkEnterpriseDataService.updateBatchById(checkEnterpriseData);
//                checkConsistencyCheckService.updateBatchById(list);
//            }
            checkVehicleAndSeriesService.saveBatch(checkVehicleAndSeriesList);
            return true;
        }
        return false;
    }

    @Override
    public Map<String,Integer> stat(CheckModelSeriesList checkModelSeriesList) {
        /**
         * 多事业部处理
         */
        List<String> baseIdList = new ArrayList<>();
        if (checkModelSeriesList.getBase() != null){
            baseIdList = Arrays.asList(checkModelSeriesList.getBase().split(","));
        }
        /**
         * 实车未核查数量
         */
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("REAL_VEHICLE_IS_CHECK", 0);
        queryWrapper.eq("TYPE",1);
        if (checkModelSeriesList.getBase() != null && !checkModelSeriesList.getBase().equals("all")){
            queryWrapper.in("BASE", baseIdList);
        }
        if (checkModelSeriesList.getStartTime() != null && checkModelSeriesList.getEndTime() != null){
            queryWrapper.between("CREATE_TIME",checkModelSeriesList.getStartTime(),checkModelSeriesList.getEndTime());
        }
        Integer stating = checkModelSeriesListDao.selectCount(queryWrapper);
        /**
         * 实车已核查数量
         */
        QueryWrapper queryWrapper1 = new QueryWrapper();
        queryWrapper1.eq("OBD_STATUS", "0");
        queryWrapper1.eq("SCAN_CODE_STATUS", "0");
        queryWrapper1.eq("REAL_MOULD_STATUS", "0");
        queryWrapper1.eq("STAND_STATUS", "0");
        queryWrapper1.eq("KEY_STATUS", "0");
        if (checkModelSeriesList.getBase() != null && !checkModelSeriesList.getBase().equals("all")){
            queryWrapper1.in("BASE", baseIdList);
        }
        if (checkModelSeriesList.getStartTime() != null && checkModelSeriesList.getEndTime() != null){
            queryWrapper1.between("REAL_VEHICLE_TIME",checkModelSeriesList.getStartTime(),checkModelSeriesList.getEndTime());
            queryWrapper1.between("OBD_TIME",checkModelSeriesList.getStartTime(),checkModelSeriesList.getEndTime());
            queryWrapper1.between("SCAN_CODE_TIME",checkModelSeriesList.getStartTime(),checkModelSeriesList.getEndTime());
            queryWrapper1.between("STAND_TIME",checkModelSeriesList.getStartTime(),checkModelSeriesList.getEndTime());
            queryWrapper1.between("KEY_TIME",checkModelSeriesList.getStartTime(),checkModelSeriesList.getEndTime());
        }
        Integer stated = checkModelSeriesListDao.selectCount(queryWrapper1);
        Map<String,Integer> map = new HashMap<>();
        map.put("stated",stated);
        map.put("stating",stating);
        return map;
    }

    @Override
    public void checkOk(String ids) {
        List<String> idList = Arrays.asList(ids.split(","));
        UpdateWrapper<CheckModelSeriesList> wrapper = new UpdateWrapper<CheckModelSeriesList>();
        wrapper.in("ID",idList);
        wrapper.set("IS_CHECK_OK","0");
        this.update(wrapper);
    }
}
