package com.adc.da.system.service.impl;


import com.adc.da.dto.reqDTO.CheckRealVehicleVerificationDto;
import com.adc.da.system.dao.CheckCheckMenuManagementMapper;
import com.adc.da.system.dao.CheckVehicleCheckMenuDao;
import com.adc.da.system.entity.CheckCheckMenuManagement;
import com.adc.da.system.entity.CheckRealVehicleVerification;
import com.adc.da.system.entity.CheckVehicleCheckMenu;
import com.adc.da.system.service.ICheckCheckMenuManagementService;
import com.adc.da.system.service.ICheckRealVehicleVerificationService;
import com.adc.da.system.service.ICheckVehicleCheckMenuService;
import com.adc.da.util.UUIDUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Service
public class CheckVehicleCheckMenuServiceImpl
        extends ServiceImpl<CheckVehicleCheckMenuDao, CheckVehicleCheckMenu>
        implements ICheckVehicleCheckMenuService {

    /**
     * checkVehicleCheckMenuDao
     */
    @Autowired
    private CheckVehicleCheckMenuDao checkVehicleCheckMenuDao;

    @Autowired
    private ICheckCheckMenuManagementService checkCheckMenuManagementService;

    @Autowired
    private ICheckRealVehicleVerificationService checkRealVehicleVerificationService;

    @Override
    public List<CheckVehicleCheckMenu> queryByVehicleSeriesId(String vehicleSeriesId) {
        return checkVehicleCheckMenuDao.queryByVehicleSeriesId(vehicleSeriesId);
    }

    @Override
    public void queryAll( CheckVehicleCheckMenu checkVehicleCheckMenu) {
//        QueryWrapper wrapper = new QueryWrapper();
//        /**
//         * 0：选中的参数
//         */
////        wrapper.eq("PARAMETER_STATE","0");
        List<CheckCheckMenuManagement> list = checkCheckMenuManagementService.
                queryMenuInfoByObdid(checkVehicleCheckMenu.getRealMouldId());
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("VEHICLE_SERIES_ID",checkVehicleCheckMenu.getVehicleSeriesId());
        List<CheckVehicleCheckMenu> list1 = checkVehicleCheckMenuDao.selectList(queryWrapper);
        List<CheckVehicleCheckMenu> checkVehicleCheckMenuList = new ArrayList<>();
        for (CheckCheckMenuManagement data:list) {
            if (data != null) {
                CheckVehicleCheckMenu checkMenu = new CheckVehicleCheckMenu();
                checkMenu.setId(UUIDUtils.getUUID());
                checkMenu.setVehicleSeriesId(checkVehicleCheckMenu.getVehicleSeriesId());
                checkMenu.setParameterCodeOne(data.getParameterCodeOne());
                checkMenu.setParameterCodeTwo(data.getParameterCodeTwo());
                checkMenu.setParameterData(data.getParameterData());
                checkMenu.setParameterType(data.getParameterType());
                checkMenu.setParameterCheckState(0);
                checkMenu.setType("1");
                if (data.getParameterName().length() > 2 && data.getParameterName().endsWith("型号") && data.getParameterType().equals("1")) {
                    checkMenu.setIsModel("型号");
                    checkMenu.setParameterName(data.getParameterName().replace("型号", ""));
                } else if (data.getParameterName().length() > 4 && data.getParameterName().endsWith("生产企业") && data.getParameterType().equals("1")) {
                    checkMenu.setIsModel("生产企业");
                    checkMenu.setParameterName(data.getParameterName().replace("生产企业", ""));
                } else {
                    checkMenu.setIsModel("其它");
                    checkMenu.setParameterName(data.getParameterName());
                }
                Boolean flag = true;
                for (CheckVehicleCheckMenu data1 : list1) {
                    if (data1.getParameterName().equals(checkMenu.getParameterName())
                            && data1.getParameterType().equals(data.getParameterType())
                            && data1.getIsModel().equals(checkMenu.getIsModel())
                    ) {
                        flag = false;
                    }
                }
                if (flag) {
                    checkVehicleCheckMenuList.add(checkMenu);
                }
            }
        }
        if (checkVehicleCheckMenuList.size() != 0) {
            this.saveBatch(checkVehicleCheckMenuList);
        }
    }

    @Override
    public IPage<CheckVehicleCheckMenu> queryVehicleCheckMenuByPage(Page page,
                                                                    CheckVehicleCheckMenu checkVehicleCheckMenu,
                                                                    CheckRealVehicleVerificationDto checkRealVehicleVerificationDto, String isShow) {
        if (checkVehicleCheckMenu.getOrderBy() != null){
            switch (checkVehicleCheckMenu.getOrderBy()){
                case "parameterName":
                    checkVehicleCheckMenu.setOrderBy("NLSSORT(PARAMETER_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "parameterCheckState":
                    checkVehicleCheckMenu.setOrderBy("PARAMETER_CHECK_STATE");
                    break;
                default:
                    break;
            }
        }
        if (StringUtils.isNotBlank(isShow)) {
            checkVehicleCheckMenu.setOrderBy("PARAMETER_CHECK_STATE DESC,TYPE desc,ID");
        }
        if (checkVehicleCheckMenu.getParameterName() != null && checkVehicleCheckMenu.getParameterName().equals("/")){
            checkVehicleCheckMenu.setIsModel(checkVehicleCheckMenu.getParameterName());
        }
        updateType(checkVehicleCheckMenu, checkRealVehicleVerificationDto);
        List<CheckVehicleCheckMenu> list = checkVehicleCheckMenuDao.queryVehicleCheckMenuByPage(page,checkVehicleCheckMenu);
        for (CheckVehicleCheckMenu data: list) {
            if (!data.getIsModel().contains("其它")){
                if (data.getIsModel().contains("/")){
                    data.setParameterName(data.getParameterName() + data.getIsModel().split("/")[0] + "/" + data.getParameterName() + data.getIsModel().split("/")[1]);
                }else {
                    data.setParameterName(data.getParameterName() + data.getIsModel());
                }
            }
        }
        //        最终合成列表List
        page.setRecords(list);
        return page;
    }

    @Override
    public List<CheckVehicleCheckMenu> queryVehicleCheckMenu(CheckVehicleCheckMenu checkVehicleCheckMenu, CheckRealVehicleVerificationDto checkRealVehicleVerificationDto) {
        updateType(checkVehicleCheckMenu, checkRealVehicleVerificationDto);
        List<CheckVehicleCheckMenu> list = checkVehicleCheckMenuDao.queryVehicleCheckMenuByPage(checkVehicleCheckMenu);
        for (CheckVehicleCheckMenu data: list) {
            if (!data.getIsModel().equals("其它")){
                if (data.getIsModel().contains("/")){
                    data.setParameterName(data.getParameterName() + data.getIsModel().split("/")[0] + "/" + data.getParameterName() + data.getIsModel().split("/")[1]);
                }else {
                    data.setParameterName(data.getParameterName() + data.getIsModel());
                }
            }
        }
        return list;
    }

    private void updateType(CheckVehicleCheckMenu checkVehicleCheckMenu, CheckRealVehicleVerificationDto checkRealVehicleVerificationDto){
        List<CheckVehicleCheckMenu> list = checkVehicleCheckMenuDao.queryVehicleCheckMenuByPage(checkVehicleCheckMenu);
        if (list.size() == 0){
            queryAll(checkVehicleCheckMenu);
            list = checkVehicleCheckMenuDao.queryVehicleCheckMenuByPage(checkVehicleCheckMenu);
        }
        for (CheckVehicleCheckMenu data:list) {
            if (!data.getIsModel().equals("其它")){
                if (data.getIsModel().contains("/")){
                    data.setParameterName(data.getParameterName() + data.getIsModel().split("/")[0] + "/" + data.getParameterName() + data.getIsModel().split("/")[1]);
                }else {
                    data.setParameterName(data.getParameterName() + data.getIsModel());
                }
            }
            QueryWrapper<CheckRealVehicleVerification> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("VEHICLE_SERIES_ID",checkRealVehicleVerificationDto.getVehicleSeriesId());
            queryWrapper.likeLeft("ID","_"+data.getParameterType());
            if (data.getParameterType().equals("3") || data.getParameterType().equals("4")){
                queryWrapper.eq("PARAMETER",data.getParameterCodeOne());
            }else {
                queryWrapper.and(wrapper -> wrapper.eq("PARAMETER_NAME",data.getParameterName())
                        .or()
                        .eq("PARAMETER_NAME",data.getParameterName()+" 1"));
            }
            checkRealVehicleVerificationDto.setParameterData(data.getParameterData());
            checkRealVehicleVerificationDto.setParameterCodeOne(data.getParameterCodeOne());
            checkRealVehicleVerificationDto.setParameterCodeTwo(data.getParameterCodeTwo());
            checkRealVehicleVerificationDto.setParameterType(data.getParameterType());
            checkRealVehicleVerificationDto.setParameterName(data.getParameterName());
            UpdateWrapper updateWrapper = new UpdateWrapper();
            updateWrapper.in("ID",Arrays.asList(data.getId().split(",")));
            if (data.getType() == null
                    && checkRealVehicleVerificationService.count(queryWrapper) == 0
                    && !checkRealVehicleVerificationService.saveInfo(checkRealVehicleVerificationDto)){
                updateWrapper.set("TYPE","0");
                this.update(updateWrapper);
            }
        }
    }

    @Override
    public List<CheckVehicleCheckMenu> getMenuByVId(String vehicleSeriesId) {
        List<CheckVehicleCheckMenu> list = checkVehicleCheckMenuDao.getMenuByVId(vehicleSeriesId);
        for (CheckVehicleCheckMenu data:list) {
            if (!data.getIsModel().equals("其它")){
                if (data.getIsModel().contains("/")){
                    data.setParameterName(data.getParameterName() + data.getIsModel().split("/")[0] + "/" + data.getParameterName() + data.getIsModel().split("/")[1]);
                }else {
                    data.setParameterName(data.getParameterName() + data.getIsModel());
                }
            }
        }
        return list;
    }
}
