package com.adc.da.system.service.impl;


import com.adc.da.dto.reqDTO.VehicleDatabaseDetaDTO;
import com.adc.da.system.dao.VehicleDatabaseDao;
import com.adc.da.system.entity.CheckCerAndDetail;
import com.adc.da.system.entity.VehicleDatabase;
import com.adc.da.system.entity.VehicleDatabaseDetails;
import com.adc.da.system.service.IVehicleDatabaseService;
import com.adc.da.util.utils.StringUtils;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Service
public class VehicleDatabaseServiceImpl extends ServiceImpl<VehicleDatabaseDao, VehicleDatabase>
        implements IVehicleDatabaseService {

    @Autowired
    private VehicleDatabaseDao vehicleDatabaseDao;
    @Override
    public IPage<VehicleDatabase> queryByPage(Page page, VehicleDatabase vehicleDatabase) {
        if (vehicleDatabase.getOrderBy() != null){
            switch (vehicleDatabase.getOrderBy()){
                case "id":
                    vehicleDatabase.setOrderBy("ID");
                    break;
                case "fileName":
                    vehicleDatabase.setOrderBy("FILE_NAME");
                    break;
                case "modelCode":
                    vehicleDatabase.setOrderBy("MODEL_CODE");
                    break;
                case "applicant":
                    vehicleDatabase.setOrderBy("APPLICANT");
                    break;
                case "createTime":
                    vehicleDatabase.setOrderBy("CREATE_TIME");
                    break;
                case "auditStatus":
                    vehicleDatabase.setOrderBy("AUDIT_STATUS");
                    break;
                default:
                    break;
            }
        }
        List<String> baseIdList = new ArrayList<>();
        if (vehicleDatabase.getBase() != null){
            baseIdList = Arrays.asList(vehicleDatabase.getBase().split(","));
        }
        return vehicleDatabaseDao.queryByPage(page,vehicleDatabase,baseIdList);
    }

    @Override
    public IPage<CheckCerAndDetail> queryVehicleDatabaseDetailsPage(Page page, VehicleDatabaseDetails vehicleDatabaseDetails) {
        if(StringUtils.isNotBlank(vehicleDatabaseDetails.getOrderBy())){
            switch (vehicleDatabaseDetails.getOrderBy()){
                case "partName":
                    vehicleDatabaseDetails.setOrderBy("NLSSORT(PART_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "partNum":
                    vehicleDatabaseDetails.setOrderBy("NLSSORT(PART_NUM,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "cccNumCer":
                    vehicleDatabaseDetails.setOrderBy("NLSSORT(CCC_NUM_CER,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "erpireDate":
                    vehicleDatabaseDetails.setOrderBy("NLSSORT(ERPIRE_DATE,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "modelCode":
                    vehicleDatabaseDetails.setOrderBy("MODEL_CODE");
                    break;
                default:
                    vehicleDatabaseDetails.setOrderBy("TYPE");
                    vehicleDatabaseDetails.setOrder("asc");
            }
        }else {
            vehicleDatabaseDetails.setOrderBy("TYPE");
            vehicleDatabaseDetails.setOrder("asc");
        }
        if (vehicleDatabaseDetails.getOrder() != null && "normal".equals(vehicleDatabaseDetails.getOrder())) {
            vehicleDatabaseDetails.setOrder(null);
        }
        return vehicleDatabaseDao.queryVehicleDatabaseDetailsPage(page,vehicleDatabaseDetails);
    }

    @Override
    public List<VehicleDatabaseDetaDTO> queryVehicleDatabaseDetails(VehicleDatabaseDetails vehicleDatabaseDetails) {
        List<String> list = new ArrayList<>();
        if(StringUtils.isNotBlank(vehicleDatabaseDetails.getPartNum())) {
            list = Arrays.asList(vehicleDatabaseDetails.getPartNum().split(","));
        }
        return vehicleDatabaseDao.queryVehicleDatabaseDetails(vehicleDatabaseDetails,list);
    }
}
