package com.adc.da.system.service.impl;


import com.adc.da.dto.ocr.CertificateEO;
import com.adc.da.dto.reqDTO.CertificateReqDTO;
import com.adc.da.dto.reqDTO.DataCheckReqDTO;
import com.adc.da.dto.resDTO.CertificateResDTO;
import com.adc.da.dto.resDTO.DataCheckDTO;
import com.adc.da.system.dao.CheckCertificateInfoDetailDao;
import com.adc.da.system.dao.CheckCertificateMainInfoDao;
import com.adc.da.system.entity.CdVehicles;
import com.adc.da.system.entity.CheckBulletinDataParameter;
import com.adc.da.system.entity.CheckCertificateInfoDetail;
import com.adc.da.system.entity.CheckCertificateMainInfo;
import com.adc.da.system.entity.CheckDataCheckResult;
import com.adc.da.system.service.ICheckCertificateInfoDetailService;
import com.adc.da.system.service.ICheckCertificateMainInfoService;
import com.adc.da.system.service.ICheckDataCheckResultService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.util.utils.UUID;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.SneakyThrows;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;


///**
// * <p>
// * 证书一致性校验
// * </p>
// *
// * @author 韩飞
// * @since 2019-09-27
// */
@Transactional
@Service
public class CheckCertificateMainInfoServiceImpl
        extends ServiceImpl<CheckCertificateMainInfoDao, CheckCertificateMainInfo>
        implements ICheckCertificateMainInfoService {
//
//    @Autowired
//    private ICdVehiclesService iCdVehiclesService;
//
////    @Autowired
////    private ICOCDetailService icocDetailService;
//
//    @Lazy
//    @Autowired
//    private IEnvDataService iEnvDataService;
//
    @Autowired
    private ICheckDataCheckResultService iCheckDataCheckResultService;
//
    @Autowired
    private ICheckCertificateInfoDetailService iCheckCertificateInfoDetailService;

    @Autowired
    private CheckCertificateInfoDetailDao checkCertificateInfoDetailDao;
//
////    @Autowired
////    private ICheckStandardService iCheckStandardService;
//
//    @Autowired
//    private HttpServletRequest request;
//    @Autowired
//    private ICheckOperationLogService iCheckOperationLogService;
//
//    @Autowired
//    private ICheckBulletinDataParameterService iCheckBulletinDataParameterService;
//
//    /**
//     * 分页查询随车文件一致性数据
//     *
//     * @param certificatePage
//     * @return
//     */
    @Override
    public IPage<CertificateResDTO> queryByPage(CertificateReqDTO certificatePage) {
        IPage pages = new Page(certificatePage.getPage(), certificatePage.getPageSize());
        List<CertificateResDTO> certificateResDTOIPage = new ArrayList<>();
        if (StringUtils.isEmpty(certificatePage.getOrder()) || "normal".equals(certificatePage.getOrder())) {
            certificateResDTOIPage = this.baseMapper.queryByPageOrderByGroup(certificatePage);
        } else {
            certificateResDTOIPage = this.baseMapper.queryByPage(certificatePage);
        }
        int total = this.baseMapper.getCount(certificatePage);
        pages.setRecords(certificateResDTOIPage);
        pages.setTotal(total);
        return pages;
    }
//
//    /**
//     * 随车文件一致性复制新增
//     *
//     * @param certificate
//     * @return
//     */
    @Override
    @Transactional
    public int add(CheckCertificateMainInfo certificate) {
        int result = 0;
        if (StringUtils.isNotEmpty(certificate.getVehicleModel())
                && StringUtils.isNotEmpty(certificate.getVehicleGroup())) {
            /*List<CheckCertificateMainInfo> list = this.baseMapper.selectList(
                    new QueryWrapper<CheckCertificateMainInfo>()
                            .eq("VEHICLE_MODEL", certificate.getVehicleModel())
                            .eq("VEHICLE_GROUP", certificate.getVehicleGroup())
                            .orderByDesc("VERSION"));*/
            CheckCertificateMainInfo checkCertificateMainInfo = this.baseMapper.getVersion(certificate);
            //String version = list.get(0).getVersion();
            certificate.setId(UUID.randomUUID());
            certificate.setCheckState("0");
            certificate.setOperator("");
            certificate.setCheckDate(null);
            certificate.setRemark("");
            int i = Integer.parseInt(checkCertificateMainInfo.getVersion());
            certificate.setVersion(String.valueOf(i + 1));
            result = this.baseMapper.insert(certificate);
        }
        return result;
    }
//
//    /**
//     * 随车文件一致性删除复制数据
//     *
//     * @param id
//     * @return
//     */
    @Override
    @Transactional
    public int delCertificate(String id) {
        int result = this.baseMapper.deleteById(id);
        if (result > 0) {
            QueryWrapper delWrapper = new QueryWrapper();
            delWrapper.eq("INFO_ID", id);
            iCheckCertificateInfoDetailService.getBaseMapper().delete(delWrapper);
            return result;
        }
        return 0;
    }
//
//    @Override
//    public int delByGroup(String group) {
//        QueryWrapper delWrapper = new QueryWrapper();
//        delWrapper.eq("VEHICLE_GROUP", group);
//        return baseMapper.delete(delWrapper);
//    }
//
    @Override
    @Transactional
    public int updateInfoDetail(String detialId, String json) {
        CheckCertificateInfoDetail checkCertificateInfoDetail
                = iCheckCertificateInfoDetailService.getBaseMapper().selectById(detialId);
        checkCertificateInfoDetail.setContent(json);
        int result = iCheckCertificateInfoDetailService.getBaseMapper().updateById(checkCertificateInfoDetail);

        return result;
    }

    @Override
    public ResponseMessage certificateDataCheck(CertificateEO certificateEO, String type,
                                                String carTypeCode, String id, String group) {
        List<CdVehicles> cdVehiclesList = checkCertificateInfoDetailDao.getClcpZk(carTypeCode, group);
        List<CheckDataCheckResult> checkResults = new ArrayList<>();
        List<DataCheckDTO> dataCheckDTOS = new ArrayList<>();

        if (cdVehiclesList != null && !cdVehiclesList.isEmpty()) {
            CdVehicles cdVehicles = cdVehiclesList.get(0);
            dataCheck("车辆制造企业名称", type, certificateEO.getNameOfCompany(),
                    cdVehicles.getEntName(), checkResults, id, dataCheckDTOS);

            dataCheck("车辆品牌", type, certificateEO.getVehicleBrands(),
                    cdVehicles.getZwpp(), checkResults, id, dataCheckDTOS);

            dataCheck("车辆名称", type, certificateEO.getNameOfVehicle(),
                    cdVehicles.getVehicleName(), checkResults, id, dataCheckDTOS);

            String vehicleModel = certificateEO.getVehicleModel();
            if (StringUtils.isNotEmpty(vehicleModel)) {
                vehicleModel = vehicleModel.toUpperCase().replaceAll("I", "1").replaceAll("O", "0");
            }
            dataCheck("车辆型号", type, vehicleModel,
                    cdVehicles.getVehicleModel(), checkResults, id, dataCheckDTOS);

//            dataCheck("车辆识别代号", type, certificateEO.getVehicleIDNumber(),
//                    cdVehicles.getProductNo(), checkResults, id, dataCheckDTOS);

//            dataCheck("底盘型号", type, certificateEO.getChassisModel(),
//                    cdVehicles.getDpxh(), checkResults, id, dataCheckDTOS);

            String fdjxh = "";
            String fdjxhData = "";
            if (StringUtils.isNotEmpty(certificateEO.getEngineModel())) {
                fdjxh = certificateEO.getEngineModel().toUpperCase().replaceAll("O", "0");
            }
            if (StringUtils.isNotEmpty(cdVehicles.getFdjxh())) {
                fdjxhData = cdVehicles.getFdjxh().toUpperCase().replaceAll("O", "0");

            }
            dataCheck("发动机型号", type, fdjxh,
                    fdjxhData, checkResults, id, dataCheckDTOS);

            dataCheck("燃料种类", type, certificateEO.getFuelType(),
                    cdVehicles.getFuelType(), checkResults, id, dataCheckDTOS);

            dataCheck("排量", type, certificateEO.getExhaustVolume(),
                    cdVehicles.getFdjpl(), checkResults, id, dataCheckDTOS);

            dataCheck("功率", type, certificateEO.getPower(),
                    cdVehicles.getFdjgl(), checkResults, id, dataCheckDTOS);

            if (StringUtils.isNotEmpty(certificateEO.getEmissionStandards())) {
                dataCheck("排放标准", type, certificateEO.getEmissionStandards(),
                        cdVehicles.getEmissionStandard(), checkResults, id, dataCheckDTOS);
            } else {
                dataCheck("排放标准", type, "",
                        cdVehicles.getEmissionStandard(), checkResults, id, dataCheckDTOS);
            }

            dataCheck("油耗", type, certificateEO.getFuelConsumption(),
                    cdVehicles.getYh(), checkResults, id, dataCheckDTOS);

            List<String> length = new ArrayList<>();
            if (StringUtils.isNotEmpty(cdVehicles.getVehicleLength())) {
                length = Arrays.asList(cdVehicles.getVehicleLength().trim().split(","));
            }
            if (length.contains(certificateEO.getLengthOfOutline().trim())) {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "外廓长",
                        "0", type, certificateEO.getLengthOfOutline(),
                        cdVehicles.getVehicleLength()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "外廓长",
                        "0", type, certificateEO.getLengthOfOutline(),
                        cdVehicles.getVehicleLength()));
            } else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "外廓长",
                        "1", type, certificateEO.getLengthOfOutline(),
                        cdVehicles.getVehicleLength()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "外廓长",
                        "1", type, certificateEO.getLengthOfOutline(),
                        cdVehicles.getVehicleLength()));
            }
//            dataCheck("外廓长", type, certificateEO.getLengthOfOutline(),
//                    cdVehicles.getVehicleLength(), checkResults, id, dataCheckDTOS);

            length = new ArrayList<>();
            if (StringUtils.isNotEmpty(cdVehicles.getWidth())) {
                length = Arrays.asList(cdVehicles.getWidth().trim().split(","));
            }
            if (length.contains(certificateEO.getWidthOfOutline().trim())) {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "外廓宽",
                        "0", type, certificateEO.getWidthOfOutline(),
                        cdVehicles.getWidth()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "外廓宽",
                        "0", type, certificateEO.getWidthOfOutline(),
                        cdVehicles.getWidth()));
            } else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "外廓宽",
                        "1", type, certificateEO.getWidthOfOutline(),
                        cdVehicles.getWidth()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "外廓宽",
                        "1", type, certificateEO.getWidthOfOutline(),
                        cdVehicles.getWidth()));
            }
//            dataCheck("外廓宽", type, certificateEO.getWidthOfOutline(),
//                    cdVehicles.getWidth(), checkResults, id, dataCheckDTOS);

            length = new ArrayList<>();
            if (StringUtils.isNotEmpty(cdVehicles.getHeight())) {
                length = Arrays.asList(cdVehicles.getHeight().trim().split(","));
            }
            if (length.contains(certificateEO.getHeightOfOutline().trim())) {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "外廓高",
                        "0", type, certificateEO.getHeightOfOutline(),
                        cdVehicles.getHeight()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "外廓高",
                        "0", type, certificateEO.getHeightOfOutline(),
                        cdVehicles.getHeight()));
            } else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "外廓高",
                        "1", type, certificateEO.getHeightOfOutline(),
                        cdVehicles.getHeight()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "外廓高",
                        "1", type, certificateEO.getHeightOfOutline(),
                        cdVehicles.getHeight()));
            }
//            dataCheck("外廓高", type, certificateEO.getHeightOfOutline(),
//                    cdVehicles.getHeight(), checkResults, id, dataCheckDTOS);

            dataCheck("货厢内部尺寸长", type, certificateEO.getLengthOfCargoInteriorSize(),
                    cdVehicles.getGateLength(), checkResults, id, dataCheckDTOS);

            dataCheck("货厢内部尺寸宽", type, certificateEO.getWidthOfCargoInteriorSize(),
                    cdVehicles.getGateWidth(), checkResults, id, dataCheckDTOS);

            dataCheck("货厢内部尺寸高", type, certificateEO.getHeightOfCargoInteriorSize(),
                    cdVehicles.getGateHeight(), checkResults, id, dataCheckDTOS);


            String numberOfLeafSprings = "";
            if (StringUtils.isNotEmpty(certificateEO.getNumberOfLeafSprings())) {
                numberOfLeafSprings = certificateEO.getNumberOfLeafSprings().replaceAll(" ", "")
                        .replaceAll("-", "");
            }
            if ("-/-".equalsIgnoreCase(cdVehicles.getSpringLeafCount()) && "".
                    equalsIgnoreCase(numberOfLeafSprings)) {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "钢板弹簧片数",
                        "0", type, certificateEO.getNumberOfLeafSprings(), cdVehicles.getSpringLeafCount()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "钢板弹簧片数",
                        "0", type, certificateEO.getNumberOfLeafSprings(), cdVehicles.getSpringLeafCount()));
            } else {
                dataCheck("钢板弹簧片数", type, certificateEO.getNumberOfLeafSprings(),
                        cdVehicles.getSpringLeafCount(), checkResults, id, dataCheckDTOS);
            }

            dataCheck("轮胎数", type, certificateEO.getTireNumber(),
                    cdVehicles.getTyreCount(), checkResults, id, dataCheckDTOS);

            String tyreSize = "";
            if (StringUtils.isNotEmpty(cdVehicles.getTyreSize())) {
                tyreSize = cdVehicles.getTyreSize();
            }

            if (tyreSize.contains(certificateEO.getTireSpecification())) {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "轮胎规格",
                        "0", type, certificateEO.getTireSpecification(),
                        cdVehicles.getTyreSize()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "轮胎规格",
                        "0", type, certificateEO.getTireSpecification(),
                        cdVehicles.getTyreSize()));
            } else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "轮胎规格",
                        "1", type, certificateEO.getTireSpecification(),
                        cdVehicles.getTyreSize()));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "轮胎规格",
                        "1", type, certificateEO.getTireSpecification(),
                        cdVehicles.getTyreSize()));
            }

//            dataCheck("轮胎规格", type, certificateEO.getTireSpecification(),
//                    cdVehicles.getTyreSize(), checkResults, id, dataCheckDTOS);


            dataCheck("轮距前", type, certificateEO.getFrontTireDistance(),
                    cdVehicles.getFrontTrack(), checkResults, id, dataCheckDTOS);

            dataCheck("轮距后", type, certificateEO.getRearTireDistance(),
                    cdVehicles.getRearTrack(), checkResults, id, dataCheckDTOS);

            dataCheck("轴距", type, certificateEO.getWheelbase(),
                    cdVehicles.getWheelSpace(), checkResults, id, dataCheckDTOS);

            dataCheck("轴荷", type, certificateEO.getAxleLoad(),
                    cdVehicles.getAxleLoad(), checkResults, id, dataCheckDTOS);

            dataCheck("轴数", type, certificateEO.getAxisNumber(),
                    cdVehicles.getAxleCount(), checkResults, id, dataCheckDTOS);

            dataCheck("转向形式", type, certificateEO.getSteeringType(),
                    cdVehicles.getSteeringType(), checkResults, id, dataCheckDTOS);

            dataCheck("总质量", type, certificateEO.getTotalWeight(),
                    cdVehicles.getTotalMass(), checkResults, id, dataCheckDTOS);

            dataCheck("整备质量", type, certificateEO.getEmptyCarWeight(),
                    cdVehicles.getKerbMass(), checkResults, id, dataCheckDTOS);

            dataCheck("额定载质量", type, certificateEO.getRatedTotalWeight(),
                    cdVehicles.getRatedContainedMass(), checkResults, id, dataCheckDTOS);

            List<String> dpxhList = new ArrayList<>();
            dpxhList.add(cdVehicles.getDpxh1());
            dpxhList.add(cdVehicles.getDpxh2());
            dpxhList.add(cdVehicles.getDpxh3());
            dpxhList.add(cdVehicles.getDpxh4());
            if(dpxhList.contains(certificateEO.getChassisModel())){
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "底盘型号",
                        "0", type, certificateEO.getChassisModel(),
                        StringUtils.join(dpxhList,",")));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "底盘型号",
                        "0", type, certificateEO.getChassisModel(),
                        StringUtils.join(dpxhList,",")));
            }else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "底盘型号",
                        "1", type, certificateEO.getChassisModel(),
                        StringUtils.join(dpxhList,",")));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "底盘型号",
                        "1", type, certificateEO.getChassisModel(),
                        StringUtils.join(dpxhList,",")));
            }
//            dataCheck("底盘型号", type, certificateEO.getChassisModel(),
//                    cdVehicles.getDpxh1(), checkResults, id, dataCheckDTOS);
//            QueryWrapper wrapper = new QueryWrapper();
//            wrapper.eq("CAR_ID", cdVehicles.getId());
//            wrapper.eq("PARAMETER_SEQ", "QA0034");
//            List<CheckBulletinDataParameter> list = iCheckBulletinDataParameterService.list(wrapper);
//            CheckBulletinDataParameter checkBulletinDataParameter = new CheckBulletinDataParameter();
//            if (!list.isEmpty()) {
//                checkBulletinDataParameter = list.get(0);
//            }
            List<String> dpIdList = new ArrayList<>();
            dpIdList.add(cdVehicles.getDpid1());
            dpIdList.add(cdVehicles.getDpid2());
            dpIdList.add(cdVehicles.getDpid3());
            dpIdList.add(cdVehicles.getDpid4());
            if(dpIdList.contains(certificateEO.getChassisID())){
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "底盘ID",
                        "0", type, certificateEO.getChassisID(),
                        StringUtils.join(dpIdList,",")));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "底盘ID",
                        "0", type, certificateEO.getChassisID(),
                        StringUtils.join(dpIdList,",")));
            }else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
                        "底盘ID",
                        "1", type, certificateEO.getChassisID(),
                        StringUtils.join(dpIdList,",")));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
                        "底盘ID",
                        "1", type, certificateEO.getChassisID(),
                        StringUtils.join(dpIdList,",")));
            }
//            dataCheck("底盘ID", type, certificateEO.getChassisID(),
//                    cdVehicles.getDpid1(), checkResults, id, dataCheckDTOS);
//            wrapper = new QueryWrapper();
//            wrapper.eq("CAR_ID", cdVehicles.getId());
//            wrapper.eq("PARAMETER_SEQ", "QA0025");
//            list = iCheckBulletinDataParameterService.list(wrapper);
//            checkBulletinDataParameter = new CheckBulletinDataParameter();
//            if (!list.isEmpty()) {
//                checkBulletinDataParameter = list.get(0);
//            }
            dataCheck("额定载客", type, certificateEO.getRatedPassenger(),
                    cdVehicles.getRatedPassCap(), checkResults, id, dataCheckDTOS);
//            dataCheck("车辆制造企业其它信息（新能源车）", type, certificateEO.getChassisModel(),
//            cdVehicles.getDpxh(), checkResults, id, dataCheckDTOS);

            dataCheck("驾驶室准乘人数", type, certificateEO.getNumberOfPassengersInTheCab(),
                    cdVehicles.getCabPopulation(), checkResults, id, dataCheckDTOS);

            dataCheck("最高设计车速", type, certificateEO.getHighestDesignSpeed(),
                    cdVehicles.getMaxSpeed(), checkResults, id, dataCheckDTOS);
            String other = certificateEO.getOther();
            String vehicleOther = cdVehicles.getVehicleOther();
            List<String> otherList = new ArrayList<>();
            boolean flag = true;
            if (StringUtils.isEmpty(other)) {
                other = "";
            }
            if (StringUtils.isEmpty(vehicleOther)) {
                vehicleOther = "";
            }
            List<String> end = new ArrayList<>();
            otherList = Arrays.asList(other.replaceAll("选装", "").split("\\."));
            for (String str : otherList) {
                end.addAll(Arrays.asList(str.split(",")));
            }
            for (String str : end) {
                if (!vehicleOther.contains(str)) {
                    flag = false;
                }
            }
            if (flag) {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "备注",
                        "0", type, certificateEO.getOther(), vehicleOther));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "备注",
                        "0", type, certificateEO.getOther(), vehicleOther));
            } else {
                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "备注",
                        "1", type, certificateEO.getOther(), vehicleOther));
                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "备注",
                        "1", type, certificateEO.getOther(), vehicleOther));
            }

//            dataCheck("备注", type, certificateEO.getOther(),
//                    cdVehicles.getVehicleOther(), checkResults, id, dataCheckDTOS);
            String code = "";
            String name = "";
            boolean flag2 = true;
            if (StringUtils.isNotEmpty(certificateEO.getCheckInformation())
                    && certificateEO.getCheckInformation().length() > 10) {
                String str = certificateEO.getCheckInformation().replaceAll(" ", "").toUpperCase();
                int codeIndex = str.indexOf("《");
                int endIndex = str.indexOf("》");
                if (codeIndex < 10 || codeIndex > endIndex) {
                    flag2 = false;
                } else {
                    code = str.substring(10, codeIndex);
                    name = str.substring(codeIndex + 1, endIndex);
                }
            } else {
                flag2 = false;
            }
//            List<CheckStandard> checkStandardList =
//                    iCheckStandardService.getStandardNameByCode(cdVehicles.getVehicleModel());
//            if (checkStandardList == null || checkStandardList.isEmpty()) {
//                flag2 = false;
//            }
//            if (flag2) {
//                CheckStandard checkStandard = new CheckStandard();
//                for (CheckStandard standard:checkStandardList) {
//                    if (standard.getStandardCode().replace(" ","").equalsIgnoreCase(code.replace(" ",""))
//                            && standard.getStandardName().replace(" ","").equalsIgnoreCase(name.replace(" ",""))){
//                        checkStandard = standard;
//                    }
//                }
//                String names = checkStandardList.stream().map(CheckStandard::getStandardName).collect(Collectors.joining(",")).replace(" ","");
//                String dataCode = checkStandardList.stream().map(CheckStandard::getStandardCode).collect(Collectors.joining(",")).replace(" ","");
//                if (names.contains(name) && dataCode.contains(code)) {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "产品检验信息",
//                            "0", type, "标准号：" + code + "；标准名称：" + name, "标准号：" + dataCode + "；标准名称：" + names));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "产品检验信息",
//                            "0", type, "标准号：" + code + "；标准名称：" + name, "标准号：" + dataCode + "；标准名称：" + names));
//                } else {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "产品检验信息",
//                            "1", type, "标准号：" + code + "；标准名称：" + name, "标准号：" + dataCode + "；标准名称：" + names));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "产品检验信息",
//                            "1", type, "标准号：" + code + "；标准名称：" + name, "标准号：" + dataCode + "；标准名称：" + names));
//                }
//            } else {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "产品检验信息",
//                        "1", type, certificateEO.getCheckInformation(), "空"));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "产品检验信息",
//                        "1", type, certificateEO.getCheckInformation(), "空"));
//            }

            iCheckDataCheckResultService.saveBatch(checkResults);
            return Result.success(this.sort(dataCheckDTOS));
        }
        return Result.error("该车型无公告数据");
    }

//    @Override
//    public ResponseMessage COCDataCheck(COCDataCheckDTO cocDataCheckDTO, String type,
//                                        String carTypeCode, String id, String group) {
//        //先对比公有参数项
//
//        List<CheckDataCheckResult> checkResults = new ArrayList<>();
//        List<DataCheckDTO> dataCheckDTOS = new ArrayList<>();
//        String code = "";
//        if (StringUtils.isEmpty(cocDataCheckDTO.getCertificateCode())) {
//            return Result.error("识别结果中没有一致性证书编号");
//        }
//        code = cocDataCheckDTO.getCertificateCode().toUpperCase().replaceAll("O", "0")
//                .replaceAll("I", "1");
//        List<COCDetailInformation> cocDetailInformationList
//                = icocDetailService.getByCOCInformationId(code);
//        if (cocDetailInformationList != null && !cocDetailInformationList.isEmpty()) {
//            COCDetailInformation cocDetailInformation = cocDetailInformationList.get(0);
//
//            dataCheck("一致性证书编号", type, code,
//                    cocDetailInformation.getCocId(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车辆生产企业名称", type, cocDataCheckDTO.getCarProduceEnterpriseName(),
//                    cocDetailInformation.getCocFactoryName(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车辆生产企业地址", type, cocDataCheckDTO.getCarProduceEnterpriseAddress(),
//                    cocDetailInformation.getCarMakeAddress(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("生产者（制造商）名称", type, cocDataCheckDTO.getManufacturerAddress(),
//                    cocDetailInformation.getCocManufacturerName(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("是否为新能源车", type, cocDataCheckDTO.getIsNewEnergy(),
//                    cocDetailInformation.getCarIsXinnengyuan(), checkResults, id, dataCheckDTOS);
//
//            boolean dkFlag = true;
//            List<String> dk = new ArrayList<>();
//            String dkwz = "";
//            if (StringUtils.isNotEmpty(cocDetailInformation.getCarIdentiCodeLoaction())) {
//                dkwz = cocDetailInformation.getCarIdentiCodeLoaction();
//            }
//            if (StringUtils.isNotEmpty(cocDataCheckDTO.getCarCodeCarvingPosition())) {
//                dk = Arrays.asList(cocDataCheckDTO.getCarCodeCarvingPosition().split(","));
//            }
//            for (int i = 0; i < dk.size(); i++) {
//                if (!dkwz.contains(dk.get(i))) {
//                    dkFlag = false;
//                }
//            }
//            if (dk.isEmpty() && StringUtils.isNotEmpty(dkwz.trim())) {
//                dkFlag = false;
//            }
//            if (!dk.isEmpty() && StringUtils.isEmpty(dkwz.trim())) {
//                dkFlag = false;
//            }
//            if (dkFlag) {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
//                        "车辆识别代号打刻位置",
//                        "0", type, cocDataCheckDTO.getCarCodeCarvingPosition(),
//                        cocDetailInformation.getCarIdentiCodeLoaction()));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
//                        "车辆识别代号打刻位置",
//                        "0", type, cocDataCheckDTO.getCarCodeCarvingPosition(),
//                        cocDetailInformation.getCarIdentiCodeLoaction()));
//            } else {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
//                        "车辆识别代号打刻位置",
//                        "1", type, cocDataCheckDTO.getCarCodeCarvingPosition(),
//                        cocDetailInformation.getCarIdentiCodeLoaction()));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
//                        "车辆识别代号打刻位置",
//                        "1", type, cocDataCheckDTO.getCarCodeCarvingPosition(),
//                        cocDetailInformation.getCarIdentiCodeLoaction()));
//            }
////            dataCheck("车辆识别代号打刻位置", type, cocDataCheckDTO.getCarCodeCarvingPosition(),
////                    cocDetailInformation.getCarIdentiCodeLoaction(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("法定标牌的位置", type, cocDataCheckDTO.getLegalSignsPosition(),
//                    cocDetailInformation.getCarNameplateLocation(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车型名称", type, cocDataCheckDTO.getVehicleTypeName(),
//                    cocDetailInformation.getCarModelName(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车辆注册类型", type, cocDataCheckDTO.getVehicleRegistrationType(),
//                    cocDetailInformation.getVehicleregtype(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车辆品牌", type, cocDataCheckDTO.getVehicleBrand(),
//                    cocDetailInformation.getCarChineseName() + "/" +
//                            cocDetailInformation.getCarEnglishName(), checkResults, id, dataCheckDTOS);
//
//            String vehicleModel = cocDataCheckDTO.getVehicleModel();
//            if (StringUtils.isNotEmpty(vehicleModel)) {
//                vehicleModel = vehicleModel.toUpperCase().replaceAll("I", "1")
//                        .replaceAll("O", "0");
//            }
//            dataCheck("车辆型号", type, vehicleModel,
//                    cocDetailInformation.getCarTypeCode(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车辆类别", type, cocDataCheckDTO.getCarType(),
//                    cocDetailInformation.getCarType(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车轴数量", type, cocDataCheckDTO.getAxleNumber(),
//                    cocDetailInformation.getCarAxleNumber(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("驱动轴位置", type, cocDataCheckDTO.getDriveShaftPosition(),
//                    cocDetailInformation.getCarDriveShaftLocation(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("轮距", type, cocDataCheckDTO.getTread(),
//                    cocDetailInformation.getCarWheelDistance(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("轴距", type, cocDataCheckDTO.getWheelBase(),
//                    cocDetailInformation.getCarAxleDistance(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车轮数量", type, cocDataCheckDTO.getWheelNumber(),
//                    cocDetailInformation.getCarWheelNumber(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("前悬/后悬 ", type, cocDataCheckDTO.getFrontAndRearSuspensions(),
//                    cocDetailInformation.getCarFrontOverhang() + "/"
//                            + cocDetailInformation.getCarRearOverhang(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("外廓尺寸", type, cocDataCheckDTO.getExternalDimensions(),
//                    cocDetailInformation.getCarLength() + "/" + cocDetailInformation.getCarWidth() + "/"
//                            + cocDetailInformation.getCarHight(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("接近角/离去角", type, cocDataCheckDTO.getApproachAngleAndDepartureAngle(),
//                    cocDetailInformation.getCarApproachAngles() + "/"
//                            + cocDetailInformation.getCarDepartureAngles(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("整备质量", type, cocDataCheckDTO.getCurbWeight(),
//                    cocDetailInformation.getCarCurbWeight(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("最大允许总质量", type, cocDataCheckDTO.getMaxGVW(),
//                    cocDetailInformation.getCarTotalWeight(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("离合器型式", type, cocDataCheckDTO.getClutchModel(),
//                    cocDetailInformation.getCarClutch(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("转向型式", type, cocDataCheckDTO.getSteeringModel(),
//                    cocDetailInformation.getCarSteeringMode(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("车门数量和结构", type, cocDataCheckDTO.getCarDoorNumAndStructure(),
//                    cocDetailInformation.getCarDoorNumber() + "/"
//                            + cocDetailInformation.getCarDoorStructure(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("最大允许总质量对应的轴荷分配", type, cocDataCheckDTO.getAxleLoadDistribution(),
//                    cocDetailInformation.getCarAxialLoadDistribution(), checkResults, id, dataCheckDTOS);
//
////            String carTransmission = cocDetailInformation.getCarTransmission();
////            if ("mt".equalsIgnoreCase(carTransmission)) {
////                carTransmission = "手动";
////            }
////            if ("at".equalsIgnoreCase(carTransmission)) {
////                carTransmission = "自动";
////            }
////            String carTransmissionData = cocDataCheckDTO.getTransmissionModel();
////            if ("mt".equalsIgnoreCase(carTransmissionData)) {
////                carTransmissionData = "手动";
////            }
////            if ("at".equalsIgnoreCase(carTransmissionData)) {
////                carTransmissionData = "自动";
////            }
//            dataCheck("变速器型式", type, cocDataCheckDTO.getTransmissionModel(),
//                    cocDetailInformation.getCarTransmission(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("最高设计车速", type, cocDataCheckDTO.getMaxSpeed(),
//                    cocDetailInformation.getCarMaxSpeed(), checkResults, id, dataCheckDTOS);
//
//            List<String> tyreSize = new ArrayList<>();
//            if (StringUtils.isNotEmpty(cocDetailInformation.getCarTireSpecification())) {
//                tyreSize = Arrays.asList(cocDetailInformation.getCarTireSpecification().replace("@", ";").split(";"));
//            }
//            List<String> data = new ArrayList<>();
//            if (StringUtils.isNotBlank(cocDataCheckDTO.getTireSpecification())) {
//                data = Arrays.asList(cocDataCheckDTO.getTireSpecification().split(","));
//            }
//            String tyreSizeStr = "";
//            boolean flag3 = true;
//            for (int i = 0; i < data.size(); i++) {
//                for (int j = 0; j < tyreSize.size(); j++) {
//                    tyreSizeStr = tyreSize.get(j).indexOf(" ") > 0 ? tyreSize.get(j).substring(0,
//                            tyreSize.get(j).indexOf(
//                                    " ")) : tyreSize.get(j);
//                    if (!tyreSizeStr.equalsIgnoreCase(data.get(i))) {
//                        flag3 = false;
//                    }
//                }
//            }
//            if (flag3) {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
//                        "轮胎规格",
//                        "0", type, cocDataCheckDTO.getTireSpecification(),
//                        cocDetailInformation.getCarTireSpecification()));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
//                        "轮胎规格",
//                        "0", type, cocDataCheckDTO.getTireSpecification(),
//                        cocDetailInformation.getCarTireSpecification()));
//            } else {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
//                        "轮胎规格",
//                        "1", type, cocDataCheckDTO.getTireSpecification(),
//                        cocDetailInformation.getCarTireSpecification()));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
//                        "轮胎规格",
//                        "1", type, cocDataCheckDTO.getTireSpecification(),
//                        cocDetailInformation.getCarTireSpecification()));
//            }
////            dataCheck("轮胎规格", type, cocDataCheckDTO.getTireSpecification(),
////                    cocDetailInformation.getCarTireSpecification(), checkResults, id, dataCheckDTOS);
//
//            List<String> carBrakeBriefDescription =
//                    Arrays.asList(cocDetailInformation.getCarBrakeBriefDescription().replace(",", "，")
//                            .split("，"));
//            String[] descriptionOfBrakeDevice = cocDataCheckDTO.getDescriptionOfBrakeDevice().replace(",", "，").split(
//                    "，");
//            boolean flag2 = true;
//            for (int i = 0; i < descriptionOfBrakeDevice.length; i++) {
//                if (!carBrakeBriefDescription.contains(descriptionOfBrakeDevice[i])) {
//                    flag2 = false;
//                }
//            }
//            if (flag2) {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "制动装置简要说明",
//                        "0", type, cocDataCheckDTO.getDescriptionOfBrakeDevice(),
//                        cocDetailInformation.getCarBrakeBriefDescription()));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "制动装置简要说明",
//                        "0", type, cocDataCheckDTO.getDescriptionOfBrakeDevice(),
//                        cocDetailInformation.getCarBrakeBriefDescription()));
//            } else {
//                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "制动装置简要说明",
//                        "1", type, cocDataCheckDTO.getDescriptionOfBrakeDevice(),
//                        cocDetailInformation.getCarBrakeBriefDescription()));
//                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "制动装置简要说明",
//                        "1", type, cocDataCheckDTO.getDescriptionOfBrakeDevice(),
//                        cocDetailInformation.getCarBrakeBriefDescription()));
//            }
////            dataCheck("制动装置简要说明", type, cocDataCheckDTO.getDescriptionOfBrakeDevice(),
////                    cocDetailInformation.getCarBrakeBriefDescription(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("是否有防抱死系统", type, cocDataCheckDTO.getIsHaveABS(),
//                    cocDetailInformation.getCarIsBaosi(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("额定载客人数", type, cocDataCheckDTO.getRatedNumberOfPassengers(),
//                    cocDetailInformation.getCarRatedCapacity(), checkResults, id, dataCheckDTOS);
//
////            dataCheck("速比", type, cocDataCheckDTO.getSpeedRatio().replaceAll(",", ""),
////                    cocDetailInformation.getCarSpeedRatio(), checkResults, id, dataCheckDTOS);
//
//            if (StringUtils.isNotEmpty(cocDataCheckDTO.getSpeedRatio())) {
//                String[] dataArr = cocDataCheckDTO.getSpeedRatio().split("/");
//                boolean flag = true;
//                String str = "";
//                for (int i = 0; i < dataArr.length; i++) {
//                    str = dataArr[i];
//                    if (str.substring(str.length() - 1, str.length()).equals("0")) {
//                        str = str.substring(0, str.length() - 1);
//                    }
//                    if (!cocDetailInformation.getCarSpeedRatio().contains(str)) {
//                        flag = false;
//                    }
//                }
//                if (flag) {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "速比",
//                            "0", type, cocDataCheckDTO.getSpeedRatio(),
//                            cocDetailInformation.getCarSpeedRatio()));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "速比",
//                            "0", type, cocDataCheckDTO.getSpeedRatio(),
//                            cocDetailInformation.getCarSpeedRatio()));
//                } else {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "速比",
//                            "1", type, cocDataCheckDTO.getSpeedRatio(),
//                            cocDetailInformation.getCarSpeedRatio()));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "速比",
//                            "1", type, cocDataCheckDTO.getSpeedRatio(),
//                            cocDetailInformation.getCarSpeedRatio()));
//
//                }
//            }
//
////            dataCheck("主传动比", type, cocDataCheckDTO.getMainTransmissionRatio(),
////                    cocDetailInformation.getCarMainDriveRatio(), checkResults, id, dataCheckDTOS);
//
//            if (StringUtils.isNotEmpty(cocDataCheckDTO.getMainTransmissionRatio())) {
//                String[] dataArr = cocDataCheckDTO.getMainTransmissionRatio().split("/");
//                boolean flag = true;
//                for (int i = 0; i < dataArr.length; i++) {
//                    if (!cocDetailInformation.getCarMainDriveRatio().contains(dataArr[i])) {
//                        flag = false;
//                    }
//                }
//                if (flag) {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "主传动比",
//                            "0", type, cocDataCheckDTO.getMainTransmissionRatio(),
//                            cocDetailInformation.getCarMainDriveRatio()));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "主传动比",
//                            "0", type, cocDataCheckDTO.getMainTransmissionRatio(),
//                            cocDetailInformation.getCarMainDriveRatio()));
//                } else {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "主传动比",
//                            "1", type, cocDataCheckDTO.getMainTransmissionRatio(),
//                            cocDetailInformation.getCarMainDriveRatio()));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "主传动比",
//                            "1", type, cocDataCheckDTO.getMainTransmissionRatio(),
//                            cocDetailInformation.getCarMainDriveRatio()));
//
//                }
//            }
////            dataCheck("声级引用的ccc标准号和实施阶段", type, cocDataCheckDTO.getSoundLevelCCC(),
////                    cocDetailInformation.getCccStanardNumber(), checkResults, id, dataCheckDTOS);
//
//            if (StringUtils.isNotEmpty(cocDataCheckDTO.getSoundLevelCCC())) {
//                String[] dataArr = cocDataCheckDTO.getSoundLevelCCC().split(",");
//                boolean flag = true;
//                for (int i = 0; i < dataArr.length; i++) {
//                    if (!cocDetailInformation.getCccStanardNumber().contains(dataArr[i])) {
//                        flag = false;
//                    }
//                }
//                if (flag) {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
//                            "声级引用的ccc标准号和实施阶段",
//                            "0", type, cocDataCheckDTO.getSoundLevelCCC(),
//                            cocDetailInformation.getCccStanardNumber()));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
//                            "声级引用的ccc标准号和实施阶段",
//                            "0", type, cocDataCheckDTO.getSoundLevelCCC(),
//                            cocDetailInformation.getCccStanardNumber()));
//                } else {
//                    checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
//                            "声级引用的ccc标准号和实施阶段",
//                            "1", type, cocDataCheckDTO.getSoundLevelCCC(),
//                            cocDetailInformation.getCccStanardNumber()));
//                    dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
//                            "声级引用的ccc标准号和实施阶段",
//                            "1", type, cocDataCheckDTO.getSoundLevelCCC(),
//                            cocDetailInformation.getCccStanardNumber()));
//                }
//            }
//            if (!"39".equals(type)) {
//                dataCheck("声级定置噪声和对应的发动机转速", type,
//                        cocDataCheckDTO.getSoundLevelNoiseEngineSpeed(),
//                        cocDetailInformation.getStationaryNoise() + "/"
//                                + cocDetailInformation.getCccEngineSpeed(), checkResults, id, dataCheckDTOS);
//            }
//
//            dataCheck("声级加速行驶车外噪声", type, cocDataCheckDTO.getSpeedingUpOffVehicleNoise(),
//                    cocDetailInformation.getCarNoise(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("备注", type, cocDataCheckDTO.getRemarks(),
//                    cocDetailInformation.getRemark(), checkResults, id, dataCheckDTOS);
//            if (!type.equalsIgnoreCase("36") && !"39".equals(type)) {
//                dataCheck("实验用液体燃料", type, cocDataCheckDTO.getLiquidFuelForTest(),
//                        cocDetailInformation.getTestFuelLiquid(), checkResults, id, dataCheckDTOS);
//                dataCheck("发动机编号在发动机上的打刻位置", type, cocDataCheckDTO.getEngineCodePosition(),
//                        cocDetailInformation.getCarMotorCodeLocation(), checkResults, id, dataCheckDTOS);
//            }
//
//            switch (type) {
//                case "32":
//                    classMFiveUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    dataCheck("实验用气体燃料", type, cocDataCheckDTO.getGasFuelForTest(),
//                            cocDetailInformation.getTestFuelGas(), checkResults, id, dataCheckDTOS);
//
//                    break;
//                case "33":
//                    nTwoFiveUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    break;
//                case "31":
//                    classMSixUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    dataCheck("液体排放N2O", type, cocDataCheckDTO.getLiquidN2O(),
//                            cocDetailInformation.getN2oLiquid(), checkResults, id, dataCheckDTOS);
//                    break;
//                case "35":
//                    classNFiveUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    dataCheck("实验用气体燃料", type, cocDataCheckDTO.getGasFuelForTest(),
//                            cocDetailInformation.getTestFuelGas(), checkResults, id, dataCheckDTOS);
//                    break;
//                case "34":
//                    classNSixUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    dataCheck("液体排放N2O", type, cocDataCheckDTO.getLiquidN2O(),
//                            cocDetailInformation.getN2oLiquid(), checkResults, id, dataCheckDTOS);
//                    break;
//                case "36":
//                    electricUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    break;
//                case "39":
//                    dataCheck("额定载质量", type, cocDataCheckDTO.getRatedLoadQuality(),
//                            cocDetailInformation.getRatedContainedMass(), checkResults, id, dataCheckDTOS);
//                    electricUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation, checkResults,
//                            dataCheckDTOS, type, id);
//                    String th = "";
//                    if (StringUtils.isNotEmpty(cocDetailInformation.getLeafSpringsNumber())) {
//                        th = cocDetailInformation.getLeafSpringsNumber().replaceAll("@", "/");
//                    }
//                    dataCheck("钢板弹簧片数", type, cocDataCheckDTO.getSpringNumber(),
//                            th, checkResults, id, dataCheckDTOS);
//                    dataCheck("载质量利用系数", type, cocDataCheckDTO.getCarrierMassUtilizationCoefficient(),
//                            cocDetailInformation.getMassUtilizationCoefficient(), checkResults, id, dataCheckDTOS);
//                    break;
//                case "38":
//                    hybridPowerFiveUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation,
//                            checkResults, dataCheckDTOS, type, id);
//                    dataCheck("实验用气体燃料", type, cocDataCheckDTO.getGasFuelForTest(),
//                            cocDetailInformation.getTestFuelGas(), checkResults, id, dataCheckDTOS);
//
//                    break;
//                case "37":
//                    hybridPowerSixUniformityCertificateDataCheck(cocDataCheckDTO, cocDetailInformation,
//                            checkResults, dataCheckDTOS, type, id);
//                    dataCheck("液体排放N2O", type, cocDataCheckDTO.getLiquidN2O(),
//                            cocDetailInformation.getN2oLiquid(), checkResults, id, dataCheckDTOS);
//                    break;
//                default:
//                    break;
//            }
//            iCheckDataCheckResultService.saveBatch(checkResults);
//            return Result.success(this.sort(dataCheckDTOS));
//        } else {
//            return Result.error("未找到该证书编号对应的COC数据");
//        }
//    }
//
//    @Override
//    public ResponseMessage ENVDataCheck(ENVDataCheckDTO envDataCheckDTO,
//                                        String type, String carTypeCode, String id, String group,
//                                        List<String> informationOpenNumber) {
//        //根据识别的信息公开编号查询官方数据
//        if (StringUtils.isEmpty(envDataCheckDTO.getInformationOpenNumber())) {
//            return Result.error("信息公开编号不能为空");
//        }
//        if (!informationOpenNumber.contains(envDataCheckDTO.getInformationOpenNumber()
//                .replaceAll(" ", "")
//                .replaceAll("t", "")
//        )) {
//            return Result.error("该车型不存在该信息公开编号，请核实");
//        }
//        String codeData = envDataCheckDTO.getInformationOpenNumber().toUpperCase()
//                .replaceAll(" ", "")
//                .replaceAll("O", "0")
//                .replaceAll("I", "1")
//                .replaceAll("T", "");
//        String code = codeData.substring(0, 2) +
//                " " + codeData.substring(2, 4) +
//                " " + codeData.substring(4, 6) +
//                " " + codeData.substring(6, 8) +
//                " " + codeData.substring(8, 18) +
//                " " + codeData.substring(18);
//        QueryWrapper wrapper = new QueryWrapper();
//        wrapper.eq("INFO_DISCLOSURE_NO", code);
//        EnvDataEntity envDataEntity = iEnvDataService.getOne(wrapper);
//        List<CheckDataCheckResult> checkResults = new ArrayList<>();
//        List<DataCheckDTO> dataCheckDTOS = new ArrayList<>();
//        if (envDataEntity == null) {
//            return Result.error("官方数据中没有该环保信息公开编号");
//        }
//        String vehicleModel = envDataCheckDTO.getVehicleType();
//        if (StringUtils.isNotEmpty(vehicleModel)) {
//            vehicleModel = vehicleModel.toUpperCase().replaceAll("I", "1")
//                    .replaceAll("O", "0");
//        }
//        dataCheck("车辆型号", type, vehicleModel, envDataEntity.getCarTypeCode(),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("商标", type, envDataCheckDTO.getTrademark(), envDataEntity.getTrademark(),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("汽车分类", type, envDataCheckDTO.getVehicleClassification(),
//                envDataEntity.getCarCategory(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("车型的识别方法和位置", type, envDataCheckDTO.getRecognitionMethod(),
//                envDataEntity.getCarIdentLocation(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("车辆制造商名称", type, envDataCheckDTO.getVehicleManufacturer(),
//                envDataEntity.getCarConstructName(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("生产厂地址", type, envDataCheckDTO.getFactoryAddress(),
//                envDataEntity.getFactoryAddress(), checkResults, id, dataCheckDTOS);
//
//        String dataForm = envDataEntity.getEnvStandard() +
//                envDataEntity.getEnvMechanism() +
//                envDataEntity.getEnvConclusion() +
//                envDataEntity.getRegularEmissionStandard() +
//                envDataEntity.getRegularEmissionMechanism() +
//                envDataEntity.getRegularEmissionConclusion() +
//                envDataEntity.getNoiseStandard() +
//                envDataEntity.getNoiseMechanism() +
//                envDataEntity.getNoiseConclusion() +
//                envDataEntity.getDoubleIdleStandard() +
//                envDataEntity.getDoubleIdlenMechanism() +
//                envDataEntity.getDoubleIdleConclusion();
//        boolean flag = true;
//        if (StringUtils.isEmpty(envDataCheckDTO.getTestStandard()) ||
//                StringUtils.isEmpty(envDataCheckDTO.getTestStandard().replaceAll("空", "")
//                        .replaceAll(" ", "").replaceAll("；", ""))) {
//            if (StringUtils.isNotEmpty(dataForm.replaceAll(" ", "")
//                    .replaceAll("null", ""))) {
//                flag = false;
//            }
//        } else {
//            List<String> list = Arrays.asList(envDataCheckDTO.getTestStandard().split("；"));
//            for (String string : list) {
//                if (!dataForm.replaceAll(" ", "").toUpperCase()
//                        .contains(string.replaceAll(" ", "").toUpperCase())) {
//                    flag = false;
//                }
//            }
//        }
//        if (flag) {
//            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "型式检验信息",
//                    "0", type, envDataCheckDTO.getTestStandard(), dataForm.replaceAll("null", "")));
//            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "型式检验信息",
//                    "0", type, envDataCheckDTO.getTestStandard(), dataForm.replaceAll("null", "")));
//        } else {
//            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "型式检验信息",
//                    "1", type, envDataCheckDTO.getTestStandard(), dataForm.replaceAll("null", "")));
//            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "型式检验信息",
//                    "1", type, envDataCheckDTO.getTestStandard(), dataForm.replaceAll("null", "")));
//        }
//        switch (type) {
//            case "14":
//                dieselCountryFiveEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            case "11":
//                gasolineCountryFiveDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            case "12":
//            case "13":
//                gasolineNationalSixEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            case "16":
//            case "17":
//                hybridPowerCountryVIDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            case "15":
//                hybridPowerFiveEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            case "18":
//                pureElectricVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            case "19":
//                hybridPowerSixEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//                break;
//            default:
//                break;
//        }
//        iCheckDataCheckResultService.saveBatch(checkResults);
//        return Result.success(this.sort(dataCheckDTOS));
//    }
//
//    /**
//     * 柴油国六环保随车清单
//     *
//     * @param envDataCheckDTO
//     * @param envDataEntity
//     * @param checkResults
//     * @param dataCheckDTOS
//     * @param type
//     * @param id
//     */
//    private void hybridPowerSixEPDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                           List<CheckDataCheckResult> checkResults, List<DataCheckDTO> dataCheckDTOS,
//                                           String type, String id) {
//        fuelVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//        if (StringUtils.isNotEmpty(envDataEntity.getDeclareText())) {
//            String stage = "";
//            String PN = "";
//            String kilometre = "";
//            String declareText = envDataEntity.getDeclareText().substring(envDataEntity.getDeclareText().indexOf("》"));
//
//            stage = declareText.substring(1, declareText.indexOf("阶段") + 2);
//            PN = declareText.substring(declareText.indexOf("PN") + 4, declareText.indexOf("km") + 2)
//                    .replaceAll("×10", "×10^");
//            kilometre = declareText.substring(declareText.indexOf("保护") + 2, declareText.indexOf("公里") + 2);
//
//            dataCheck("污染物排放限值及测量方法", type,
//                    envDataCheckDTO.getStage(),
//                    stage, checkResults, id, dataCheckDTOS);
//            dataCheck("PN", type,
//                    envDataCheckDTO.getPN(),
//                    PN, checkResults, id, dataCheckDTOS);
//            dataCheck("耐久性", type,
//                    envDataCheckDTO.getKilometre(),
//                    kilometre, checkResults, id, dataCheckDTOS);
//
//
////            System.out.println(stage);
////            System.out.println(PN);
////            System.out.println(kilometre);
//        }
//        dataCheck("喷油泵型号/生产厂", type,
//                envDataCheckDTO.getFuelInjectionPump(),
//                envDataEntity.getInjectionPumpModel(), checkResults, id, dataCheckDTOS);
//        dataCheck("喷油器型号/生产厂", type,
//                envDataCheckDTO.getInjector(),
//                envDataEntity.getInjectorModel(), checkResults, id, dataCheckDTOS);
//        dataCheck("OBD接口位置", type,
//                envDataCheckDTO.getOBDInterfaceLocation(),
//                envDataEntity.getOBDInterfaceLocation(), checkResults, id, dataCheckDTOS);
//        dataCheck("基准质量", type,
//                envDataCheckDTO.getBenchmarkQuality(),
//                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//        dataCheck("燃料供给系统型式", type,
//                envDataCheckDTO.getFuelSupplySystemType(),
//                envDataEntity.getFuelSupplySystemType(), checkResults, id, dataCheckDTOS);
////        dataCheck("燃料供给系统型式", type,
////                envDataCheckDTO.getFuelSupplySystemType(),
////                envDataEntity.getFuelSupplySystemType(), checkResults, id, dataCheckDTOS);
//        dataCheck("曲轴箱排放控制装置型号/生产厂", type,
//                envDataCheckDTO.getCrankcaseEmissionControlDevice(),
//                envDataEntity.getCrankEmisControlType(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器（DOC）型号/生产企业", type,
//                envDataCheckDTO.getCatalystsTypeDOC(),
//                envDataEntity.getCatalystsTypeDOC(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器（DOC）封装/载体/涂层生产企业", type,
//                envDataCheckDTO.getTcZtFzDoc(),
//                envDataEntity.getTcZtFzDoc(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器（SCR）型号/生产企业", type,
//                envDataCheckDTO.getCatalystsTypeSCR(),
//                envDataEntity.getCatalystsTypeSCR(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器（SCR）封装/载体/涂层生产企业", type,
//                envDataCheckDTO.getTcZtFzSCR(),
//                envDataEntity.getTcZtFzSCR(), checkResults, id, dataCheckDTOS);
//        dataCheck("氮氧化物存储催化还原催化转化器型号/生产企业", type,
//                envDataCheckDTO.getNitrogenOxidesType(),
//                envDataEntity.getNitrogenOxidesType(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("氮氧化物存储催化还原催化转化器封装/载体/涂层生产企业", type,
//                envDataCheckDTO.getTcZtFzNitrogenOxides(),
//                envDataEntity.getTcZtFzNitrogenOxides(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器（ASC）型号/生产企业", type,
//                envDataCheckDTO.getCatalystsTypeASC(),
//                envDataEntity.getCatalystsTypeASC(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器（ASC）封装/载体/涂层生产企业", type,
//                envDataCheckDTO.getTcZtFzASC(),
//                envDataEntity.getTcZtFzASC(), checkResults, id, dataCheckDTOS);
//        dataCheck("颗粒捕集器（DPF）型号/生产企业", type,
//                envDataCheckDTO.getKlpjqDFF(),
//                envDataEntity.getKlpjqDFF(), checkResults, id, dataCheckDTOS);
//        dataCheck("颗粒捕集器封装/载体/涂层生产企业", type,
//                envDataCheckDTO.getTcZtFzDFF(),
//                envDataEntity.getTcZtFzDFF(), checkResults, id, dataCheckDTOS);
//
//
////        dataCheck("OBD系统供应商", type,
////                envDataCheckDTO.getO(),
////                envDataEntity.getCrankEmisControlType(), checkResults, id, dataCheckDTOS);
//
//
//    }
//
//    @Override
//    public ResponseMessage nameplateDataCheck(NameplateDataCheckDTO nameplateDataCheckDTO, String type,
//                                              String carTypeCode, String id, String group) {
//        List<CdVehicles> cdVehiclesList = iCdVehiclesService.selectCdVehiclesByModelAndGroup(carTypeCode, group);
//        List<CheckDataCheckResult> checkResults = new ArrayList<>();
//        List<DataCheckDTO> dataCheckDTOS = new ArrayList<>();
//        if (cdVehiclesList != null && !cdVehiclesList.isEmpty()) {
//            CdVehicles cdVehicles = cdVehiclesList.get(0);
//            List<CheckBulletinDataParameter> list = new ArrayList<>();
//            QueryWrapper wrapper = new QueryWrapper();
//            QueryWrapper wrapper1 = new QueryWrapper();
//            wrapper.eq("CAR_ID", cdVehicles.getId());
//            wrapper.eq("PARAMETER_SEQ", "QC0011");
//            list = iCheckBulletinDataParameterService.list(wrapper);
//            CheckBulletinDataParameter checkBulletinDataParameter = new CheckBulletinDataParameter();
//            if (list != null && !list.isEmpty()) {
//                checkBulletinDataParameter = list.get(0);
//            }
//            String vehicleModel = nameplateDataCheckDTO.getVehicleModel();
//            //先对比公有参数项
//            if (StringUtils.isNotEmpty(vehicleModel)) {
//                vehicleModel = vehicleModel.toUpperCase().replaceAll("I", "1").replaceAll("O", "0");
//            }
//            dataCheck("整车型号", type, vehicleModel,
//                    cdVehicles.getVehicleModel(), checkResults, id, dataCheckDTOS);
//
//            dataCheck("中文品牌", type, nameplateDataCheckDTO.getBrand(), cdVehicles.getZwpp(),
//                    checkResults, id, dataCheckDTOS);
//
//            dataCheck("最大允许总质量", type, nameplateDataCheckDTO.getPermissibleTotalMass(),
//                    cdVehicles.getTotalMass(), checkResults, id, dataCheckDTOS);
//            String str = "";
//            String data = "";
//            String fdjxh = "";
//            String fdjxhData = "";
//            if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getEngineModel())) {
//                fdjxh = nameplateDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
//            }
//            if (StringUtils.isNotEmpty(cdVehicles.getFdjxh())) {
//                fdjxhData = cdVehicles.getFdjxh().toUpperCase().replaceAll("O", "0");
//
//            }
//            switch (type) {
//                //哈弗常规
//                case "52":
//                    //魏派常规
//                case "55":
//                    dataCheck("发动机型号", type, fdjxh,
//                            fdjxhData, checkResults, id, dataCheckDTOS);
//
//                    if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getMaximumNetPower())) {
//                        str = nameplateDataCheckDTO.getMaximumNetPower().toUpperCase().replaceAll("K", "")
//                                .replaceAll("W", "").replaceAll(" ", "");
//                    }
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        data = checkBulletinDataParameter.getValue();
//                    }
//                    if (str.length() > 3) {
//                        if (str.substring(str.length() - 2, str.length()).equals(".0")) {
//                            str = str.substring(0, str.length() - 2);
//                        }
//                    }
//                    if (str.equalsIgnoreCase(data.toUpperCase().replaceAll(" ", "")
//                            .replaceAll("K", "").replaceAll("W", ""))) {
//
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "发动机最大净功率",
//                                "0", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "发动机最大净功率",
//                                "0", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                    } else {
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "发动机最大净功率",
//                                "1", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "发动机最大净功率",
//                                "1", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//
//                    }
//
////                    dataCheck("发动机最大净功率", type, nameplateDataCheckDTO.getMaximumNetPower(),
////                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//                    dataCheck("发动机排量", type, nameplateDataCheckDTO.getEngineDisplacement(),
//                            cdVehicles.getFdjpl(), checkResults, id, dataCheckDTOS);
//
//
//                    wrapper1.eq("CAR_ID", cdVehicles.getId());
//                    wrapper1.eq("PARAMETER_SEQ", "QA0025");
//                    list = iCheckBulletinDataParameterService.list(wrapper1);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (!list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        List<String> valueList = Arrays.asList(checkBulletinDataParameter.getValue().split(","));
//                        if (valueList.contains(nameplateDataCheckDTO.getPassengers().replaceAll(" ", "")
//                                .replaceAll("人", ""))) {
//                            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "乘坐人数",
//                                    "0", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "乘坐人数",
//                                    "0", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                        } else {
//                            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "乘坐人数",
//                                    "1", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "乘坐人数",
//                                    "1", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                        }
//                    }
//                    break;
//                //长城牌N类车型
//                case "51":
//                    dataCheck("发动机型号", type, fdjxh,
//                            fdjxhData, checkResults, id, dataCheckDTOS);
////                    String str = "";
////                    String data = "";
//                    if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getMaximumNetPower())) {
//                        str = nameplateDataCheckDTO.getMaximumNetPower().toUpperCase().replaceAll("K", "")
//                                .replaceAll("W", "").replaceAll(" ", "");
//                    }
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        data = checkBulletinDataParameter.getValue();
//                    }
//                    if (str.length() > 3) {
//                        if (str.substring(str.length() - 2, str.length()).equals(".0")) {
//                            str = str.substring(0, str.length() - 2);
//                        }
//                    }
//                    if (str.equalsIgnoreCase(data.toUpperCase().replaceAll(" ", "")
//                            .replaceAll("K", "").replaceAll("W", ""))) {
//
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "发动机最大净功率",
//                                "0", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "发动机最大净功率",
//                                "0", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                    } else {
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "发动机最大净功率",
//                                "1", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "发动机最大净功率",
//                                "1", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//
//                    }
//                    dataCheck("发动机排量", type, nameplateDataCheckDTO.getEngineDisplacement(),
//                            cdVehicles.getFdjpl(), checkResults, id, dataCheckDTOS);
//                    dataCheck("整备质量", type, nameplateDataCheckDTO.getReadinessQuality(),
//                            cdVehicles.getKerbMass(), checkResults, id, dataCheckDTOS);
//                    break;
//                //欧拉
//                case "54":
//                    QueryWrapper wrapper3 = new QueryWrapper();
//                    wrapper3.eq("CAR_ID", cdVehicles.getId());
//                    wrapper3.eq("PARAMETER_SEQ", "QH007");
//                    list = iCheckBulletinDataParameterService.list(wrapper3);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("驱动电机型号", type, nameplateDataCheckDTO.getDrivingMotorType(),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//                    QueryWrapper wrapper2 = new QueryWrapper();
//                    wrapper2.eq("CAR_ID", cdVehicles.getId());
//                    wrapper2.eq("PARAMETER_SEQ", "QH0091");
//                    list = iCheckBulletinDataParameterService.list(wrapper2);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//
//                    List<String> peakPowerList = new ArrayList<>();
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        peakPowerList = Arrays.asList(checkBulletinDataParameter.getValue().replaceAll(" ", "")
//                                .split("/"));
//                    }
//                    String peakPower = "";
//                    if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getPeakPower())) {
//                        peakPower = nameplateDataCheckDTO.getPeakPower();
//                    }
//                    if (peakPowerList.contains(peakPower.toUpperCase().replaceAll(" ", "")
//                            .replaceAll("K", "").replaceAll("W", ""))) {
//
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "0", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "0", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                    } else {
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "1", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "1", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//
//                    }
////                    dataCheck("驱动电机峰值功率", type, nameplateDataCheckDTO.getPeakPower(),
////                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper5 = new QueryWrapper();
//                    wrapper5.eq("CAR_ID", cdVehicles.getId());
//                    wrapper5.eq("PARAMETER_SEQ", "QH012");
//                    list = iCheckBulletinDataParameterService.list(wrapper5);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("动力电池系统额定电压", type, nameplateDataCheckDTO.getRatedVoltage()
//                                    .toUpperCase().replaceAll("V", ""),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
////                    dataCheck("整备质量", type, nameplateDataCheckDTO.getReadinessQuality(),
////                            cdVehicles.getKerbMass(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper4 = new QueryWrapper();
//                    wrapper4.eq("CAR_ID", cdVehicles.getId());
//                    wrapper4.eq("PARAMETER_SEQ", "QH014");
//                    list = iCheckBulletinDataParameterService.list(wrapper4);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("动力电池系统额定容量", type, nameplateDataCheckDTO.getRatedCapacity(),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    wrapper1.eq("CAR_ID", cdVehicles.getId());
//                    wrapper1.eq("PARAMETER_SEQ", "QA0025");
//                    list = iCheckBulletinDataParameterService.list(wrapper1);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (!list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        List<String> valueList = Arrays.asList(checkBulletinDataParameter.getValue().split(","));
//                        if (valueList.contains(nameplateDataCheckDTO.getPassengers().replaceAll(" ", "")
//                                .replaceAll("人", ""))) {
//                            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "乘坐人数",
//                                    "0", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "乘坐人数",
//                                    "0", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                        } else {
//                            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "乘坐人数",
//                                    "1", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "乘坐人数",
//                                    "1", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                        }
//                    }
//                    break;
//                case "53":
//                    //魏派混合动力
//                    dataCheck("发动机型号", type, fdjxh,
//                            fdjxhData, checkResults, id, dataCheckDTOS);
////                    String str = "";
////                    String data = "";
//                    if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getMaximumNetPower())) {
//                        str = nameplateDataCheckDTO.getMaximumNetPower().toUpperCase().replaceAll("K", "")
//                                .replaceAll("W", "").replaceAll(" ", "");
//                    }
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        data = checkBulletinDataParameter.getValue();
//                    }
//                    if (str.length() > 3) {
//                        if (str.substring(str.length() - 2, str.length()).equals(".0")) {
//                            str = str.substring(0, str.length() - 2);
//                        }
//                    }
//                    if (str.equalsIgnoreCase(data.toUpperCase().replaceAll(" ", "")
//                            .replaceAll("K", "")
//                            .replaceAll("W", ""))) {
//
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "发动机最大净功率",
//                                "0", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "发动机最大净功率",
//                                "0", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                    } else {
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "发动机最大净功率",
//                                "1", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "发动机最大净功率",
//                                "1", type, nameplateDataCheckDTO.getMaximumNetPower(),
//                                checkBulletinDataParameter.getValue()));
//
//                    }
//                    dataCheck("发动机排量", type, nameplateDataCheckDTO.getEngineDisplacement(),
//                            cdVehicles.getFdjpl(), checkResults, id, dataCheckDTOS);
//                    QueryWrapper wrapper6 = new QueryWrapper();
//                    wrapper6.eq("CAR_ID", cdVehicles.getId());
//                    wrapper6.eq("PARAMETER_SEQ", "QH007");
//                    list = iCheckBulletinDataParameterService.list(wrapper6);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("驱动电机型号", type, nameplateDataCheckDTO.getDrivingMotorType(),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrappe = new QueryWrapper();
//                    wrappe.eq("CAR_ID", cdVehicles.getId());
//                    wrappe.eq("PARAMETER_SEQ", "QH0091");
//                    list = iCheckBulletinDataParameterService.list(wrappe);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//
//                    List<String> peakPowerList2 = new ArrayList<>();
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        peakPowerList2 = Arrays.asList(checkBulletinDataParameter.getValue().replaceAll(" ", "")
//                                .split("/"));
//                    }
//                    String peakPower2 = "";
//                    if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getPeakPower())) {
//                        peakPower2 = nameplateDataCheckDTO.getPeakPower();
//                    }
//                    if (peakPowerList2.contains(peakPower2.toUpperCase().replaceAll(" ", "")
//                            .replaceAll("K", "").replaceAll("W", ""))) {
//
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "0", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "0", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                    } else {
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "1", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "1", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//
//                    }
////                    dataCheck("驱动电机峰值功率", type, nameplateDataCheckDTO.getPeakPower(),
////                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper7 = new QueryWrapper();
//                    wrapper7.eq("CAR_ID", cdVehicles.getId());
//                    wrapper7.eq("PARAMETER_SEQ", "QH012");
//                    list = iCheckBulletinDataParameterService.list(wrapper7);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("动力电池系统额定电压", type, nameplateDataCheckDTO.getRatedVoltage()
//                                    .toUpperCase().replaceAll("V", ""),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
////                    dataCheck("整备质量", type, nameplateDataCheckDTO.getReadinessQuality(),
////                            cdVehicles.getKerbMass(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper8 = new QueryWrapper();
//                    wrapper8.eq("CAR_ID", cdVehicles.getId());
//                    wrapper8.eq("PARAMETER_SEQ", "QH014");
//                    list = iCheckBulletinDataParameterService.list(wrapper8);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("动力电池系统额定容量", type, nameplateDataCheckDTO.getRatedCapacity(),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    wrapper1.eq("CAR_ID", cdVehicles.getId());
//                    wrapper1.eq("PARAMETER_SEQ", "QA0025");
//                    list = iCheckBulletinDataParameterService.list(wrapper1);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (!list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        List<String> valueList = Arrays.asList(checkBulletinDataParameter.getValue().split(","));
//                        if (valueList.contains(nameplateDataCheckDTO.getPassengers().replaceAll(" ", "")
//                                .replaceAll("人", ""))) {
//                            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "乘坐人数",
//                                    "0", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "乘坐人数",
//                                    "0", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                        } else {
//                            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "乘坐人数",
//                                    "1", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "乘坐人数",
//                                    "1", type, nameplateDataCheckDTO.getPassengers(),
//                                    checkBulletinDataParameter.getValue()));
//                        }
//                    }
//                    break;
//                case "56":
//                case "57":
//                    QueryWrapper wrapper9 = new QueryWrapper();
//                    wrapper9.eq("CAR_ID", cdVehicles.getId());
//                    wrapper9.eq("PARAMETER_SEQ", "QH007");
//                    list = iCheckBulletinDataParameterService.list(wrapper9);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("驱动电机型号", type, nameplateDataCheckDTO.getDrivingMotorType(),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper10 = new QueryWrapper();
//                    wrapper10.eq("CAR_ID", cdVehicles.getId());
//                    wrapper10.eq("PARAMETER_SEQ", "QH0091");
//                    list = iCheckBulletinDataParameterService.list(wrapper10);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//
//                    List<String> peakPowerList1 = new ArrayList<>();
//                    if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//                        peakPowerList1 = Arrays.asList(checkBulletinDataParameter.getValue().replaceAll(" ", "")
//                                .split("/"));
//                    }
//                    String peakPower1 = "";
//                    if (StringUtils.isNotEmpty(nameplateDataCheckDTO.getPeakPower())) {
//                        peakPower1 = nameplateDataCheckDTO.getPeakPower();
//                    }
//                    if (peakPowerList1.contains(peakPower1.toUpperCase().replaceAll(" ", "")
//                            .replaceAll("K", "").replaceAll("W", ""))) {
//
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "0", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "0", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                    } else {
//                        checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "1", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//                        dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "驱动电机峰值功率",
//                                "1", type, nameplateDataCheckDTO.getPeakPower(),
//                                checkBulletinDataParameter.getValue()));
//
//                    }
////                    dataCheck("驱动电机峰值功率", type, nameplateDataCheckDTO.getPeakPower(),
////                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper11 = new QueryWrapper();
//                    wrapper11.eq("CAR_ID", cdVehicles.getId());
//                    wrapper11.eq("PARAMETER_SEQ", "QH012");
//                    list = iCheckBulletinDataParameterService.list(wrapper11);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("动力电池系统额定电压", type, nameplateDataCheckDTO.getRatedVoltage()
//                                    .toUpperCase().replaceAll("V", ""),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
////                    dataCheck("整备质量", type, nameplateDataCheckDTO.getReadinessQuality(),
////                            cdVehicles.getKerbMass(), checkResults, id, dataCheckDTOS);
//
//                    QueryWrapper wrapper12 = new QueryWrapper();
//                    wrapper12.eq("CAR_ID", cdVehicles.getId());
//                    wrapper12.eq("PARAMETER_SEQ", "QH014");
//                    list = iCheckBulletinDataParameterService.list(wrapper12);
//                    checkBulletinDataParameter = new CheckBulletinDataParameter();
//                    if (list != null && !list.isEmpty()) {
//                        checkBulletinDataParameter = list.get(0);
//                    }
//                    dataCheck("动力电池系统额定容量", type, nameplateDataCheckDTO.getRatedCapacity(),
//                            checkBulletinDataParameter.getValue(), checkResults, id, dataCheckDTOS);
//                    dataCheck("整备质量", type, nameplateDataCheckDTO.getReadinessQuality(),
//                            cdVehicles.getKerbMass(), checkResults, id, dataCheckDTOS);
//                    break;
//                default:
//                    break;
//            }
//            iCheckDataCheckResultService.saveBatch(checkResults);
//            return Result.success(this.sort(dataCheckDTOS));
//        }
//        return Result.error("该车型无公告数据");
//    }
//
//    @Override
//    public ResponseMessage energyConsumptionDataCheck(EnergyConsumption energyConsumption, String type,
//                                                      String carTypeCode, String id, String group) {
//        //根据车型编号查询油耗数据
//        FuelDataEntity fuelDataEntity = baseMapper.selectFuelDataByCarTypeCode(carTypeCode);
//        List<CheckDataCheckResult> checkResults = new ArrayList<>();
//        List<DataCheckDTO> dataCheckDTOS = new ArrayList<>();
//        if (null == fuelDataEntity) {
//            return Result.error("未找到该车型的油耗数据");
//        }
//        List<CdVehicles> cdVehiclesList = iCdVehiclesService.selectCdVehiclesByModelAndGroup(carTypeCode, group);
//        CheckBulletinDataParameter checkBulletinDataParameter = new CheckBulletinDataParameter();
//        if (cdVehiclesList != null && !cdVehiclesList.isEmpty()) {
//            CdVehicles cdVehicles = cdVehiclesList.get(0);
//            List<CheckBulletinDataParameter> list = new ArrayList<>();
//            QueryWrapper wrapper = new QueryWrapper();
//            wrapper.eq("CAR_ID", cdVehicles.getId());
//            wrapper.eq("PARAMETER_SEQ", "QC0011");
//            list = iCheckBulletinDataParameterService.list(wrapper);
//
//            if (list != null && !list.isEmpty()) {
//                checkBulletinDataParameter = list.get(0);
//            }
//        }
//        String manufacturingEnterprise = this.distinct(fuelDataEntity.getProductComp());
//        dataCheck("最终阶段车辆生产国", type, energyConsumption.getManufacturingEnterprise(),
//                manufacturingEnterprise, checkResults, id, dataCheckDTOS);
//
//        String vehicleModel = energyConsumption.getVehicleType();
//        if (StringUtils.isNotEmpty(vehicleModel)) {
//            vehicleModel = vehicleModel.toUpperCase().replaceAll("I", "1").replaceAll("O", "0");
//        }
//
//        dataCheck("车辆型号", type, vehicleModel, this.distinct(fuelDataEntity.getVeModel()),
//                checkResults, id, dataCheckDTOS);
//
//        String fdjxh = "";
//        String fdjxhData = "";
//        if (StringUtils.isNotEmpty(energyConsumption.getEngineType())) {
//            fdjxh = energyConsumption.getEngineType().toUpperCase().replaceAll("O", "0");
//        }
//        if (StringUtils.isNotEmpty(fuelDataEntity.getEngineType())) {
//            fdjxhData = fuelDataEntity.getEngineType().toUpperCase().replaceAll("O", "0");
//
//        }
//        dataCheck("发动机型号", type, fdjxh, this.distinct(fdjxhData),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("变速器类型", type, energyConsumption.getTransmissionType(),
//                this.distinct(fuelDataEntity.getTransmission()), checkResults, id, dataCheckDTOS);
//
//        dataCheck("能源种类", type, energyConsumption.getEnergyTypes(), this.distinct(fuelDataEntity.getFuleType()),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("整车整备质量", type, energyConsumption.getWholevehicleQuality(),
//                this.distinct(fuelDataEntity.getWholevehicleQuality()), checkResults, id, dataCheckDTOS);
//
//        dataCheck("排量", type, energyConsumption.getDisplacement(), this.distinct(fuelDataEntity.getDisplacement()),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("最大设计总质量", type, energyConsumption.getCarTotalWeight(),
//                this.distinct(fuelDataEntity.getTotalMass()), checkResults, id, dataCheckDTOS);
//
//        String str = "";
//        String data = "";
//        if (StringUtils.isNotEmpty(energyConsumption.getMaximumNetPower())) {
//            str = energyConsumption.getMaximumNetPower().toUpperCase().replaceAll("K", "")
//                    .replaceAll("W", "");
//        }
//        if (StringUtils.isNotEmpty(checkBulletinDataParameter.getValue())) {
//            data = checkBulletinDataParameter.getValue();
//        }
//        if (str.length() > 3) {
//            if (str.substring(str.length() - 2, str.length()).equals(".0")) {
//                str = str.substring(0, str.length() - 2);
//            }
//        }
//        if (str.equalsIgnoreCase(data.toUpperCase()
//                .replaceAll("K", "").replaceAll("W", ""))) {
//
//            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "最大净功率",
//                    "0", type, energyConsumption.getMaximumNetPower(),
//                    checkBulletinDataParameter.getValue()));
//            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "最大净功率",
//                    "0", type, energyConsumption.getMaximumNetPower(),
//                    checkBulletinDataParameter.getValue()));
//        } else {
//            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id, "最大净功率",
//                    "1", type, energyConsumption.getMaximumNetPower(),
//                    checkBulletinDataParameter.getValue()));
//            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id, "最大净功率",
//                    "1", type, energyConsumption.getMaximumNetPower(),
//                    checkBulletinDataParameter.getValue()));
//
//        }
////        dataCheck("最大净功率", type, energyConsumption.getMaximumNetPower(),
////                this.distinct(checkBulletinDataParameter.getValue()), checkResults, id, dataCheckDTOS);
//
//        dataCheck("驱动形式", type, energyConsumption.getDrivingForm(),
//                this.distinct(fuelDataEntity.getDriveType()), checkResults, id, dataCheckDTOS);
//
//        dataCheck("市郊工况", type, energyConsumption.getSuburbanWorkingCondition(),
//                this.distinct(fuelDataEntity.getSuburbFuelConsumption()), checkResults, id, dataCheckDTOS);
//
//        dataCheck("市区工况", type, energyConsumption.getUrbanConditions(),
//                this.distinct(fuelDataEntity.getUrbanFuelConsumption()), checkResults, id, dataCheckDTOS);
//
//        dataCheck("综合工况", type, energyConsumption.getComprehensiveWorkingCondition(),
//                this.distinct(fuelDataEntity.getGeneralFuelConsumption()), checkResults, id, dataCheckDTOS);
//        dataCheck("综合工况值", type, energyConsumption.getComprehensiveWorkingConditionValue(),
//                this.distinct(fuelDataEntity.getGeneralFuelConsumption()), checkResults, id, dataCheckDTOS);
////        dataCheck("领跑值", type, energyConsumption.getLeaderValue(),
////                this.distinct(fuelDataEntity.getLeaderValue()), checkResults, id, dataCheckDTOS);
////        dataCheck("限值", type, energyConsumption.getLimitValue(),
////                this.distinct(fuelDataEntity.getLimitValue()), checkResults, id, dataCheckDTOS);
//
//        iCheckDataCheckResultService.saveBatch(checkResults);
//        return Result.success(this.sort(dataCheckDTOS));
//    }
//
//    /**
//     * 去除list 中重复的项
//     *
//     * @param productComp
//     * @return
//     */
//    private String distinct(String productComp) {
//        String str = "";
//        if (StringUtils.isNotEmpty(productComp)) {
//            List<String> list = Arrays.asList(productComp.split(","));
//            list = list.stream().distinct().collect(Collectors.toList());
//            for (int i = 0; i < list.size(); i++) {
//                str += list.get(i) + ",";
//            }
//            return str.substring(0, str.length() - 1);
//        }
//        return str;
//    }
//
//    @Override
//    public ResponseMessage checkIsOk(String id) {
//        QueryWrapper queryWrapper = new QueryWrapper();
//        queryWrapper.eq("CHECK_CERTIFICATE_MAIN_INFO_ID", id);
//        queryWrapper.likeRight("CHECK_TYPE", "1");
//        List<CheckDataCheckResult> envList = iCheckDataCheckResultService.list(queryWrapper);
//        QueryWrapper queryWrapper2 = new QueryWrapper();
//        queryWrapper2.eq("CHECK_CERTIFICATE_MAIN_INFO_ID", id);
//        queryWrapper2.likeRight("CHECK_TYPE", "2");
//        List<CheckDataCheckResult> certificateList = iCheckDataCheckResultService.list(queryWrapper2);
//        QueryWrapper queryWrapper3 = new QueryWrapper();
//        queryWrapper3.eq("CHECK_CERTIFICATE_MAIN_INFO_ID", id);
//        queryWrapper3.likeRight("CHECK_TYPE", "3");
//        List<CheckDataCheckResult> cocList = iCheckDataCheckResultService.list(queryWrapper3);
//        QueryWrapper queryWrapper4 = new QueryWrapper();
//        queryWrapper4.eq("CHECK_CERTIFICATE_MAIN_INFO_ID", id);
//        queryWrapper4.likeRight("CHECK_TYPE", "4");
//        List<CheckDataCheckResult> energyConsumptionList = iCheckDataCheckResultService.list(queryWrapper4);
//        QueryWrapper queryWrapper5 = new QueryWrapper();
//        queryWrapper5.eq("CHECK_CERTIFICATE_MAIN_INFO_ID", id);
//        queryWrapper5.likeRight("CHECK_TYPE", "5");
//        List<CheckDataCheckResult> nameplateDataList = iCheckDataCheckResultService.list(queryWrapper5);
//        String msg = "";
//        if (null == envList || envList.isEmpty()) {
//            msg += "环保随车清单、";
//        }
//        if (null == certificateList || certificateList.isEmpty()) {
//            msg += "合格证、";
//        }
//        if (null == cocList || cocList.isEmpty()) {
//            msg += "一致性证书、";
//        }
//        if (null == energyConsumptionList || energyConsumptionList.isEmpty()) {
//            msg += "能源消耗量标识、";
//        }
//        if (null == nameplateDataList || nameplateDataList.isEmpty()) {
//            msg += "铭牌、";
//        }
//        if (StringUtils.isNotEmpty(msg)) {
//            return Result.error("-1", "该车型还有证书未对比，是否确定核查完成");
//        }
//        return Result.success("200", "该车型已经对比完所有证书,请确定");
//    }
//
    @Override
    public ResponseMessage dataCheck(DataCheckReqDTO dataCheckReqDTO) {

        String id = dataCheckReqDTO.getId();
        String type = dataCheckReqDTO.getType();
        String carTypeCode = dataCheckReqDTO.getCarTypeCode();
        String group = dataCheckReqDTO.getGroup();
        //先删除之前的对比结果
        iCheckDataCheckResultService.delByMainIdAndType(dataCheckReqDTO.getId(), type);
        //根据类型对比数据
//        if (Arrays.asList(envTypeArr).contains(type)) {
//            ENVDataCheckDTO envDataCheckDTO = JSONObject.parseObject(dataCheckReqDTO.getTypeObj(),
//                    ENVDataCheckDTO.class);
//            if (StringUtils.isEmpty(envDataCheckDTO.getInformationOpenNumbers())) {
//                return Result.error("该车型下没有环保信息公开编号");
//            }
//            List<String> informationOpenNumber = Arrays.asList(envDataCheckDTO.getInformationOpenNumbers()
//                    .replaceAll(" ", "")
//                    .split(","));
//            return this.ENVDataCheck(envDataCheckDTO, type, carTypeCode, id, group, informationOpenNumber);
//        }
//        if (Arrays.asList(cocTypeArr).contains(type)) {
//            COCDataCheckDTO cocDataCheckDTO = JSONObject.parseObject(dataCheckReqDTO.getTypeObj(),
//                    COCDataCheckDTO.class);
//            return this.COCDataCheck(cocDataCheckDTO, type, carTypeCode, id, group);
//        }
//        if (Arrays.asList(nameplateTypeArr).contains(type)) {
//            NameplateDataCheckDTO nameplateDataCheckDTO = JSONObject.parseObject(dataCheckReqDTO.getTypeObj(),
//                    NameplateDataCheckDTO.class);
//            return this.nameplateDataCheck(nameplateDataCheckDTO, type, carTypeCode, id, group);
//        }
        if ("2".equals(type)) {
            CertificateEO certificateEO = JSONObject.parseObject(dataCheckReqDTO.getTypeObj(), CertificateEO.class);

            //TODO
            //调用合格证对比接口
            return this.certificateDataCheck(certificateEO, type, carTypeCode, id, group);
        }
//        if ("4".equals(type)) {
//            EnergyConsumption energyConsumption = JSONObject.parseObject(dataCheckReqDTO.getTypeObj(),
//                    EnergyConsumption.class);
//            return this.energyConsumptionDataCheck(energyConsumption, type, carTypeCode, id, group);
//        }
        return Result.error("对比类型不存在");
    }
//
    @Override
    @Transactional
    public ResponseMessage checkOk(String id, String userId) {
        UpdateWrapper wrapper = new UpdateWrapper();
        wrapper.set("CHECK_STATE", "2");
        wrapper.set("CHECK_DATE", new Date());
        wrapper.set("OPERATOR", userId);
        wrapper.eq("ID", id);
        boolean flag = this.update(wrapper);
        if (flag) {
            return Result.success("200", "操作成功", "true");
        } else {
            return Result.error("操作失败");
        }
    }
//
//
//    /**
//     * 汽油国五车型环保随车清单
//     */
//    private void gasolineCountryFiveDataCheck(ENVDataCheckDTO envDataCheckDTO,
//                                              EnvDataEntity envDataEntity,
//                                              List<CheckDataCheckResult> checkResults,
//                                              List<DataCheckDTO> dataCheckDTOS, String type, String id) {
//        fuelVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//        dataCheck("催化转化器型号/生产厂", type, envDataCheckDTO.getCatalyticConverterModel(),
//                envDataEntity.getCatalystsType(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器涂层/载体/封装生产厂", type, envDataCheckDTO.getCatalyticConverterCoating(),
//                envDataEntity.getCoatCarrEncapsul(), checkResults, id, dataCheckDTOS);
//        dataCheck("燃油蒸发控制装置型号/生产厂", type, envDataCheckDTO.getFuelEvaporationControlDevice(),
//                envDataEntity.getFuelEvaporaControlType(), checkResults, id, dataCheckDTOS);
//        dataCheck("氧传感器型号/生产厂", type, envDataCheckDTO.getOxygenSensor(),
//                envDataEntity.getOxygenSensorType(), checkResults, id, dataCheckDTOS);
//        dataCheck(" 曲轴箱排放控制装置型号/生产厂", type,
//                envDataCheckDTO.getCrankcaseEmissionControlDevice(),
//                envDataEntity.getCrankEmisControlType(), checkResults, id, dataCheckDTOS);
//        dataCheck("IUPR监测功能", type, envDataCheckDTO.getIupr(), envDataEntity.getIuprMonitorFunction(),
//                checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息依据的标准", type,
////                envDataCheckDTO.getTestStandard(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);dataCheck("型式检验信息检测机构", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);dataCheck("型式检验信息检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);dataCheck("出厂检验项目及结论依据的标准",
////                type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);dataCheck("出厂检验项目及结论检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//    }
//
//    /**
//     * 汽油国六车型环保随车清单
//     */
//    private void gasolineNationalSixEPDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                                List<CheckDataCheckResult> checkResults,
//                                                List<DataCheckDTO> dataCheckDTOS, String type, String id) {
//        fuelVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//        if (StringUtils.isNotEmpty(envDataEntity.getDeclareText())) {
//            String stage = "";
//            String PN = "";
//            String kilometre = "";
//            String declareText = envDataEntity.getDeclareText().substring(envDataEntity.getDeclareText().indexOf("》"));
//
//            stage = declareText.substring(1, declareText.indexOf("阶段") + 2);
//            PN = declareText.substring(declareText.indexOf("PN") + 4, declareText.indexOf("km") + 2)
//                    .replaceAll("×10", "×10^");
//            kilometre = declareText.substring(declareText.indexOf("保护") + 2, declareText.indexOf("公里") + 2);
//
//            dataCheck("污染物排放限值及测量方法", type,
//                    envDataCheckDTO.getStage(),
//                    stage, checkResults, id, dataCheckDTOS);
//            dataCheck("PN", type,
//                    envDataCheckDTO.getPN(),
//                    PN, checkResults, id, dataCheckDTOS);
//            dataCheck("耐久性", type,
//                    envDataCheckDTO.getKilometre(),
//                    kilometre, checkResults, id, dataCheckDTOS);
//        }
//
//        dataCheck("催化转化器型号/生产厂", type, envDataCheckDTO.getCatalyticConverterModel(),
//                envDataEntity.getCatalystsType(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器涂层/载体/封装生产厂", type, envDataCheckDTO.getCatalyticConverterCoating(),
//                envDataEntity.getCoatCarrEncapsul(), checkResults, id, dataCheckDTOS);
//        dataCheck("氧传感器型号/生产厂", type, envDataCheckDTO.getOxygenSensor(),
//                envDataEntity.getOxygenSensorType(), checkResults, id, dataCheckDTOS);
//
//        String klpjq = "";
//        String tcztfz = "";
//        if (StringUtils.isNotEmpty(envDataEntity.getParticleModelManufacturer())) {
//            klpjq = envDataEntity.getParticleModelManufacturer();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getCoatingCarrierPackaging())) {
//            tcztfz = envDataEntity.getCoatingCarrierPackaging();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getKlpjqDFF())) {
//            klpjq = envDataEntity.getKlpjqDFF();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getKlpjqCGPF())) {
//            klpjq = envDataEntity.getKlpjqCGPF();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getTcZtFzDFF())) {
//            klpjq = envDataEntity.getTcZtFzDFF();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getTcZtFcCGPF())) {
//            tcztfz = envDataEntity.getTcZtFcCGPF();
//        }
//
//        dataCheck("颗粒捕集器型号/生产厂", type, envDataCheckDTO.getParticleTrapType(),
//                klpjq, checkResults, id, dataCheckDTOS);
//        dataCheck("颗粒捕集器涂层/载体/封装生产厂", type, envDataCheckDTO.getParticleTrapCoating(),
//                tcztfz, checkResults, id, dataCheckDTOS);
//        dataCheck("碳罐型号/生产企业", type, envDataCheckDTO.getCanister(),
//                envDataEntity.getCanisterManufacturer(), checkResults, id, dataCheckDTOS);
//        dataCheck("曲轴箱排放控制装置型号/生产厂", type,
//                envDataCheckDTO.getCrankcaseEmissionControlDevice(),
//                envDataEntity.getCrankEmisControlType(), checkResults, id, dataCheckDTOS);
//        dataCheck("基准质量", type,
//                envDataCheckDTO.getBenchmarkQuality(),
//                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测机构", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论依据的标准", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//
//    }
//
//    /**
//     * 混合动力国六车型环保随车清单
//     */
//    private void hybridPowerCountryVIDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                               List<CheckDataCheckResult> checkResults,
//                                               List<DataCheckDTO> dataCheckDTOS, String type, String id) {
//        fuelVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//        dataCheck("电动机型号/生产厂", type, envDataCheckDTO.getMotorType(),
//                envDataEntity.getElectricMotorType(), checkResults, id, dataCheckDTOS);
//        dataCheck("储能装置型号/生产厂", type, envDataCheckDTO.getEnergyStorageDevice(),
//                envDataEntity.getEnergyStorageType(), checkResults, id, dataCheckDTOS);
//        dataCheck("电池容量/续航里程", type, envDataCheckDTO.getBattery(),
//                envDataEntity.getBatteryCapacity(),
//                checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器型号/生产厂", type, envDataCheckDTO.getCatalyticConverterModel(),
//                envDataEntity.getCatalystsType(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器涂层/载体/封装生产厂", type,
//                envDataCheckDTO.getCatalyticConverterCoating(),
//                envDataEntity.getCoatCarrEncapsul(), checkResults, id, dataCheckDTOS);
//        String klpjq = "";
//        String tcztfz = "";
//        if (StringUtils.isNotEmpty(envDataEntity.getParticleModelManufacturer())) {
//            klpjq = envDataEntity.getParticleModelManufacturer();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getCoatingCarrierPackaging())) {
//            tcztfz = envDataEntity.getCoatingCarrierPackaging();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getKlpjqDFF())) {
//            klpjq = envDataEntity.getKlpjqDFF();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getKlpjqCGPF())) {
//            klpjq = envDataEntity.getKlpjqCGPF();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getTcZtFzDFF())) {
//            klpjq = envDataEntity.getTcZtFzDFF();
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getTcZtFcCGPF())) {
//            tcztfz = envDataEntity.getTcZtFcCGPF();
//        }
//
//        dataCheck("颗粒捕集器型号/生产厂", type, envDataCheckDTO.getParticleTrapType(),
//                klpjq, checkResults, id, dataCheckDTOS);
//        dataCheck("颗粒捕集器涂层/载体/封装生产厂", type, envDataCheckDTO.getParticleTrapCoating(),
//                tcztfz, checkResults, id, dataCheckDTOS);
//        dataCheck("碳罐型号/生产企业", type, envDataCheckDTO.getCanister(),
//                envDataEntity.getCanisterManufacturer(), checkResults, id, dataCheckDTOS);
//        dataCheck("氧传感器型号/生产厂", type, envDataCheckDTO.getOxygenSensor(),
//                envDataEntity.getOxygenSensorType(), checkResults, id, dataCheckDTOS);
//        dataCheck("曲轴箱排放控制装置型号/生产厂", type,
//                envDataCheckDTO.getCrankcaseEmissionControlDevice(),
//                envDataEntity.getCrankEmisControlType(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("基准质量", type,
//                envDataCheckDTO.getBenchmarkQuality(),
//                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息依据的标准", type,
////                envDataCheckDTO.getTestStandard(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测机构", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论依据的标准", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//    }
//
//    /**
//     * 混合动力国五车型环保随车清单
//     */
//    private void hybridPowerFiveEPDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                            List<CheckDataCheckResult> checkResults, List<DataCheckDTO> dataCheckDTOS,
//                                            String type, String id) {
//        fuelVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//        dataCheck("电动机型号/生产厂", type, envDataCheckDTO.getMotorType(),
//                envDataEntity.getElectricMotorType(), checkResults, id, dataCheckDTOS);
//        dataCheck("储能装置型号/生产厂", type, envDataCheckDTO.getEnergyStorageDevice(),
//                envDataEntity.getEnergyStorageType(), checkResults, id, dataCheckDTOS);
//        dataCheck("电池容量/续航里程", type, envDataCheckDTO.getBattery(),
//                envDataEntity.getBatteryCapacity(),
//                checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器型号/生产厂", type, envDataCheckDTO.getCatalyticConverterModel(),
//                envDataEntity.getCatalystsType(), checkResults, id, dataCheckDTOS);
//        dataCheck("催化转化器涂层/载体/封装生产厂", type, envDataCheckDTO.getCatalyticConverterCoating(),
//                envDataEntity.getCoatCarrEncapsul(), checkResults, id, dataCheckDTOS);
//        dataCheck("氧传感器型号/生产厂", type, envDataCheckDTO.getOxygenSensor(),
//                envDataEntity.getOxygenSensorType(), checkResults, id, dataCheckDTOS);
//        dataCheck("曲轴箱排放控制装置型号/生产厂", type,
//                envDataCheckDTO.getCrankcaseEmissionControlDevice(),
//                envDataEntity.getCrankEmisControlType(), checkResults, id, dataCheckDTOS);
//        dataCheck("IUPR监测功能", type, envDataCheckDTO.getIupr(), envDataEntity.getIuprMonitorFunction(),
//                checkResults, id, dataCheckDTOS);
//        dataCheck("燃油蒸发控制装置型号/生产厂", type, envDataCheckDTO.getFuelEvaporationControlDevice(),
//                envDataEntity.getFuelEvaporaControlType(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息依据的标准", type,
////                envDataCheckDTO.getTestStandard(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测机构", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//    }
//
//    /**
//     * 柴油国五车型环保随车清单
//     */
//    private void dieselCountryFiveEPDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                              List<CheckDataCheckResult> checkResults, List<DataCheckDTO> dataCheckDTOS,
//                                              String type, String id) {
//        fuelVehicleEPDataCheck(envDataCheckDTO, envDataEntity, checkResults, dataCheckDTOS, type, id);
//        dataCheck("IUPR监测功能", type, envDataCheckDTO.getIupr(), envDataEntity.getIuprMonitorFunction(),
//                checkResults, id, dataCheckDTOS);
//
//
////        dataCheck("型式检验信息依据的标准", type,
////                envDataCheckDTO.getTestStandard(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测机构", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//////        dataCheck("出厂检验项目及结论依据的标准", type,
//////                envDataCheckDTO.getBenchmarkQuality(),
//////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//        dataCheck("后处理装置型号/生产厂", type,
//                envDataCheckDTO.getPostProcessingDeviceType(),
//                envDataEntity.getReprocessModel(), checkResults, id, dataCheckDTOS);
//        dataCheck("后处理装置涂层/载体/封装生产厂", type,
//                envDataCheckDTO.getPostTreatmentDeviceCoating(),
//                envDataEntity.getTcZtFzPostTreat(), checkResults, id, dataCheckDTOS);
//        dataCheck("喷油泵型号/生产厂", type,
//                envDataCheckDTO.getFuelInjectionPump(),
//                envDataEntity.getInjectionPumpModel(), checkResults, id, dataCheckDTOS);
//        dataCheck("喷油器型号/生产厂", type,
//                envDataCheckDTO.getInjector(),
//                envDataEntity.getInjectorModel(), checkResults, id, dataCheckDTOS);
//    }
//
//    /**
//     * 纯电动车型环保随车清单参数项对比
//     */
//    private void pureElectricVehicleEPDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                                List<CheckDataCheckResult> checkResults,
//                                                List<DataCheckDTO> dataCheckDTOS, String type, String id) {
//
//
//        dataCheck("整车控制器型号/版本号/生产厂", type, envDataCheckDTO.getVehicleController(),
//                envDataEntity.getVehModelVersionNum(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("电动机型号/生产厂", type, envDataCheckDTO.getMotorType(),
//                envDataEntity.getMotorModel(), checkResults, id, dataCheckDTOS);
//        dataCheck("储能装置型号/生产厂", type, envDataCheckDTO.getEnergyStorageDevice(),
//                envDataEntity.getEnergyStoringModel(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("电池容量/续航里程", type, envDataCheckDTO.getBattery(),
//                envDataEntity.getBatteryCapacity(),
//                checkResults, id, dataCheckDTOS);
//
////        dataCheck("型式检验信息依据的标准", type,
////                envDataCheckDTO.getTestStandard(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测机构", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("型式检验信息检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//////        dataCheck("出厂检验项目及结论依据的标准", type,
//////                envDataCheckDTO.getBenchmarkQuality(),
//////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
////        dataCheck("出厂检验项目及结论检测结论", type,
////                envDataCheckDTO.getBenchmarkQuality(),
////                envDataEntity.getReferenceQuality(), checkResults, id, dataCheckDTOS);
//
//    }
//
//    /**
//     * 燃油及混合动力车环保随车清单公有参数项识别
//     */
//    private void fuelVehicleEPDataCheck(ENVDataCheckDTO envDataCheckDTO, EnvDataEntity envDataEntity,
//                                        List<CheckDataCheckResult> checkResults, List<DataCheckDTO> dataCheckDTOS,
//                                        String type, String id) {
//        dataCheck("排放阶段", type, envDataCheckDTO.getEmissionStage(),
//                envDataEntity.getDischargeStage(),
//                checkResults, id, dataCheckDTOS);
//
//        String fdjxh = "";
//        String fdjxhData = "";
//        if (StringUtils.isNotEmpty(envDataCheckDTO.getEngineModel())) {
//            fdjxh = envDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
//        }
//        if (StringUtils.isNotEmpty(envDataEntity.getEngineType())) {
//            fdjxhData = envDataEntity.getEngineType().toUpperCase().replaceAll("O", "0");
//
//        }
//        dataCheck("发动机型号/生产厂", type, fdjxh, fdjxhData
//                ,
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("EGR型号/生产厂", type, envDataCheckDTO.getEgr(),
//                envDataEntity.getErgType(), checkResults,
//                id, dataCheckDTOS);
//
//        dataCheck("OBD型号/生产厂", type, envDataCheckDTO.getObd(),
//                envDataEntity.getObdType(), checkResults,
//                id, dataCheckDTOS);
//
//        dataCheck("ECU型号/生产厂", type, envDataCheckDTO.getEcu(), envDataEntity.getEcuModelVersionNum(),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("变速器型式/档位数", type, envDataCheckDTO.getDerailleur(),
//                envDataEntity.getGearboxTypeGearNum(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("消声器型号/生产厂", type, envDataCheckDTO.getMuffler(), envDataEntity.getMufflerModel(),
//                checkResults, id, dataCheckDTOS);
//
//        dataCheck("增压器型号/生产厂", type, envDataCheckDTO.getSupercharger(),
//                envDataEntity.getSuperchargerModel(), checkResults, id, dataCheckDTOS);
//
//        dataCheck("中冷器型式", type, envDataCheckDTO.getIntercoolerType(),
//                envDataEntity.getHeartShapeType(), checkResults, id, dataCheckDTOS);
//
//    }
//
//    /**
//     * 纯电动一致性证书数据对比
//     */
////    private void electricUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                        COCDetailInformation cocDetailInformation,
////                                                        List<CheckDataCheckResult> checkResults,
////                                                        List<DataCheckDTO> dataCheckDTOS, String type, String id) {
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion()
////                        + "/"
////                        + cocDetailInformation.getCccSignData(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机生产厂商名称", type, cocDataCheckDTO.getMotorManufacturer(),
////                cocDetailInformation.getCarMainmotorManufactorName(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机工作电压", type, cocDataCheckDTO.getWorkingVoltageOfMotor(),
////                cocDetailInformation.getCarMainmotorWorkingVoltage(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最大输出功率", type, cocDataCheckDTO.getMaxPower(),
////                cocDetailInformation.getCarMainmotorMaxPower(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池型号", type, cocDataCheckDTO.getPowerBatteryModel(),
////                cocDetailInformation.getCarBatteryModel(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池系统额定电压", type, cocDataCheckDTO.getSystemRatedPower(),
////                cocDetailInformation.getCarBatteryVoltage(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池系统额定容量", type, cocDataCheckDTO.getSystemRatedCapacity(),
////                cocDetailInformation.getCarBatteryCapacity(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池生产厂名称", type, cocDataCheckDTO.getPowerBatteryManufacturing(),
////                cocDetailInformation.getCarBatteryManufactorName(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机型号", type, cocDataCheckDTO.getMotorModel(),
////                cocDetailInformation.getCarMainmotorType(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机编号在电动机上的打刻位置", type, cocDataCheckDTO.getMotorCodePosition(),
////                cocDetailInformation.getCarMotorCodeLocation(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("货厢内部尺寸", type, cocDataCheckDTO.getCargoSize(),
////                cocDetailInformation.getContainerLength() + "/"
////                        + cocDetailInformation.getContainerWidth() + "/"
////                        + cocDetailInformation.getContainerHeight(), checkResults, id, dataCheckDTOS);
////
////    }
//
//    /**
//     * 混合动力国六一致性数据对比
//     */
//
////    private void hybridPowerSixUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                              COCDetailInformation cocDetailInformation,
////                                                              List<CheckDataCheckResult> checkResults,
////                                                              List<DataCheckDTO> dataCheckDTOS,
////                                                              String type, String id) {
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh, fdjxhData
////                ,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机生产厂商名称", type, cocDataCheckDTO.getMotorManufacturer(),
////                cocDetailInformation.getCarMainmotorManufactorName(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机工作电压", type, cocDataCheckDTO.getWorkingVoltageOfMotor(),
////                cocDetailInformation.getCarMainmotorWorkingVoltage(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最大输出功率", type, cocDataCheckDTO.getMaxPower(),
////                cocDetailInformation.getCarMainmotorMaxPower(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池型号", type, cocDataCheckDTO.getPowerBatteryModel(),
////                cocDetailInformation.getCarBatteryModel(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池系统额定电压", type, cocDataCheckDTO.getSystemRatedPower(),
////                cocDetailInformation.getCarBatteryVoltage(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池系统额定容量", type, cocDataCheckDTO.getSystemRatedCapacity(),
////                cocDetailInformation.getCarBatteryCapacity(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池生产厂名称", type, cocDataCheckDTO.getPowerBatteryManufacturing(),
////                cocDetailInformation.getCarBatteryManufactorName(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机型号", type, cocDataCheckDTO.getMotorModel(),
////                cocDetailInformation.getCarMainmotorType(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type, cocDataCheckDTO.getDischargeCCC(),
////                cocDetailInformation.getExhaustEmission(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getCoLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放PN", type, cocDataCheckDTO.getLiquidPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getPn(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放THC", type, cocDataCheckDTO.getLiquidTHC(),
////                cocDetailInformation.getThcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NMHC", type, cocDataCheckDTO.getLiquidNMHC(),
////                cocDetailInformation.getNmhcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放PM", type, cocDataCheckDTO.getLiquidPM(),
////                cocDetailInformation.getParticulateLiquid(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getCO2Discharge())) {
////            String[] dataArr = cocDataCheckDTO.getCO2Discharge().split(";");
////            boolean flag = true;
////            for (int i = 0; i < dataArr.length; i++) {
////                if (!cocDetailInformation.getCccStanardNumberEmission().contains(dataArr[i])) {
////                    flag = false;
////                }
////            }
////            if (flag) {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            } else {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            }
////        }
//////        dataCheck("CO2排放量/燃料消耗量引用CCC标准号", type, cocDataCheckDTO.getCO2Discharge(),
//////                cocDetailInformation.getCccStanardNumberEmission(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2DownLiquid())) {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2TownLiquid())) {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2ComprehensiveLiquid())) {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelDownLiquid())) {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelTownLiquid())) {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelComprehensiveLiquid())) {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////    }
//
//    /**
//     * 混合动力国五一致性数据对比
//     */
////    private void hybridPowerFiveUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                               COCDetailInformation cocDetailInformation,
////                                                               List<CheckDataCheckResult> checkResults,
////                                                               List<DataCheckDTO> dataCheckDTOS,
////                                                               String type, String id) {
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("货厢内部尺寸", type, cocDataCheckDTO.getCargoSize(),
////                cocDetailInformation.getContainerLength() + "/"
////                        + cocDetailInformation.getContainerWidth() + "/"
////                        + cocDetailInformation.getContainerHeight(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh,
////                fdjxhData,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机生产厂商名称", type, cocDataCheckDTO.getMotorManufacturer(),
////                cocDetailInformation.getCarMainmotorManufactorName(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机工作电压", type, cocDataCheckDTO.getWorkingVoltageOfMotor(),
////                cocDetailInformation.getCarMainmotorWorkingVoltage(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最大输出功率", type, cocDataCheckDTO.getMaxPower(),
////                cocDetailInformation.getCarMainmotorMaxPower(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池型号", type, cocDataCheckDTO.getPowerBatteryModel(),
////                cocDetailInformation.getCarBatteryModel(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池系统额定电压", type, cocDataCheckDTO.getSystemRatedPower(),
////                cocDetailInformation.getCarBatteryVoltage(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池系统额定容量", type, cocDataCheckDTO.getSystemRatedCapacity(),
////                cocDetailInformation.getCarBatteryCapacity(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("动力电池生产厂名称", type, cocDataCheckDTO.getPowerBatteryManufacturing(),
////                cocDetailInformation.getCarBatteryManufactorName(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("电动机型号", type, cocDataCheckDTO.getMotorModel(),
////                cocDetailInformation.getCarMainmotorType(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type, cocDataCheckDTO.getDischargeCCC(),
////                cocDetailInformation.getExhaustEmission(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getCoLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC", type, cocDataCheckDTO.getLiquidHC(),
////                cocDetailInformation.getHcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC+NOx", type, cocDataCheckDTO.getLiquidHCNOx(),
////                cocDetailInformation.getHcnoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放微粒物/PN", type, cocDataCheckDTO.getLiquidPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getParticulateLiquid() + "/" + cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放CO", type, cocDataCheckDTO.getGasCO(),
////                cocDetailInformation.getCoGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放NMHC", type, cocDataCheckDTO.getGasNMHC(),
////                cocDetailInformation.getNmhcGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放CH4", type, cocDataCheckDTO.getGasCH4(),
////                cocDetailInformation.getCh4Gas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放NOx", type, cocDataCheckDTO.getGasNOx(),
////                cocDetailInformation.getNoxGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放THC", type, cocDataCheckDTO.getGasTHC(),
////                cocDetailInformation.getThcGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放微粒物/PN", type, cocDataCheckDTO.getGasPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getParticulateGas() + "/" + cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getCO2Discharge())) {
////            String[] dataArr = cocDataCheckDTO.getCO2Discharge().split(";");
////            boolean flag = true;
////            for (int i = 0; i < dataArr.length; i++) {
////                if (!cocDetailInformation.getCccStanardNumberEmission().contains(dataArr[i])) {
////                    flag = false;
////                }
////            }
////            if (flag) {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            } else {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            }
////        }
//////        dataCheck("CO2排放量/燃料消耗量引用CCC标准号", type, cocDataCheckDTO.getCO2Discharge(),
//////                cocDetailInformation.getCccStanardNumberEmission(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2DownLiquid())) {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2TownLiquid())) {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2ComprehensiveLiquid())) {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelDownLiquid())) {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelTownLiquid())) {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelComprehensiveLiquid())) {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////    }
//
//    /**
//     * M类国六一致性数据对比
//     */
////    private void classMSixUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                         COCDetailInformation cocDetailInformation,
////                                                         List<CheckDataCheckResult> checkResults,
////                                                         List<DataCheckDTO> dataCheckDTOS, String type, String id) {
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh,
////                fdjxhData,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type, cocDataCheckDTO.getDischargeCCC(),
////                cocDetailInformation.getExhaustEmission(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getCoLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放PN", type, cocDataCheckDTO.getLiquidPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getPn(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放THC", type, cocDataCheckDTO.getLiquidTHC(),
////                cocDetailInformation.getThcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NMHC", type, cocDataCheckDTO.getLiquidNMHC(),
////                cocDetailInformation.getNmhcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放PM", type, cocDataCheckDTO.getLiquidPM(),
////                cocDetailInformation.getParticulateLiquid(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getCO2Discharge()) && StringUtils.isNotEmpty(cocDetailInformation.getCccStanardNumberEmission())) {
////            String[] dataArr = cocDataCheckDTO.getCO2Discharge().split(";");
////            boolean flag = true;
////            for (int i = 0; i < dataArr.length; i++) {
////                if (!cocDetailInformation.getCccStanardNumberEmission().contains(dataArr[i])) {
////                    flag = false;
////                }
////            }
////            if (flag) {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            } else {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            }
////        } else {
////            checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                    "CO2排放量/燃料消耗量引用CCC标准号",
////                    "0", type, cocDataCheckDTO.getCO2Discharge(),
////                    cocDetailInformation.getCccStanardNumberEmission()));
////            dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                    "CO2排放量/燃料消耗量引用CCC标准号",
////                    "0", type, cocDataCheckDTO.getCO2Discharge(),
////                    cocDetailInformation.getCccStanardNumberEmission()));
////        }
//////        dataCheck("CO2排放量/燃料消耗量引用CCC标准号", type, cocDataCheckDTO.getCO2Discharge(),
//////                cocDetailInformation.getCccStanardNumberEmission(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2DownLiquid())) {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2TownLiquid())) {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2ComprehensiveLiquid())) {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelDownLiquid())) {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelTownLiquid())) {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelComprehensiveLiquid())) {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////
////    }
//
//    /**
//     * N类国六一致性数据对比
//     */
////    private void classNSixUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                         COCDetailInformation cocDetailInformation,
////                                                         List<CheckDataCheckResult> checkResults,
////                                                         List<DataCheckDTO> dataCheckDTOS, String type, String id) {
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("货厢内部尺寸", type, cocDataCheckDTO.getCargoSize(),
////                cocDetailInformation.getContainerLength() + "/"
////                        + cocDetailInformation.getContainerWidth() + "/"
////                        + cocDetailInformation.getContainerHeight(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh,
////                fdjxhData,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////
////        String th = "";
////        if (StringUtils.isNotEmpty(cocDetailInformation.getLeafSpringsNumber())) {
////            th = cocDetailInformation.getLeafSpringsNumber().replaceAll("@", "/");
////        }
////        dataCheck("钢板弹簧片数", type, cocDataCheckDTO.getSpringNumber(),
////                th, checkResults, id, dataCheckDTOS);
////
////
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type, cocDataCheckDTO.getDischargeCCC(),
////                cocDetailInformation.getExhaustEmission(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getCoLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("额定载质量", type, cocDataCheckDTO.getRatedLoadQuality(),
////                cocDetailInformation.getRatedContainedMass(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放PN", type, cocDataCheckDTO.getLiquidPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getPn(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放THC", type, cocDataCheckDTO.getLiquidTHC(),
////                cocDetailInformation.getThcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NMHC", type, cocDataCheckDTO.getLiquidNMHC(),
////                cocDetailInformation.getNmhcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放PM", type, cocDataCheckDTO.getLiquidPM(),
////                cocDetailInformation.getParticulateLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("载质量利用系数", type, cocDataCheckDTO.getCarrierMassUtilizationCoefficient(),
////                cocDetailInformation.getMassUtilizationCoefficient(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getCO2Discharge())) {
////            String[] dataArr = cocDataCheckDTO.getCO2Discharge().split(";");
////            boolean flag = true;
////            for (int i = 0; i < dataArr.length; i++) {
////                if (!cocDetailInformation.getCccStanardNumberEmission().contains(dataArr[i])) {
////                    flag = false;
////                }
////            }
////            if (flag) {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            } else {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            }
////        }
//////        dataCheck("CO2排放量/燃料消耗量引用CCC标准号", type, cocDataCheckDTO.getCO2Discharge(),
//////                cocDetailInformation.getCccStanardNumberEmission(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2DownLiquid())) {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2TownLiquid())) {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2ComprehensiveLiquid())) {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelDownLiquid())) {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelTownLiquid())) {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelComprehensiveLiquid())) {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////
////    }
//
//    /**
//     * N类国五一致性数据对比
//     */
////    private void classNFiveUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                          COCDetailInformation cocDetailInformation,
////                                                          List<CheckDataCheckResult> checkResults,
////                                                          List<DataCheckDTO> dataCheckDTOS, String type, String id) {
////
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("货厢内部尺寸", type, cocDataCheckDTO.getCargoSize(),
////                cocDetailInformation.getContainerLength() + "/"
////                        + cocDetailInformation.getContainerWidth() + "/"
////                        + cocDetailInformation.getContainerHeight(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("载质量利用系数", type, cocDataCheckDTO.getCarrierMassUtilizationCoefficient(),
////                cocDetailInformation.getMassUtilizationCoefficient(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh,
////                fdjxhData,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////
////        String th = "";
////        if (StringUtils.isNotEmpty(cocDetailInformation.getLeafSpringsNumber())) {
////            th = cocDetailInformation.getLeafSpringsNumber().replaceAll("@", "/");
////        }
////        dataCheck("钢板弹簧片数", type, cocDataCheckDTO.getSpringNumber(),
////                th, checkResults, id, dataCheckDTOS);
////
////        dataCheck("额定载质量", type, cocDataCheckDTO.getRatedLoadQuality(),
////                cocDetailInformation.getRatedContainedMass(), checkResults, id, dataCheckDTOS);
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type, cocDataCheckDTO.getDischargeCCC(),
////                cocDetailInformation.getExhaustEmission(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getCoLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC", type, cocDataCheckDTO.getLiquidHC(),
////                cocDetailInformation.getHcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC+NOx", type, cocDataCheckDTO.getLiquidHCNOx(),
////                cocDetailInformation.getHcnoxLiquid(), checkResults, id, dataCheckDTOS);
////        List<String> pn = Arrays.asList(StringUtils.isNotBlank(cocDataCheckDTO.getLiquidPN()) ?
////                cocDataCheckDTO.getLiquidPN().split("/") : "".split("/"));
////        dataCheck("液体排放微粒物", type, CollectionUtils.isNotEmpty(pn) ? pn.get(0) : "",
////                cocDetailInformation.getParticulateLiquid(),
////                checkResults, id, dataCheckDTOS);
////        dataCheck("液体排放PN", type, CollectionUtils.isNotEmpty(pn) && pn.size() > 1 ?
////                        pn.get(1).replace("X", "×").replace("x", "×") : "",
////                cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放CO", type, cocDataCheckDTO.getGasCO(),
////                cocDetailInformation.getCoGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放NMHC", type, cocDataCheckDTO.getGasNMHC(),
////                cocDetailInformation.getNmhcGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放CH4", type, cocDataCheckDTO.getGasCH4(),
////                cocDetailInformation.getCh4Gas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放NOx", type, cocDataCheckDTO.getGasNOx(),
////                cocDetailInformation.getNoxGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放THC", type, cocDataCheckDTO.getGasTHC(),
////                cocDetailInformation.getThcGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放微粒物/PN", type, cocDataCheckDTO.getGasPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getParticulateGas() + "/" + cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getCO2Discharge())) {
////            String[] dataArr = cocDataCheckDTO.getCO2Discharge().split(";");
////            boolean flag = true;
////            for (int i = 0; i < dataArr.length; i++) {
////                if (!cocDetailInformation.getCccStanardNumberEmission().contains(dataArr[i])) {
////                    flag = false;
////                }
////            }
////            if (flag) {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            } else {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            }
////        }
//////        dataCheck("CO2排放量/燃料消耗量引用CCC标准号", type, cocDataCheckDTO.getCO2Discharge(),
//////                cocDetailInformation.getCccStanardNumberEmission(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2DownLiquid())) {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2TownLiquid())) {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2ComprehensiveLiquid())) {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelDownLiquid())) {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelTownLiquid())) {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelComprehensiveLiquid())) {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////    }
//
//    /**
//     * N类二类底盘国五一致性数据对比
//     */
////    private void nTwoFiveUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                        COCDetailInformation cocDetailInformation,
////                                                        List<CheckDataCheckResult> checkResults,
////                                                        List<DataCheckDTO> dataCheckDTOS,
////                                                        String type,
////                                                        String id) {
////        dataCheck("最终阶段车辆生产国", type, cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("货厢内部尺寸", type, cocDataCheckDTO.getCargoSize(),
////                cocDetailInformation.getContainerLength() + "/"
////                        + cocDetailInformation.getContainerWidth() + "/"
////                        + cocDetailInformation.getContainerHeight(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("载质量利用系数", type, cocDataCheckDTO.getCarrierMassUtilizationCoefficient(),
////                cocDetailInformation.getMassUtilizationCoefficient(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh,
////                fdjxhData,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////        String th = "";
////        if (StringUtils.isNotEmpty(cocDetailInformation.getLeafSpringsNumber())) {
////            th = cocDetailInformation.getLeafSpringsNumber().replaceAll("@", "/");
////        }
////        dataCheck("钢板弹簧片数", type, cocDataCheckDTO.getSpringNumber(),
////                th, checkResults, id, dataCheckDTOS);
////
////        dataCheck("额定载质量", type, cocDataCheckDTO.getRatedLoadQuality(),
////                cocDetailInformation.getRatedContainedMass(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type,
////                cocDataCheckDTO.getDischargeCCC(), cocDetailInformation.getExhaustEmission(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getHcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getHcnoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getParticulateLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC", type, cocDataCheckDTO.getLiquidHC(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC+NOx", type, cocDataCheckDTO.getLiquidHCNOx(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放微粒物/PN", type, cocDataCheckDTO.getLiquidPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getTestFuelGas() + "/" + cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////
////    }
//
//    /**
//     * M类国五一致性数据对比
//     */
////    private void classMFiveUniformityCertificateDataCheck(COCDataCheckDTO cocDataCheckDTO,
////                                                          COCDetailInformation cocDetailInformation,
////                                                          List<CheckDataCheckResult> checkResults,
////                                                          List<DataCheckDTO> dataCheckDTOS,
////                                                          String type,
////                                                          String id) {
////        dataCheck("最终阶段车辆生产国", "32", cocDataCheckDTO.getFinalStageVehicleProducers(),
////                cocDetailInformation.getCocFactoryCount(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("最终阶段车辆CCC证书编号（版本号）/签发日期", type, cocDataCheckDTO.getFinalStageCCC(),
////                cocDetailInformation.getCccCertificateCode() + "/"
////                        + cocDetailInformation.getCccCertificateVesion() + "/"
////                        + cocDetailInformation.getCccSignData(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("是否为直接喷射", type, cocDataCheckDTO.getIsDirectInjection(),
////                cocDetailInformation.getDirectInjection(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("排量/最大净功率", type, cocDataCheckDTO.getDisplacement(),
////                cocDetailInformation.getDisplacement() + "/" + cocDetailInformation.getMaxNetPower(),
////                checkResults, id, dataCheckDTOS);
////
////        String fdjxh = "";
////        String fdjxhData = "";
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getEngineModel())) {
////            fdjxh = cocDataCheckDTO.getEngineModel().toUpperCase().replaceAll("O", "0");
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getEngineType())) {
////            fdjxhData = cocDetailInformation.getEngineType() + "/" + cocDetailInformation.getFuelType();
////            fdjxhData = fdjxhData.toUpperCase().replaceAll("O", "0");
////
////        }
////        dataCheck("发动机型号/燃料种类", type, fdjxh,
////                fdjxhData,
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气缸数量和排列", type, cocDataCheckDTO.getCylinderNumber(),
////                cocDetailInformation.getCylindersNumber() + "/" + cocDetailInformation.getCylindersArrangement(),
////                checkResults, id, dataCheckDTOS);
////
////
////        dataCheck("排气排放物CCC认证标准号和对应的实施阶段", type, cocDataCheckDTO.getDischargeCCC(),
////                cocDetailInformation.getExhaustEmission(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放CO", type, cocDataCheckDTO.getLiquidCO(),
////                cocDetailInformation.getCoLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放NOx", type, cocDataCheckDTO.getLiquidNOx(),
////                cocDetailInformation.getNoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放烟度", type, cocDataCheckDTO.getLiquidSmoke(),
////                cocDetailInformation.getSmokeLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC", type, cocDataCheckDTO.getLiquidHC(),
////                cocDetailInformation.getHcLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放HC+NOx", type, cocDataCheckDTO.getLiquidHCNOx(),
////                cocDetailInformation.getHcnoxLiquid(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("液体排放微粒物/PN", type, cocDataCheckDTO.getLiquidPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getParticulateLiquid() + "/" + cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放CO", type, cocDataCheckDTO.getGasCO(),
////                cocDetailInformation.getCoGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放NMHC", type, cocDataCheckDTO.getGasNMHC(),
////                cocDetailInformation.getNmhcGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放CH4", type, cocDataCheckDTO.getGasCH4(),
////                cocDetailInformation.getCh4Gas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放NOx", type, cocDataCheckDTO.getGasNOx(),
////                cocDetailInformation.getNoxGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放THC", type, cocDataCheckDTO.getGasTHC(),
////                cocDetailInformation.getThcGas(), checkResults, id, dataCheckDTOS);
////
////        dataCheck("气体燃料排放微粒物/PN", type, cocDataCheckDTO.getGasPN().replace("X", "×").replace("x", "×"),
////                cocDetailInformation.getParticulateGas() + "/" + cocDetailInformation.getPn(),
////                checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDataCheckDTO.getCO2Discharge())) {
////            String[] dataArr = cocDataCheckDTO.getCO2Discharge().split(";");
////            boolean flag = true;
////            for (int i = 0; i < dataArr.length; i++) {
////                if (!cocDetailInformation.getCccStanardNumberEmission().contains(dataArr[i])) {
////                    flag = false;
////                }
////            }
////            if (flag) {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "0", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            } else {
////                checkResults.add(new CheckDataCheckResult(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////                dataCheckDTOS.add(new DataCheckDTO(UUID.randomUUID(), id,
////                        "CO2排放量/燃料消耗量引用CCC标准号",
////                        "1", type, cocDataCheckDTO.getCO2Discharge(),
////                        cocDetailInformation.getCccStanardNumberEmission()));
////            }
////        }
//////        dataCheck("CO2排放量/燃料消耗量引用CCC标准号", type, cocDataCheckDTO.getCO2Discharge(),
//////                cocDetailInformation.getCccStanardNumberEmission(), checkResults, id, dataCheckDTOS);
////
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2DownLiquid())) {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市区", type, cocDataCheckDTO.getCO2City(),
////                    cocDetailInformation.getCo2DownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2TownLiquid())) {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量市郊", type, cocDataCheckDTO.getCO2Suburbs(),
////                    cocDetailInformation.getCo2TownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getCo2ComprehensiveLiquid())) {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("CO2排放量综合", type, cocDataCheckDTO.getCO2Comprehensive(),
////                    cocDetailInformation.getCo2ComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelDownLiquid())) {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市区", type, cocDataCheckDTO.getFuelCity(),
////                    cocDetailInformation.getFuelDownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelTownLiquid())) {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量市郊", type, cocDataCheckDTO.getFuelSuburbs(),
////                    cocDetailInformation.getFuelTownGas(), checkResults, id, dataCheckDTOS);
////        }
////        if (StringUtils.isNotEmpty(cocDetailInformation.getFuelComprehensiveLiquid())) {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveLiquid(), checkResults, id, dataCheckDTOS);
////        } else {
////            dataCheck("燃料消耗量综合", type, cocDataCheckDTO.getFuelComprehensive(),
////                    cocDetailInformation.getFuelComprehensiveGas(), checkResults, id, dataCheckDTOS);
////        }
////    }
//
    private void dataCheck(String paramName, String type, String str, String data,
                           List<CheckDataCheckResult> checkResults, String id, List<DataCheckDTO> dataCheckDTOS) {
        String uuId = UUID.randomUUID();
        String checkResult = "1";
        // 如果数据是--或者N/A或者为null 视为空
        if ("-".equalsIgnoreCase(str) || "N/A".equalsIgnoreCase(str) || "null".equalsIgnoreCase(str)
                || "--".equalsIgnoreCase(str)) {
            str = "";
        }
        if ("-".equalsIgnoreCase(str) ||
                "--".equalsIgnoreCase(data) || "N/A".equalsIgnoreCase(data) || "一".equalsIgnoreCase(data)) {
            data = "";
        }
        if (StringUtils.isEmpty(str)) {
            str = "";
        }
        if (StringUtils.isEmpty(data)) {
            data = "";
        }
        if (StringUtils.isEmpty(str.replaceAll(" ", "")
                .replaceAll("无", "")
                .replaceAll("不适用", "").replaceAll("/", "")
                .replaceAll("空", "")) && StringUtils.isEmpty(data.replaceAll(" ", "")
                .replaceAll("无", "")
                .replaceAll("不适用", "").replaceAll("/", "")
                .replaceAll("空", ""))) {
            checkResult = "0";
        }

        if (StringUtils.isNotEmpty(str) && StringUtils.isNotEmpty(data)) {
            str = str.replaceAll(" ", "");
            data = data.replaceAll(" ", "");
//             油耗对比做包含操作
            if ("4".equals(type) || "2".equals(type)) {
                List<String> dataList = Arrays.asList(data.toUpperCase()
                        .replaceAll("\\(", "")
                        .replaceAll("\\)", "")
                        .replaceAll(" ", "")
                        .replaceAll("/", "")
                        .replaceAll("（", "")
                        .replaceAll("）", "")
                        .replaceAll("L100KM", "")
                        .replaceAll("NI", "N1")
                        .replaceAll("MI", "M1")
                        .replaceAll("KW", "")
                        .replaceAll(";", "")
                        .replaceAll("；", "")
                        .replaceAll("AH", "")
//                        .replaceAll("H", "")
                        .replaceAll("KG", "")
                        .replaceAll("KM", "")
                        .replaceAll(":", "")
                        .replaceAll("：", "")
                        .replaceAll("ML", "")
//                        .replaceAll("W", "")
                        .replaceAll("，", "")
                        .replaceAll("《", "")
                        .replaceAll("V", "")
                        .replaceAll("》", "").split(","));
                if (dataList
                        .contains(str.toUpperCase().replaceAll("\\(", "")
                                        .replaceAll("\\)", "")
                                        .replaceAll("/", "")
                                        .replaceAll("（", "")
                                        .replaceAll("）", "")
                                        .replaceAll(",", "")
                                        .replaceAll(" ", "")
                                        .replaceAll("L100KM", "")
                                        .replaceAll("NI", "N1")
                                        .replaceAll("MI", "M1")
                                        .replaceAll("KW", "")
                                        .replaceAll("KG", "")
                                        .replaceAll("KM", "")
                                        .replaceAll(";", "")
                                        .replaceAll(":", "")
                                        .replaceAll("：", "")
                                        .replaceAll("；", "")
                                        .replaceAll("ML", "")
//                                .replaceAll("W", "")
                                        .replaceAll("《", "")
                                        .replaceAll("》", "")
                                        .replaceAll("AH", "")
//                                .replaceAll("H", "")
                                        .replaceAll("，", "")
                                        .replaceAll("国ⅤII", "国Ⅶ")
                                        .replaceAll("国Ⅴ11", "国Ⅶ")
                                        .replaceAll("国Ⅴ1I", "国Ⅶ")
                                        .replaceAll("国ⅤI1", "国Ⅶ")
                                        .replaceAll("国VII", "国Ⅶ")
                                        .replaceAll("国VI1", "国Ⅶ")
                                        .replaceAll("国V1I", "国Ⅶ")
                                        .replaceAll("国V11", "国Ⅶ")
                                        .replaceAll("国ⅥI", "国Ⅶ")
                                        .replaceAll("国Ⅵ1", "国Ⅶ")
                                        .replaceAll("国VI", "国Ⅵ")
                                        .replaceAll("国V1", "国Ⅵ")
                                        .replaceAll("国VⅠ", "国Ⅵ")
                                        .replaceAll("国ⅤⅠ", "国Ⅵ")
                                        .replaceAll("国Ⅴ1", "国Ⅵ")
                                        .replaceAll("国ⅤI", "国Ⅵ")
                                        .replaceAll("国V", "国Ⅴ")
                                        .replaceAll("V", "")
                        )
                    //双向包含
//                        ||
//                        str.toUpperCase().replaceAll("\\(", "")
//                                .replaceAll("\\)", "")
//                                .replaceAll("/", "")
//                                .replaceAll("（", "")
//                                .replaceAll("）", "")
//                                .replaceAll(",", "")
//                                .replaceAll(" ", "")
//                                .replaceAll("L100KM", "")
//                                .replaceAll("K", "")
//                                .replaceAll("NI", "N1")
//                                .replaceAll("MI", "M1")
//                                .replaceAll("G", "")
//                                .replaceAll("M", "")
//                                .replaceAll(";", "")
//                                .replaceAll(":", "")
//                                .replaceAll("：", "")
//                                .replaceAll("；", "")
//                                .replaceAll("L", "")
//                                .replaceAll("W", "")
//                                .replaceAll("《", "")
//                                .replaceAll("》", "")
//                                .replaceAll("，", "")
//                                .replaceAll("国ⅤII", "国Ⅶ")
//                                .replaceAll("国Ⅴ11", "国Ⅶ")
//                                .replaceAll("国Ⅴ1I", "国Ⅶ")
//                                .replaceAll("国ⅤI1", "国Ⅶ")
//                                .replaceAll("国VII", "国Ⅶ")
//                                .replaceAll("国VI1", "国Ⅶ")
//                                .replaceAll("国V1I", "国Ⅶ")
//                                .replaceAll("国V11", "国Ⅶ")
//                                .replaceAll("国ⅥI", "国Ⅶ")
//                                .replaceAll("国Ⅵ1", "国Ⅶ")
//                                .replaceAll("国VI", "国Ⅵ")
//                                .replaceAll("国V1", "国Ⅵ")
//                                .replaceAll("国VⅠ", "国Ⅵ")
//                                .replaceAll("国ⅤⅠ", "国Ⅵ")
//                                .replaceAll("国Ⅴ1", "国Ⅵ")
//                                .replaceAll("国ⅤI", "国Ⅵ")
//                                .replaceAll("国V", "国Ⅴ")
//                                .contains(data.toUpperCase()
//                                        .replaceAll("\\(", "")
//                                        .replaceAll("\\)", "")
//                                        .replaceAll(" ", "")
//                                        .replaceAll("/", "")
//                                        .replaceAll("（", "")
//                                        .replaceAll("）", "")
//                                        .replaceAll(",", "")
//                                        .replaceAll("L100KM", "")
//                                        .replaceAll("K", "")
//                                        .replaceAll("NI", "N1")
//                                        .replaceAll("MI", "M1")
//                                        .replaceAll(";", "")
//                                        .replaceAll("；", "")
//                                        .replaceAll("G", "")
//                                        .replaceAll("M", "")
//                                        .replaceAll(":", "")
//                                        .replaceAll("：", "")
//                                        .replaceAll("L", "")
//                                        .replaceAll("W", "")
//                                        .replaceAll("，", "")
//                                        .replaceAll("《", "")
//                                        .replaceAll("》", ""))
                ) {
                    checkResult = "0";
                }
            } else if (str.toUpperCase().replaceAll("\\(", "")
                    .replaceAll("\\)", "")
                    .replaceAll("/", "")
                    .replaceAll("（", "")
                    .replaceAll("）", "")
                    .replaceAll(",", "")
                    .replaceAll(" ", "")
                    .replaceAll("L100KM", "")
                    .replaceAll("KW", "")
                    .replaceAll("NI", "N1")
                    .replaceAll("MI", "M1")
                    .replaceAll("KG", "")
                    .replaceAll("KM", "")
                    .replaceAll(";", "")
                    .replaceAll(":", "")
                    .replaceAll("AH", "")
//                    .replaceAll("H", "")
                    .replaceAll("：", "")
                    .replaceAll("；", "")
                    .replaceAll("ML", "")
//                    .replaceAll("W", "")
                    .replaceAll("《", "")
                    .replaceAll("》", "")
                    .replaceAll("，", "")
                    .replaceAll("国ⅤII", "国Ⅶ")
                    .replaceAll("国Ⅴ11", "国Ⅶ")
                    .replaceAll("国Ⅴ1I", "国Ⅶ")
                    .replaceAll("国ⅤI1", "国Ⅶ")
                    .replaceAll("国VII", "国Ⅶ")
                    .replaceAll("国VI1", "国Ⅶ")
                    .replaceAll("国V1I", "国Ⅶ")
                    .replaceAll("国V11", "国Ⅶ")
                    .replaceAll("国ⅥI", "国Ⅶ")
                    .replaceAll("国Ⅵ1", "国Ⅶ")
                    .replaceAll("国VI", "国Ⅵ")
                    .replaceAll("国V1", "国Ⅵ")
                    .replaceAll("国VⅠ", "国Ⅵ")
                    .replaceAll("国ⅤⅠ", "国Ⅵ")
                    .replaceAll("国Ⅴ1", "国Ⅵ")
                    .replaceAll("国ⅤI", "国Ⅵ")
                    .replaceAll("国V", "国Ⅴ")
                    .replaceAll("人", "")
                    .equals(data.toUpperCase()
                            .replaceAll("\\(", "")
                            .replaceAll("\\)", "")
                            .replaceAll(" ", "")
                            .replaceAll("/", "")
                            .replaceAll("（", "")
                            .replaceAll("）", "")
                            .replaceAll(",", "")
                            .replaceAll("L100KM", "")
                            .replaceAll("KW", "")
                            .replaceAll("NI", "N1")
                            .replaceAll("MI", "M1")
                            .replaceAll(";", "")
                            .replaceAll("；", "")
                            .replaceAll("KG", "")
                            .replaceAll("KM", "")
                            .replaceAll(":", "")
                            .replaceAll("：", "")
                            .replaceAll("ML", "")
//                            .replaceAll("W", "")
                            .replaceAll("，", "")
                            .replaceAll("AH", "")
//                            .replaceAll("H", "")
                            .replaceAll("《", "")
                            .replaceAll("人", "")
                            .replaceAll("》", ""))) {
                checkResult = "0";
            }
            if (checkResult.equals("1")) {
                if (StringUtils.isEmpty(str.replaceAll(" ", "")
                        .replaceAll("无", "")
                        .replaceAll("不适用", "").replaceAll("/", "")
                        .replaceAll("空", "")) &&
                        StringUtils.isEmpty(data.replaceAll(" ", "")
                                .replaceAll("无", "")
                                .replaceAll("不适用", "").replaceAll("null", "")
                                .replaceAll("空", "").replaceAll("/", ""))) {
                    checkResult = "0";
                }
                if ("手动挡".equalsIgnoreCase(str) && "手动".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("自动挡".equalsIgnoreCase(str) && "手动".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("手动挡".equalsIgnoreCase(str) && "at".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("自动挡".equalsIgnoreCase(str) && "mt".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("at".equalsIgnoreCase(str) && "自动".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("mt".equalsIgnoreCase(str) && "手动".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("自动".equalsIgnoreCase(str) && "at".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if ("手动".equalsIgnoreCase(str) && "mt".equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
                if (str.equalsIgnoreCase(data)) {
                    checkResult = "0";
                }
            }
        }

        CheckDataCheckResult checkDataCheckResult
                = new CheckDataCheckResult(uuId, id, paramName, checkResult, type,
                str.replaceAll("null", ""), data.replaceAll("null", ""));
        DataCheckDTO dataCheckDTO = new DataCheckDTO(uuId, id, paramName, checkResult, type,
                str.replaceAll("null", ""), data.replaceAll("null", ""));
        checkResults.add(checkDataCheckResult);
        dataCheckDTOS.add(dataCheckDTO);
    }

    /**
     * 对比结果排序（不一致的靠前）
     */
    private List<DataCheckDTO> sort(List<DataCheckDTO> logsList) {
        Collections.sort(logsList, new Comparator<DataCheckDTO>() {
            @Override
            public int compare(DataCheckDTO o1, DataCheckDTO o2) {
                return -o1.getCheckResult().compareTo(o2.getCheckResult());
            }
        });
        return logsList;
    }
    @SneakyThrows
    @Scheduled(cron = "0 0 2 * * ?")
//    @Scheduled(cron = "0/5 * * * * ?")
    public void insertCertificateMainInfo() {
        String vehicleGroup = this.baseMapper.getMaxVehicleGroup();
        if(StringUtils.isEmpty(vehicleGroup)){
            vehicleGroup = "339";
        }

        if(StringUtils.isNotEmpty(vehicleGroup)){
            List<CheckCertificateMainInfo> clcpZk = this.baseMapper.getClcpZk(vehicleGroup);
            if(clcpZk.size()>0) {
                for (CheckCertificateMainInfo mainInfo : clcpZk) {
                    mainInfo.setId(mainInfo.getVehicleModel() + mainInfo.getVehicleGroup());
                    mainInfo.setCheckState("0");
                    mainInfo.setVersion("1");
                    this.baseMapper.insert(mainInfo);
                }
            }
        }
    }
}
